 import  java.awt.*;
 import  java.awt.event.*;
 import  javax.swing.*;
  class AmCanvas extends JPanel
   {
   static final int hd = 10;
   static final int vd = 10;
   AmFrame frame;
   AmCanvasScrollbar sbv, sbh;
   Point start;
   Selection selection;
   boolean caretToScreen;
   boolean mouseDragged;
   boolean justActivated;
   boolean own;
   int X; int Y; int W; int H;
    AmCanvas(AmFrame fr)
     {
     frame = fr;
     start = new Point(0, 0);
     selection = null;
     caretToScreen = true;
     setBackground(Default.backgroundColor);
     setForeground(Default.foregroundColor);
     addMouseListener(new AmMouseListener(this));
     addMouseMotionListener(new AmMouseMovementListener(this));
     addKeyListener(new AmKeyListener(this));
     justActivated = false;
     own = false;
     }
    public void paint(Graphics g)
     {
     super.paintComponent(g);
     int canvh = getSize().height;
     int canvw = getSize().width;
       {
       if(
       (justActivated)
       ){
         {
         if(
         true//Am.isWindows
         ){
         requestFocus();
         g.setClip(0, 0 , canvw, canvh);
         }
         }
       g.setColor(Default.backgroundColor);
       g.fillRect(0, 0 , canvw, canvh);
       justActivated = false;
       }
       }
     g.setColor(Color.green);
     g.drawRect(0, 0 , canvw-1, canvh-1);
      L0:
       {
         {
         if(
         (frame.contents != null)
         ){
         g.translate(start.x, start.y);
         frame.contents.editor.caret.drawx(g);
         frame.contents.draw(g);
         frame.contents.affected = frame.contents.main;
           {
           if(
           (selection.kind() != Selection.NONE)
           ){
           selection.drawx(g);
           }
           }
           {
           if(
           (!own)
           ){
           frame.contents.main.invalidate(-start.y, getSize().height-start.y);
           }
           }
         int vis_am = 100;
         int value = 0;
         int yy = frame.contents.main.view.height + vd;
           {
           if(
            (canvh < yy)
           ){
           vis_am = (int)( ((float)canvh/(float)yy)*100);
           value =  (int)( ((float)(-start.y)/(float)yy)*100);
           }
           }
         sbv.setVisibleAmount(vis_am);
         sbv.setValue(value);
         vis_am = 100;
         value = 0;
         int xx = frame.contents.main.view.width + hd;
           {
           if(
            (canvw < xx)
           ){
           vis_am = (int)( ((float)canvw/(float)xx)*100);
           value =  (int)( ((float)(-start.x)/(float)xx)*100);
           }
           }
         sbh.setVisibleAmount(vis_am);
         sbh.setValue(value);
         break L0;
         }
         }
       g.setColor(Default.backgroundColor);
       g.fillRect(1, 1 , canvw-2, canvh-2);
       }
     own = false;
     }
    public boolean caretToScreen()
     {
     return(
     rectToScreen(frame.contents.editor.caret.row)
     );
     }
    private boolean rectToScreen(Rectangle p)
     {
     boolean res = false;
     int canvh = getSize().height;
     int canvw = getSize().width;
       {
       if(
       ((p.y + start.y) <= 0) ||
       ((p.y + p.height + start.y) >= canvh)
       ){
        L1:
         {
           {
           if(
           (p.y + start.y) <= 0
           ){
           res = true;
           start.y = canvh/2 - p.y;
             {
             if(
             start.y > 0
             ){
             start.y = 0;
             }
             }
           break L1;
           }
           }
         if(
         (p.y + p.height + start.y) >= canvh
         ){
         res = true;
         start.y = -p.y - p.height + canvh/2;
         }
         }
       }
       }
     return(
     res
     );
     }
    public void selectionToScreen()
     {
     if(
     selection.kind() != Selection.NONE
     ){
     Rectangle rk = selection.area();
     rk. height = 20;
     rectToScreen(rk);
     }
     }
    void prepare(int yy)
     {
     X = 0;
     Y = yy + start.y;
     W = getSize().width;
     H = getSize().height - Y;
     }
    void prepare(int yy, Scheme s)
     {
     X = 0;
     Y = yy + start.y;
     W = getSize().width;
     H = getSize().height - Y;
     s.invalidate(yy, yy + H);
     }
   }
