 import java.util.*;
 import java.awt.*;
  class BaseLanguageJava extends BaseLanguage
   {
    BaseLanguageJava()
     {
     type = JAVA;
     }
    byte nextPrimitiveHeadType(byte prev)
     {
     return(
     prev
     );
     }
   static AmFrame frame;
   static Vector labels;
    public  boolean sketchify(SketchyText skt0,
    SketchyText skt1,
    AmFrame dialogTargetFrame)
     {
     frame = dialogTargetFrame;
     Sketch sNew = skt1.main;
     sNew.baseLanguage = new BaseLanguageJava();
     sNew.branch(0).baseLanguage = new BaseLanguageJava();
     Sketch s = skt0.main;
     Branch br = s.branch(0);
     Branch br1 = sNew.branch(0);
     transferPrimitives(br, br1);
     comments(br1);
     colorLiterals(br1);
     joinElseIf(sNew);
      {try
       {
       braces2simple(br1);
       }
       catch
       (RuntimeException e)
       {
       AmDialog d = new AmDialog(frame,
       AmLocale.Source_syntax_error(),
       AmDialog.B_OK, "'}' " + AmLocale.missing());
       return(
       false
       );
       }
      }
     clean(sNew);
     docComments2simple(sNew);
     semicolons(sNew);
     keywords(sNew);
     extraBlocks(sNew);
     makeBlockHeads(sNew);
     controlSketches(sNew);
     extraControlSketches(sNew);
     controlSketches(sNew);
     labelTable(sNew);
     breaks(sNew);
     clean(sNew);
     joinHeads(sNew);
     setBranchHeadColor(sNew);
     openParenthInConditions(sNew);
     return(
     true
     );
     }
    static void transferPrimitives(Branch br, Branch br1)
     {
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       PrimitiveMember p = (PrimitiveMember)(br.member(i));
       PrimitiveMember p1 = p.makeCopy();
       p1.text.trim();
       br1.insert(p1,i);
       }
     }
    private static void comments(Branch br)
     {
     endComments(br);
     blockComments(br);
     }
   static Cursor cursor1;
   static Cursor cursor2 = null;
   static boolean inString;
   static boolean inChar;
    private static void blockComments(Branch br)
     {
     cursor2 = null;
      for(
      ;gotoCommentStart(br);
      )
       {
       if(
       gotoCommentEnd(br)
       ){
       multiLineComment();
       }
       }
     }
    private static boolean gotoCommentStart(Branch br)
     {
     char prev, curr = ' ';
      L0:
       {
         {
         if(
         cursor2 == null
         ){
         cursor1 = new Cursor(br);
         cursor1.moveToBody();
         break L0;
         }
         }
       cursor1 = cursor2.makeCopy();
       }
      L3:
      for(
      ;;
      )
       {
       inString = false;
       inChar = false;
        L2:
        for(
        ;cursor1.scanRow();
        )
         {
         Symbol sy = cursor1.row.sy;
         prev = curr;
         curr = sy.c;
           {
           if(
           (!inString) && (!inChar)
           ){
             {
             if(
             (prev == '/') && (curr == '*')
             ){
             cursor1.text.splitRow(cursor1.rowNo(), cursor1.noInRow-2);
             cursor1.primitive.split(br, 1);
             cursor1.moveToNextElement();
             return(
             true
             );
             }
             }
            L1:
             {
               {
               if(
               curr == '"'
               ){
               inString = true;
               break L1;
               }
               }
             if(
             curr == '\''
             ){
             inChar = true;
             }
             }
           continue L2;
           }
           }
           {
           if(
           inString && (curr == '"') && (prev != '\\')
           ){
           inString = false;
           continue L2;
           }
           }
         if(
         (curr == '\'') && (prev != '\\') 
         ){
         inChar = false;
         }
         }
         {
         if(
         !cursor1.moveToNextElement()
         ){
         break L3;
         }
         }
       curr = ' ';
       }
     return(
     false
     );
     }
    private static boolean gotoCommentEnd(Branch br)
     {
     cursor2 = cursor1.makeCopy();
     char prev, curr = ' ';
      L4:
      for(
      ;;
      )
       {
        for(
        ;cursor2.scanRow();
        )
         {
         Symbol sy = cursor2.row.sy;
         prev = curr;
         curr = sy.c;
         if(
         (prev == '*') && (curr == '/')
         ){
         cursor2.text.splitRow(cursor2.rowNo(), cursor2.noInRow);
         cursor2.primitive.split(br, 1);
         return(
         true
         );
         }
         }
         {
         if(
         !cursor2.moveToNextElement()
         ){
         break L4;
         }
         }
       curr = ' ';
       }
     return(
     false
     );
     }
    private static void multiLineComment()
     {
      L5:
      for(
      ;;
      )
       {
       Row comm = cursor1.text.comment;
       Row r = cursor1.row;
        for(
         int i = 1; i < r.elements.size(); i++
        )
         {
         r.getElement(i);
         comm.insert(new Symbol(
         r.sy.c, r.sy.font, Default.commentColor), i);
         }
       comm.planSize();
       r.removeAll();
       r.planSize();
         {
         if(
         cursor1.row == cursor2.row
         ){
         break L5;
         }
         }
       cursor1.moveToNextElement();
       }
     }
    private static void docComments2simple(Sketch s)
     {
     int istart, iend;
     Selection selection = new Selection(null, null);
     PrimitiveMember p;
     Branch br = (Branch)(s.member(0));
      L6:
      for(
      int i=0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof Sketch
         ){
         docComments2simple((Sketch)o);
         continue L6;
         }
         }
       p = (PrimitiveMember)o;
       String t1 = p.text.comment.toString();
       if(
       t1.trim().startsWith("/**")
       ){
       selection.start = new Cursor(br, p);
       istart = i;
         {
         if(
         t1.indexOf("/**") == 0
         ){
         p.text.comment.remove(1);
         p.text.comment.remove(1);
         p.text.comment.remove(1);
         p.text.comment.planSize();
         }
         }
       i--;
        L7:
        for(
        ;;
        )
         {
         i++;
         p = (PrimitiveMember)(br.member(i));
         String t2 = p.text.comment.toString();
           {
           if(
           t2.indexOf("*/") >= 0
           ){
           selection.end = new Cursor(br, p);
           iend = i;
           int d1=1; int d2 = 1;
             {
             if(
             t1.length() > 3
             ){
             d1 = 0;
             }
             }
             {
             if(
             t2.length() > 2
             ){
             d2 = 0;
             int l = p.text.comment.elements.size()-1;
             p.text.comment.remove(l);
             p.text.comment.remove(l-1);
             p.text.comment.planSize();
             }
             }
           Sketch newMember =
           selection.convert2simple(d1, d2, new BaseLanguageJava());
           newMember.comment =
           new Row("Javadoc", Default.commentColor);
           newMember.icon = true;
           newMember.type = Scheme.MODULE;
           i -= iend - istart;
           break L7;
           }
           }
         }
       }
       }
     }
    private static void endComments(Branch br)
     {
     boolean inEndComment;
     char prev, curr;
     cursor1 = new Cursor(br);
     cursor1.moveToBody();
      for(
      ;;
      )
       {
       inString = false;
       inChar = false;
       inEndComment = false;
       curr  = ' ';
       int ic = 0;
        L8:
        for(
        ;cursor1.scanRow();
        )
         {
         Symbol sy = cursor1.row.sy;
         prev = curr;
         curr = sy.c;
           {
           if(
           (!inString) && (!inChar)
           ){
             {
             if(
             (prev == '/') && (curr == '/')
             ){
             inEndComment = true;
             cursor1.moveLeft();
             cursor1.moveLeft();
             break L8;
             }
             }
            L9:
             {
               {
               if(
               curr == '"'
               ){
               inString = true;
               break L9;
               }
               }
             if(
             curr == '\''
             ){
             inChar = true;
             }
             }
           continue L8;
           }
           }
           {
           if(
           inString && (curr == '"') && (prev != '\\')
           ){
           inString = false;
           continue L8;
           }
           }
         if(
         (curr == '\'') && (prev != '\\') 
         ){
         inChar = false;
         }
         }
         {
         if(
         inEndComment
         ){
         cursor1.row.remove(cursor1.noInRow);
         cursor1.row.remove(cursor1.noInRow);
          for(
          ;cursor1.scanRow();
          )
           {
           Symbol sy = cursor1.row.sy;
           cursor1.text.comment.insert(sy, ++ic);
           sy.color = Default.commentColor;
           cursor1.moveLeft();
           cursor1.row.remove(cursor1.noInRow);
           }
         cursor1.row.planSize();
         cursor1.text.comment.planSize();
         }
         }
       if(
       !cursor1.moveToNextElement()
       ){
       break;
       }
       }
     }
    static void clean(Sketch s)
     {
     Branch br = s.branch(0);
      L10:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof Sketch
         ){
         clean((Sketch)o);
         continue L10;
         }
         }
       PrimitiveMember p = (PrimitiveMember)o;
       if(
       p.type == Primitive.SIMPLE
       ){
       p.text.trim();
       if(
       p.text.row(0).elements.size() == 1
       ){
       if(
       p.text.comment.elements.size() == 1
       ){
       br.removeMember(i);
       i--;
       }
       }
       }
       }
     }
    static void joinElseIf(Sketch s)
     {
     Branch br = s.branch(0);
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
       PrimitiveMember p = (PrimitiveMember)o;
       normElseIf(p);
       String t = p.text.toString(Default.literalColor).trim();
       PrimitiveMember pp = null;
       int k= -1;
        L12:
         {
         if(
         t.equals("else")||t.endsWith(" else")||t.endsWith(";else")||
         t.endsWith("\telse")||t.endsWith("}else")
         ){
          L11:
          for(
          int j = i+1; j < br.body.size(); j++
          )
           {
           o = br.member(j);
           pp = (PrimitiveMember)o;
           t = pp.text.toString(Default.literalColor).trim();
             {
             if(
             t.length() == 0
             ){
             continue L11;
             }
             }
             {
             if(
             t.equals("if")||t.startsWith("if ")||
             t.startsWith("if\t")||t.startsWith("if(")
             ){
             k = j;
             }
             }
           break;
           }
           {
           if(
           k == -1
           ){
           break L12;
           }
           }
         Row r = p.text.row(0);
         Row rr = pp.text.row(0);
         r.trim();  
         rr.trim();
         rr.insert(new Symbol(' ', Default.foregroundColor),1);
         p.text.insert(rr, 1);
         p.text.joinRow(1);
         br.removeMember(k);
         i--;
         }
         }
       }
     }
    private static void normElseIf(Primitive p)
     {
     boolean ridaMuudetud = true;
      for(
      ;ridaMuudetud;
      )
       {
       ridaMuudetud = false;
       Row prida = p.text.row(0);
       String rida = prida.toString();
       StringTokenizer st = new StringTokenizer(rida, " \t(;",true);
       String token = "";
       int i = 0;
       int iElse = 0;
       int iIf = 0;
       boolean elseFound = false;
        L14:
        for(
        ;st.hasMoreTokens();
        )
         {
         token = st.nextToken();
          L13:
           {
             {
             if(
             !elseFound
             ){
               {
               prida.getElement(i+1);
               if(
               token.equals("else")  
               ){
               if(
               prida.sy.color != Default.literalColor
               ){
               iElse = i;
               elseFound = true;
               }
               }
               }
             break L13;
             }
             }
             {
             prida.getElement(i+1);
             if(
             token.equals("if")  
             ){
             if(
             prida.sy.color != Default.literalColor
             ){
             iIf = i;
             String vahe = rida.substring(iElse+4, iIf);
               {
               if(
               vahe.trim().length() == 0
               ){
               if(
               vahe.length() > 1
               ){
               prida.getElement(iElse+4+1);
               prida.sy.c = ' ';
                for(
                int j = iElse+5+1; j < (iIf+1); j++
                )
                 {
                 prida.remove(iElse+5);
                 }
               ridaMuudetud = true;
               break L14;
               }
               }
               }
             }
             }
             }
           }
         i += token.length();
         }
       }
     }
    private  static void braces2simple (Branch br)
     {
     Cursor cursor = new Cursor(br);
     cursor.moveToBody();
     char prev, curr = ' ';
     int balance = 0;
      L16:
      for(
      ;;
      )
       {
        for(
        ;cursor.scanRow();
        )
         {
         Symbol sy = cursor.row.sy;
         prev = curr;
         curr = sy.c;
         if(
         sy.color != Default.literalColor
         ){
           {
           if(
           balance != 0
           ){
           sy.color = Default.literalColor;
           }
           }
           {
           if(
           (balance == 0)&&
           
           ((sy.c == '{') || (sy.c == '}'))
           ){
           cursor.text.splitRow(cursor.rowNo(), cursor.noInRow-1);
           cursor.moveDown();
           cursor.text.splitRow(cursor.rowNo(), 2);
           cursor.moveDown();
           cursor.primitive.split(br,2);
           cursor.primitive.split(br,1);
           cursor.moveToNextElement();
           cursor.moveToNextElement();
           }
           }
          L15:
           {
             {
             if(
             curr == '('
             ){
             balance++;
             break L15;
             }
             }
           if(
           curr == ')'
           ){
           balance--;
           if(
           balance == 0
           ){
           sy.color = Default.foregroundColor;
           }
           }
           }
         }
         }
         {
         if(
         !cursor.moveToNextElement()
         ){
         break L16;
         }
         }
       curr = ' ';
       }
     braces2sk(br);
     }
   static Selection selection = new Selection(null, null);
    static void braces2sk(Branch s)
     {
      L17:
      for(
       ;findStartBrace(s);
      )
       {
       findEndBrace(s);
       Sketch newMember = selection.convert2simple(new BaseLanguageJava());
         {
         if(
         newMember != null
         ){
         newMember.comment = new Row("..block", Default.commentColor);
         braces2sk((Branch)(newMember.member(0)));
         continue L17;
         }
         }
       selection.start.primitive.text =
       new Text();
       selection.start.primitive.text.row(0).insert(
       new Symbol('{'), 1);
       selection.start.primitive.text.row(0).planSize();
       selection.start.primitive.text.comment =
       new Row(" *** NOT CLOSED! ***", Default.conditionColor);
       throw new RuntimeException("Closing brace not found!");
       }
     }
    static boolean findStartBrace(Branch s)
     {
      for(
      int i=0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
         o instanceof PrimitiveMember
         ){
         PrimitiveMember p = (PrimitiveMember)o;
         Row r = p.text.row(0);
         if(
         r.elements.size() > 1
         ){
         r.getElement(1);
         char c = r.sy.c;
         if(
         (c == '{')&&(r.sy.color != Default.literalColor)
         ){
         selection.start = new Cursor(s, p);
         r.remove(1);
         r.planSize();
         return(
         true
         );
         }
         }
         }
         }
       }
     return(
     false
     );
     }
    static boolean findEndBrace(Branch s)
     {
     int count = 1;
      for(
      int i=0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
       if(
       o instanceof PrimitiveMember
       ){
       PrimitiveMember p = (PrimitiveMember)o;
       Row r = p.text.row(0);
       if(
       r.elements.size() > 1
       ){
       r.getElement(1);
       char c = r.sy.c;
        L18:
         {
           {
           if(
           (c == '{')&&(r.sy.color != Default.literalColor)
           ){
           count++;
           break L18;
           }
           }
         if(
         (c == '}')&&(r.sy.color != Default.literalColor)
         ){
         count--;
         if(
         count == 0
         ){
         selection.end = new Cursor(s, p);
         r.remove(1);
         r.planSize();
         return(
         true
         );
         }
         }
         }
       }
       }
       }
     return(
     false
     );
     }
   static boolean isControlSketch;
   static boolean isClassSketch;
   static boolean isMethodSketch;
    private static void makeBlockHeads(Sketch s)
     {
     Sketch block;
      for(
      ;;
      )
       {
       block = findBlock(s);
         {
         if(
         block == null
         ){
         return;
         }
         }
       makeHead(s, block);
       makeBlockHeads(block);
       }
     }
    private static Sketch findBlock(Sketch s)
     {
     Branch br = (Branch)(s.member(0));
      for(
      int i=0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof Sketch
         ){
         Sketch member = (Sketch)o;
         if(
         member.comment.toString().compareTo("..block")==0
         ){
         return(
         member
         );
         }
         }
         }
       }
     return(
     null
     );
     }
    private static void makeHead(Sketch parent, Sketch block)
     {
     String komm = new String();
     String w = new String();
     String wprev = new String("x");
     isControlSketch = false;
     isClassSketch = false;
     isMethodSketch = false;
     PrimitiveMember p = null;
     Selection selection = new Selection(null, null);
     Branch br = (Branch)(parent.member(0));
     int ind;
      for(
       ind = 0; ind < br.body.size(); ind++
      )
       {
       Object o = br.body.elementAt(ind);
       if(
       o instanceof Sketch
       ){
       if(
       (Sketch)o == block
       ){
       break;
       }
       }
       }
     int i = ind;
     String keyword = findHeadGroup(br, i, selection);
       {
       if(
       selection.kind() == Selection.NONE
       ){
       block.comment = new Row("non-control", Default.commentColor);
       return;
       }
       }
      L19:
       {
         {
         if(
         keyword.compareTo("class")==0
         ){
         StringTokenizer st =
         new StringTokenizer(selection.toString(Default.literalColor));
          for(
          ;;
          )
           {
           w = st.nextToken();
           if(
           w.compareTo("class") == 0
           ){
           break;
           }
           }
         komm = "class " + st.nextToken();
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.SIMPLE);
         block.type = Scheme.MODULE;
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("interface")==0
         ){
         StringTokenizer st =
         new StringTokenizer(selection.toString(Default.literalColor));
          for(
          ;;
          )
           {
           w = st.nextToken();
           if(
           w.compareTo("interface") == 0
           ){
           break;
           }
           }
         komm = "interface " + st.nextToken();
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.SIMPLE);
         block.type = Scheme.MODULE;
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("for")==0
         ){
         komm = "for";
         block.comment = new Row(komm, Default.commentColor);
         block.type = Sketch.LOOP;
         selection.convert2head(PrimitiveHead.LOOP);
           {
           if(
           block.head.size() == 2
           ){
           Text t1 = block.primitiveHead(1).text;
           if(
           t1.rows.size() == 1
           ){
           Row r1 = t1.row(0);
           if(
           r1.elements.size() == 2
           ){
           r1.getElement(1);
           if(
           r1.sy.c == ')'
           ){
           Text t0 = block.primitiveHead(0).text;
           Row r0 = t0.row(0);
           r0.insert
           ((Symbol)(r1.element(1)), r0.elements.size());
           block.removePrimitiveHead(1);
           }
           }
           }
           }
           }
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
         r.getElement(1);
           {
           if(
           r.sy.c == 'f'
           ){
            for(
            int k = 0; k < 3; k++
            )
             {
             r.remove(1);
             }
           r.planSize();
           }
           }
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("while")==0
         ){
         komm = "while";
         block.comment = new Row(komm, Default.commentColor);
         block.type = Sketch.LOOP;
         selection.convert2head(PrimitiveHead.LOOP);
         Text t = (block.primitiveHead(0)).text;
         Row r = t.row(0);
         r.getElement(1);
           {
           if(
           r.sy.c == 'w'
           ){
            for(
            int k = 0; k < 5; k++
            )
             {
             r.remove(1);
             }
           r.planSize();
           }
           }
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("do")==0
         ){
         komm = "do";
         block.comment = new Row(komm, Default.commentColor);
         block.type = Sketch.LOOP;
         selection.convert2head(PrimitiveHead.LOOP);
         block.head.removeAllElements();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("if")==0
         ){
         komm = "if";
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.SIMPLE);
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
          for(
          int k = 0; k < 2; k++
          )
           {
           r.remove(1);
           }
         r.planSize();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("else")==0
         ){
         komm = "else";
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.SIMPLE);
         block.head.removeAllElements();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("elseif")==0
         ){
         komm = "elseif";
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.SIMPLE);
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
          for(
          int k = 0; k < 7; k++
          )
           {
           r.remove(1);
           }
         r.planSize();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("switch")==0
         ){
         komm = "switch";
         block.comment = new Row(komm, Default.commentColor);
         block.type = Sketch.SIMPLE;
         selection.convert2head(PrimitiveHead.SWITCH);
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
          for(
          int k = 0; k < 6; k++
          )
           {
           r.remove(1);
           }
         r.planSize();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("case")==0
         ){
         komm = "case";
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.CASE);
          L20:
          for(
          int hi = 0; hi < block.head.size(); hi++
          )
           {
           Text t = block.primitiveHead(hi).text;
             {
             if(
             t.rows.size() == 0
             ){
             continue L20;
             }
             }
           Row r = t.row(0);
           int l = r.elements.size();
             {
             if(
             l == 1
             ){
             continue L20;
             }
             }
            L21:
            for(
            int m = 0; m < l; l++
            )
             {
             r.getElement(1);
               {
               if(
               r.sy.c == ' '
               ){
               r.remove(1);
               continue L21;
               }
               }
               {
               if(
               r.sy.c == 'c'
               ){
                for(
                int k = 0; k < 4; k++
                )
                 {
                 r.remove(1);
                 }
               }
               }
             break;
             }
           r.planSize();
           }
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("default")==0
         ){
         komm = "default";
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.CASE);
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
          for(
          int k = 0; k < 7; k++
          )
           {
           r.remove(1);
           }
         r.planSize();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("try")==0
         ){
         komm = "try";
         block.comment = new Row(komm, Default.commentColor);
         block.type = Sketch.SIMPLE;
         selection.convert2head(PrimitiveHead.TRY);
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
          for(
          int k = 0; k < 3; k++
          )
           {
           r.remove(1);
           }
         r.planSize();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("catch")==0
         ){
         komm = "catch";
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.CASE);
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
          for(
          int k = 0; k < 5; k++
          )
           {
           r.remove(1);
           }
         r.planSize();
         break L19;
         }
         }
         {
         if(
         keyword.compareTo("finally")==0
         ){
         komm = "finally";
         block.comment = new Row(komm, Default.commentColor);
         selection.convert2head(PrimitiveHead.CASE);
         Text t = block.primitiveHead(0).text;
         Row r = t.row(0);
          for(
          int k = 0; k < 7; k++
          )
           {
           r.remove(1);
           }
         r.planSize();
         break L19;
         }
         }
       StringTokenizer st =
       new StringTokenizer(selection.toString(Default.literalColor)," \t(", true);
       String prev = "";
       String curr = "";
        for(
        ;st.hasMoreTokens();
        )
         {
           {
           if(
           (curr.compareTo(" ") != 0)&&curr.compareTo("\t")!=0
           ){
           prev = curr;
           }
           }
         curr = st.nextToken();
         if(
         curr.compareTo("(") == 0
         ){
         break;
         }
         }
         {
         if(
         curr.compareTo("(") == 0
         ){
         selection.convert2head(PrimitiveHead.SIMPLE);
         komm = new String(prev);
          L22:
           {
             {
             if(
             komm.compareTo("synchronized") == 0
             ){
             block.comment = new Row("non-control", Default.commentColor);
             break L22;
             }
             }
           block.comment = new Row(komm, Default.commentColor);
           block.type = Scheme.MODULE;
           }
         break L19;
         }
         }
       block.comment = new Row("non-control", Default.commentColor);
       }
     }
    private static String findHeadGroup(Branch parent, int i, Selection sel)
     {
     String keywords =
     " interface class for while do if then else switch case default try catch finally ";
     String keyword = "";
     int balance = 0;
     int prevbalance = 0;
     int gr_start = 0, gr_end = -1;
     ALL:
      L23:
       {
         {
         if(
         i == 0
         ){
         break L23;
         }
         }
       gr_end = i-1;
        L25:
        for(
        int j = i-1;;j--
        )
         {
           {
           if(
           j == -1
           ){
           gr_start = j+1;
           break L23;
           }
           }
         Object o = parent.member(j);
           {
           if(
           o instanceof Sketch
           ){
           gr_start = j+1;
           break L23;
           }
           }
         PrimitiveMember p=  (PrimitiveMember)o;
         Row r = p.text.row(0);
           {
           if(
           r.elements.size() == 2
           ){
           r.getElement(1);
           if(
           r.sy.c == ' '
           ){
           gr_start = j+1;
           break L23;
           }
           }
           }
         StringTokenizer st1 =
         new StringTokenizer(r.toString(Default.literalColor),"()",true);
         prevbalance = balance;
          L24:
          for(
          ;st1.hasMoreTokens();
          )
           {
           String t = st1.nextToken();
             {
             if(
             t.compareTo("(")==0
             ){
             balance++;
             continue L24;
             }
             }
           if(
           t.compareTo(")")==0
           ){
           balance--;
           }
           }
         r.getElement(r.elements.size()-1);
           {
           if(
           r.sy.c == ';'
           ){
           if(
           prevbalance == 0
           ){
           gr_start = j+1;
           break L23;
           }
           }
           }
           {
           if(
           keyword.length() > 0
           ){
             {
               {
               if(
               (keyword.compareTo("class") != 0)
               &&
               (keyword.compareTo("interface") != 0) &&
               (keyword.compareTo("case") != 0) &&
               (keyword.compareTo("default") != 0)
               
               ){
               gr_start = j+1;
               break L23;
               }
               }
             continue L25;
             }
           }
           }
         StringTokenizer st =
         new StringTokenizer(r.toString(Default.literalColor),": (\t");
         String w = "";
         String prevw = "";
         String prevkeyword = "";
          for(
          ; st.hasMoreTokens(); 
          )
           {
           prevw = w;
           w = st.nextToken();
           if(
           keywords.indexOf(" "+w+" ") > -1
           ){
           keyword = w;
           prevkeyword = prevw;
           }
           }
         if(
         (keyword.compareTo("if")==0) && (prevkeyword.compareTo("else")==0)
         ){
         keyword = "elseif";
         }
         }
       }
     selection.start = null;
     selection.end = null;
       {
       if(
       gr_start <= gr_end
       ){
       sel.start =
       new Cursor(parent, (PrimitiveMember)parent.member(gr_start));
       sel.end =
       new Cursor(parent, (PrimitiveMember)parent.member(gr_end));
       }
       }
     return(
     keyword
     );
     }
    private static void colorLiterals(Branch br)
     {
     char prev, curr = ' ';
     cursor1 = new Cursor(br);
     cursor1.moveToBody();
      L28:
      for(
      ;;
      )
       {
       inString = false;
       inChar = false;
        L27:
        for(
        ;cursor1.scanRow();
        )
         {
         Symbol sy = cursor1.row.sy;
         prev = curr;
         curr = sy.c;
           {
           if(
           (!inString) && (!inChar)
           ){
            L26:
             {
               {
               if(
               curr == '"'
               ){
               sy.color = Default.literalColor;
               inString = true;
               break L26;
               }
               }
             if(
             curr == '\''
             ){
             sy.color = Default.literalColor;
             inChar = true;
             }
             }
           continue L27;
           }
           }
         sy.color = Default.literalColor;
           {
           if(
           inString && (curr == '"') && (prev != '\\')
           ){
           inString = false;
           continue L27;
           }
           }
           {
           if(
           (curr == '\\') && (prev == '\\')
           ){
           curr = 'x';
           continue L27;
           }
           }
         if(
         (curr == '\'') && (prev != '\\') 
         ){
         inChar = false;
         }
         }
         {
         if(
         !cursor1.moveToNextElement()
         ){
         break L28;
         }
         }
       curr = ' ';
       }
     }
    public static void semicolons(Sketch s)
     {
     Cursor cursor;
     int iSemicolon;
     PrimitiveMember p;
     Branch br = (Branch)(s.member(0));
      L29:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof Sketch
         ){
         semicolons((Sketch)o);
         continue L29;
         }
         }
       p = (PrimitiveMember)o;
       cursor = new Cursor(br, p);
         {
         if(
         cursor.row.elements.size() == 1
         ){
         continue L29;
         }
         }
       iSemicolon = -1;
        L30:
        for(
        ;cursor.scanRow();
        )
         {
         Symbol sy = cursor.row.sy;
           {
           if(
           sy.color != Default.literalColor
           ){
             {
             if(
             (sy.c == ';') || (sy.c == ':')
             ){
             iSemicolon = cursor.noInRow-1;
             }
             }
           if(
           sy.c == ':'
           ){
           break L30;
           }
           }
           }
         }
       if(
       (iSemicolon >= 0)&&
       (iSemicolon != cursor.row.elements.size()-1)
       ){
       cursor.text.splitRow(0, iSemicolon+1);
       p.split(br, 1);
       }
       }
     }
    public static void keywords(Sketch s)
     {
     String keyWords =
     " if else while for do break continue return ";
     int ikeyword;
     PrimitiveMember p;
     Branch br = (Branch)(s.member(0));
      L31:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof Sketch
         ){
         keywords((Sketch)o);
         continue L31;
         }
         }
       p = (PrimitiveMember)o;
       Row r = (Row)(p.text.row(0));
         {
         if(
         r.elements.size() == 1
         ){
         continue L31;
         }
         }
       String t = r.toString();
       StringTokenizer st = new StringTokenizer(t, " \t;()", true);
       int iToken = 1;
       ikeyword = -1;
        L32:
        for(
        ;st.hasMoreTokens();
        )
         {
         String token = st.nextToken();
           {
           if(
           keyWords.indexOf(" "+token+" ") >= 0
           ){
           r.getElement(iToken);
           Symbol sy = r.sy;
           if(
           sy.color != Default.literalColor
           ){
             {
             if(
             (token.compareTo("if") == 0)
             && (t.indexOf("else ") == 0)
             
             ){
             iToken += token.length();
             continue L32;
             }
             }
           if(
           iToken > 1
           ){
           ikeyword = iToken;
           break L32;
           }
           }
           }
           }
         iToken += token.length();
         }
       if(
       ikeyword > 0
       ){
       p.text.splitRow(0, ikeyword);
       Row rr = (Row)(p.text.row(0));
       int n = rr.elements.size();
        L33:
        for(
        ;;
        )
         {
         rr.getElement(n-1);
           {
           if(
           rr.sy.c != ' '
           ){
           break L33;
           }
           }
         rr.remove(--n);
         }
       rr.planSize();
       p.split(br, 1);
       }
       }
     }
    public static void controlSketches(Sketch s)
     {
      for(
      int brnr = 0; brnr < s.body.size(); brnr++
      )
       {
       Branch br = (Branch)(s.body.elementAt(brnr));
       Sketch sk;
       String sss =  s.comment.toString();
        L36:
         {
           {
           if(
           s.comment.toString().compareTo("if") == 0
           ){
           s.comment = new Row("..if", Default.commentColor);
           PrimitiveMember newns = new PrimitiveMember(Primitive.CONDITION,
           new Text());
           newns.text.rows.removeElementAt(0);
            for(
             int i = 0; i < s.head.size(); i++
            )
             {
             PrimitiveHead h = s.primitiveHead(i);
             newns.text.insert(h.text.row(0), i);
             }
           s.head.removeAllElements();
           br.insert(newns, 0);
           newns.text.setColor(Default.conditionColor);
           int j = s.parent.body.indexOf(s) + 1;
            L34:
            for(
            ;;
            )
             {
               {
               if(
               j >= s.parent.body.size()
               ){
               break L34;
               }
               }
             Object o = s.parent.body.elementAt(j);
               {
               if(
               o instanceof PrimitiveMember
               ){
               PrimitiveMember ns = (PrimitiveMember)o;
                 {
                   {
                   if(
                   !ns.text.isTrivial()
                   ){
                   break L34;
                   }
                   }
                 j++;
                 continue L34;
                 }
               }
               }
             Sketch ske = (Sketch)o;
             String t = ske.comment.toString();
               {
               if(
               t.indexOf("else") == 0
               ){
               br.body.addElement(new Arrow(Arrow.STRONG, s.level()));
                 {
                 if(
                 ske.head.size() > 0
                 ){
                 newns = new PrimitiveMember(Primitive.CONDITION,
                 new Text());
                 newns.text.rows.removeElementAt(0);
                 int m = 0;
                  for(
                  Enumeration e = ske.head.elements(); e.hasMoreElements();
                  )
                   {
                   PrimitiveHead h = ( PrimitiveHead)(e.nextElement());
                   newns.text.insert((Row)(h.text.rows.elementAt(0)),
                   m++);
                   }
                 br.body.addElement(newns);
                 newns.text.setColor(Default.conditionColor);
                 }
                 }
               Branch skeBr = (Branch)(ske.body.elementAt(0));
                L35:
                for(
                Enumeration e = skeBr.body.elements(); e.hasMoreElements();
                )
                 {
                 o = e.nextElement();
                   {
                   if(
                   o instanceof Sketch
                   ){
                   Sketch skk = (Sketch)o;
                   br.body.addElement(skk);
                   skk.parent = br;
                   continue L35;
                   }
                   }
                 PrimitiveMember skk = (PrimitiveMember)o;
                 br.body.addElement(skk);
                 }
               s.parent.removeMember(j);
               continue L34;
               }
               }
             break;
             }
           break L36;
           }
           }
           {
           if(
           s.comment.toString().compareTo("..if") == 0
           ){
           int j = s.parent.body.indexOf(s) + 1;
            L37:
            for(
            ;;
            )
             {
               {
               if(
               j >= s.parent.body.size()
               ){
               break L37;
               }
               }
             Object o = s.parent.body.elementAt(j);
               {
               if(
               o instanceof PrimitiveMember
               ){
               PrimitiveMember ns = (PrimitiveMember)o;
                 {
                   {
                   if(
                   !ns.text.isTrivial()
                   ){
                   break L37;
                   }
                   }
                 j++;
                 continue L37;
                 }
               }
               }
             Sketch ske = (Sketch)o;
             String t = ske.comment.toString();
               {
               if(
               t.indexOf("else") == 0
               ){
               br.body.addElement(new Arrow(Arrow.STRONG, s.level()));
                 {
                 if(
                 ske.head.size() > 0
                 ){
                 PrimitiveMember newns = new PrimitiveMember(Primitive.CONDITION,
                 new Text());
                 newns.text.rows.removeElementAt(0);
                 int m = 0;
                  for(
                  Enumeration e = ske.head.elements(); e.hasMoreElements();
                  )
                   {
                   PrimitiveHead h = ( PrimitiveHead)(e.nextElement());
                   newns.text.insert((Row)(h.text.rows.elementAt(0)),
                   m++);
                   }
                 br.body.addElement(newns);
                 newns.text.setColor(Default.conditionColor);
                 }
                 }
               Branch skeBr = (Branch)(ske.body.elementAt(0));
                L38:
                for(
                Enumeration e = skeBr.body.elements(); e.hasMoreElements();
                )
                 {
                 o = e.nextElement();
                   {
                   if(
                   o instanceof Sketch
                   ){
                   Sketch skk = (Sketch)o;
                   br.body.addElement(skk);
                   skk.parent = br;
                   continue L38;
                   }
                   }
                 PrimitiveMember skk = (PrimitiveMember)o;
                 br.body.addElement(skk);
                 }
               s.parent.removeMember(j);
               continue L37;
               }
               }
             break;
             }
           break L36;
           }
           }
           {
           if(
           s.comment.toString().compareTo("try") == 0
           ){
           s.comment = new Row("..try", Default.commentColor);
           int i = s.parent.body.indexOf(s)+1;
            L39:
            for(
            ;i < s.parent.body.size();i++
            )
             {
             Object o = s.parent.body.elementAt(i);
             if(
             o instanceof Sketch
             ){
             sk = (Sketch)o;
               {
               if(
               (sk.comment.toString().compareTo("catch")!=0) &&
               (sk.comment.toString().compareTo("finally")!=0)
               ){
               break L39;
               }
               }
              L41:
               {
                 {
                 if(
                 sk.comment.toString().compareTo("catch")==0
                 ){
                 Branch newBr = new Branch(Scheme.SIMPLE,
                 new BaseLanguageJava());
                 newBr.parent = s;
                 newBr.comment = sk.comment;
                 Symbol sy = new Symbol('.',Default.commentColor);
                 newBr.comment.insert(sy, 1);
                 newBr.comment.insert(sy, 1);
                 newBr.comment.planSize();
                 newBr.head = sk.head;
                 newBr.primitiveHead(0).type = PrimitiveHead.CATCH;
                 Branch skBr = (Branch)(sk.body.elementAt(0));
                  L40:
                  for(
                  Enumeration e = skBr.body.elements();e.hasMoreElements();
                  )
                   {
                   o = e.nextElement();
                     {
                     if(
                     o instanceof Sketch
                     ){
                     ((Sketch)o).parent = newBr;
                     newBr.body.addElement((Sketch)o);
                     continue L40;
                     }
                     }
                   newBr.body.addElement((PrimitiveMember)o);
                   }
                 s.body.addElement(newBr);
                 s.parent.body.removeElementAt(i);
                 i--;
                 break L41;
                 }
                 }
               if(
               sk.comment.toString().compareTo("finally")==0
               ){
               Branch newBr = new Branch(Scheme.SIMPLE,
               new BaseLanguageJava());
               newBr.parent = s;
               newBr.comment = sk.comment;
               Symbol sy = new Symbol('.',Default.commentColor);
               newBr.comment.insert(sy, 1);
               newBr.comment.insert(sy, 1);
               newBr.comment.planSize();
               newBr.head = sk.head;
               newBr.primitiveHead(0).type = PrimitiveHead.FINALLY;
               Branch skBr = (Branch)(sk.body.elementAt(0));
                L42:
                for(
                Enumeration e = skBr.body.elements();e.hasMoreElements();
                )
                 {
                 o = e.nextElement();
                   {
                   if(
                   o instanceof Sketch
                   ){
                   ((Sketch)o).parent = newBr;
                   newBr.body.addElement((Sketch)o);
                   continue L42;
                   }
                   }
                 newBr.body.addElement((PrimitiveMember)o);
                 }
               s.body.addElement(newBr);
               s.parent.body.removeElementAt(i);
               i--;
               }
               }
             }
             }
           break L36;
           }
           }
           {
           if(
           s.comment.toString().compareTo("do") == 0
           ){
           s.comment = new Row("..do", Default.commentColor);
           break L36;
           }
           }
           {
           if(
           s.comment.toString().compareTo("..do") == 0
           ){
           int i = s.parent.body.indexOf(s)+1;
            L43:
            for(
            ;i < s.parent.body.size();i++
            )
             {
             Object o = s.parent.body.elementAt(i);
               {
               if(
               o instanceof Sketch
               ){
               sk = (Sketch)o;
                 {
                 if(
                 (sk.comment.toString().compareTo("while")==0) ||
                 (sk.comment.toString().compareTo("..while")==0)
                 ){
                 PrimitiveMember newns =
                 new PrimitiveMember(PrimitiveMember.CONDITION,
                 new Text());
                 newns.text.rows.removeElementAt(0);
                 int m = 0;
                  for(
                  Enumeration e = sk.head.elements(); e.hasMoreElements();
                  )
                   {
                   PrimitiveHead h = (PrimitiveHead)(e.nextElement());
                   newns.text.insert((Row)(h.text.rows.elementAt(0)), m++);
                   }
                 br.body.addElement(newns);
                 newns.text.setColor(Default.conditionColor);
                 s.parent.body.removeElementAt(i);
                 }
                 }
               break L43;
               }
               }
             }
           break L36;
           }
           }
           {
           if(
           s.comment.toString().compareTo("switch") == 0
           ){
           s.comment = new Row("..switch", Default.commentColor);
            for(
            int i=0; i < br.body.size(); i++
            )
             {
             Object o = br.body.elementAt(i);
             if(
             o instanceof Sketch
             ){
             sk = (Sketch)o;
             if(
             (sk.comment.toString().compareTo("case") == 0) ||
             (sk.comment.toString().compareTo("default") == 0)
             
             ){
             Branch newBr = new Branch(Scheme.SIMPLE,
             new BaseLanguageJava());
             newBr.parent = s;
             newBr.comment = sk.comment;
             Symbol sy = new Symbol('.',Default.commentColor);
             newBr.comment.insert(sy, 1);
             newBr.comment.insert(sy, 1);
             newBr.comment.planSize();
             newBr.head = sk.head;
             newBr.primitiveHead(0).type = PrimitiveHead.CASE;
             Branch skBr = (Branch)(sk.body.elementAt(0));
              L44:
              for(
              Enumeration e = skBr.body.elements();e.hasMoreElements();
              )
               {
               o = e.nextElement();
                 {
                 if(
                 o instanceof Sketch
                 ){
                 ((Sketch)o).parent = newBr;
                 newBr.body.addElement((Sketch)o);
                 continue L44;
                 }
                 }
               newBr.body.addElement((PrimitiveMember)o);
               }
             s.body.addElement(newBr);
             br.body.removeElementAt(i);
             i--;
             }
             }
             }
           br = (Branch)(s.body.elementAt(0));
             {
             if(
             s.body.size() > 1
             ){
             if(
             br.body.size() == 0
             ){
             s.body.removeElementAt(0);
             }
             }
             }
           break L36;
           }
           }
           {
           if(
           s.comment.toString().compareTo("for") == 0
           ){
           s.comment = new Row("..for", Default.commentColor);
           break L36;
           }
           }
         if(
         s.comment.toString().compareTo("while") == 0
         ){
         s.comment = new Row("..while", Default.commentColor);
         }
         }
        for(
        int i=0; i < br.body.size(); i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof Sketch
         ){
         controlSketches((Sketch)o);
         }
         }
       }
     }
    public static void extraControlSketches(Sketch s)
     {
     final String NONE = "";
     final String IF = "if";
     final String ELSEIF = "elseif";
     final String ELSE = "else";
     final String WHILE = "while";
     final String FOR = "for";
     final String BREAK = "break";
     final String CONTINUE = "continue";
     final String RETURN = "return";
     final String DO = "do";
     int gr_start = -1, gr_end = 0;
      for(
      int is = 0; is < s.body.size(); is++
      )
       {
       Branch br = (Branch)(s.body.elementAt(is));
       Sketch sk;
       Sketch newMember = null;
       String key;
        L45:
        for(
        int i=0; i < br.body.size(); i++
        )
         {
         Object o = br.body.elementAt(i);
           {
           if(
           o instanceof Sketch
           ){
           extraControlSketches((Sketch)o);
           continue L45;
           }
           }
         PrimitiveMember ns = (PrimitiveMember)o;
         String t = ns.text.toString(Default.literalColor);
         key = NONE;
          L46:
           {
             {
             if(
             t.equals("if")||t.startsWith("if ")||t.startsWith("if(")||t.startsWith("if\t")
             ){
             key = IF;
             break L46;
             }
             }
             {
             if(
             t.equals("else if")||t.startsWith("else if(")||t.startsWith("else if ")||t.startsWith("else if\t")
             ){
             key = ELSEIF;
             break L46;
             }
             }
             {
             if(
             t.equals("else")||t.startsWith("else;")||t.startsWith("else ")||t.startsWith("else\t")
             ){
             key = ELSE;
             break L46;
             }
             }
             {
             if(
             t.equals("while")||t.startsWith("while(")||t.startsWith("while ")||t.startsWith("while\t")
             ){
             key = WHILE;
             break L46;
             }
             }
             {
             if(
             t.equals("for")||t.startsWith("for ")||t.startsWith("for(")||t.startsWith("for\t")
             ){
             key = FOR;
             break L46;
             }
             }
             {
             if(
             t.equals("break")||t.startsWith("break;")||t.startsWith("break ")||t.startsWith("break\t")
             ){
             key = BREAK;
             break L46;
             }
             }
             {
             if(
             t.equals("continue")||t.startsWith("continue;")||t.startsWith("continue ")||t.startsWith("continue\t")
             ){
             key = CONTINUE;
             break L46;
             }
             }
             {
             if(
             t.equals("return")||t.startsWith("return(")||t.startsWith("return;")||t.startsWith("return ")||t.startsWith("return\t")
             ){
             key = RETURN;
             break L46;
             }
             }
           if(
           t.equals("do")||t.startsWith("do;")||t.startsWith("do ")||t.startsWith("do\t")
           ){
           key = DO;
           }
           }
           {
           if(
           key.length() != 0
           ){
           newMember = null;
           Selection selection = new Selection(null, null);
           gr_start = i;
           selection.start = new Cursor(br, ns);
           int balanse = 0;
            L47:
            for(
            int j = i; j < br.body.size(); j++
            )
             {
             o = br.body.elementAt(j);
               {
               if(
               o instanceof Sketch
               ){
               gr_end = j;
               selection.end = new Cursor((Sketch)o);
               break L47;
               }
               }
               {
               if(
               o instanceof PrimitiveMember
               ){
               PrimitiveMember nsk = (PrimitiveMember)o;
               Row r = (Row)(nsk.text.rows.elementAt(0));
               t = r.toString(Default.literalColor);
                L48:
                for(
                int u = 0; u < t.length(); u++
                )
                 {
                   {
                   if(
                   t.charAt(u) == '('
                   ){
                   balanse++;
                   continue L48;
                   }
                   }
                 if(
                 t.charAt(u) == ')'
                 ){
                 balanse--;
                 }
                 }
               if(
               (t.length()>0)&&
               (t.charAt(t.length()-1) == ';')&&
               (balanse == 0)
               ){
               gr_end = j;
               selection.end = new Cursor(br, nsk);
               break L47;
               }
               }
               }
             }
           newMember = selection.convert2simple(0,0,new BaseLanguageJava());
           newMember.comment
           = new Row(key,Default.commentColor);
             {
             if(
             key.compareTo("do")==0
             ){
             newMember.comment
             = new Row(".."+key,Default.commentColor);
             }
             }
             {
             if(
             (key.compareTo(FOR) == 0) ||
             (key.compareTo(DO) == 0) ||
             (key.compareTo(WHILE) == 0)
             ){
             newMember.type = Scheme.LOOP;
             }
             }
           Branch newBr = (Branch)(newMember.body.elementAt(0));
            L51:
             {
               {
               if(
               (key.compareTo(ELSE) != 0) &&
               (key.compareTo(BREAK) != 0) &&
               (key.compareTo(CONTINUE) != 0) &&
               (key.compareTo(DO) != 0) &&
               (key.compareTo(RETURN) != 0)
               ){
                L49:
                for(
                ;;
                )
                 {
                 PrimitiveMember nsk = (PrimitiveMember)(newBr.body.elementAt(0));
                 Text txt = nsk.text;
                 Row r = (Row)(txt.rows.elementAt(0));
                 t = r.toString();
                   {
                   if(
                   t.indexOf("(") < 0
                   ){
                   newBr.body.removeElementAt(0);
                   continue L49;
                   }
                   }
                  for(
                  ;((Symbol)(r.element(1))).c != '(';
                  )
                   {
                   r.remove(1);
                   }
                 r.planSize();
                 break;
                 }
               int balance = 0;
                for(
                ;;
                )
                 {
                 o = newBr.body.elementAt(0);
                   {
                   if(
                   o instanceof Sketch
                   ){
                   System.exit(0);
                   }
                   }
                 PrimitiveMember nsk = (PrimitiveMember)o;
                 Row r = (Row)(nsk.text.rows.elementAt(0));
                 t = r.toString(Default.literalColor);
                 byte type = PrimitiveHead.SIMPLE;
                   {
                   if(
                   (key.compareTo(FOR) == 0) ||
                   (key.compareTo(WHILE) == 0)
                   ){
                   type = PrimitiveHead.LOOP;
                   }
                   }
                 PrimitiveHead h =
                 new PrimitiveHead
                 (type, new Text());
                 Row hrow = new Row(Default.sketchHeadColor);
                 h.text.rows.removeElementAt(0);
                 int n = r.elements.size();
                  for(
                  int m=1; m < n; m++
                  )
                   {
                   Symbol sy = (Symbol)(r.elements.elementAt(1));
                   hrow.insert(sy, m);
                    L50:
                     {
                       {
                       if(
                       (sy.c == '(')&&(sy.color != Default.literalColor)
                       ){
                       balance++;
                       break L50;
                       }
                       }
                     if(
                     (sy.c == ')')&&(sy.color != Default.literalColor)
                     ){
                     balance--;
                     }
                     }
                   r.remove(1);
                   if(
                   balance == 0
                   ){
                    for(
                    ;(r.elements.size()>1)&& ((((Symbol)(r.element(1))).c == ' '));
                    )
                     {
                     r.remove(1);
                     }
                   break;
                   }
                   }
                 r.planSize();
                 hrow.planSize();
                 hrow.setColor(Default.sketchHeadColor);
                 h.text.rows.addElement(hrow);
                 newMember.head.addElement(h);
                   {
                   if(
                   r.elements.size() == 1
                   ){
                   newBr.body.removeElementAt(0);
                   }
                   }
                 if(
                 balance == 0
                 ){
                 break;
                 }
                 }
               break L51;
               }
               }
             PrimitiveMember nsk = (PrimitiveMember)(newBr.body.elementAt(0));
             Text txt = nsk.text;
             Row r = (Row)(txt.rows.elementAt(0));
              for(
              int jj = 0; jj < key.length(); jj++
              )
               {
               r.remove(1);
               }
              for(
              ;(r.elements.size()>1) &&((((Symbol)(r.element(1))).c == ' '));
              )
               {
               r.remove(1);
               }
             r.planSize();
             if(
             r.elements.size()==1
             ){
             newBr.body.removeElementAt(0);
             }
             }
           }
           }
         if(
         newMember != null
         ){
         extraControlSketches(newMember);
         }
         }
       }
     }
    public static void extraBlocks(Sketch s)
     {
     Branch br = (Branch)(s.member(0));
     PrimitiveMember p;
     Selection selection = new Selection(null, null);
     int gr_start=0, gr_end=0;
      L54:
      for(
      int i=0; i < br.body.size(); i++
      )
       {
       selection.start = null;
       selection.end = null;
       Object o = br.member(i);
        L52:
         {
           {
           if(
           o instanceof Sketch
           ){
           extraBlocks((Sketch)o);
           break L52;
           }
           }
         p = (PrimitiveMember)o;
         String t = p.text.toString(Default.literalColor);
         StringTokenizer st = new StringTokenizer(t, " \t:");
         String ss = "";
          for(
          ;st.hasMoreTokens();
          )
           {
           ss = st.nextToken();
           if(
           ss.equals("case") || ss.equals("default")
           ){
           break;
           }
           }
         if(
         ss.equals("case") || ss.equals("default")
         ){
         gr_start = i+1;
         selection.start = new Cursor(br, p);
         selection.end =  new Cursor(br, p);
         i++;
         int countMembersInGroup = 0;
          L53:
          for(
          ;i < br.body.size();i++
          )
           {
           selection.end.moveToNextElement();
           o = br.member(i);
             {
             if(
             o instanceof Sketch
             ){
             countMembersInGroup++;
             continue L53;
             }
             }
           p = (PrimitiveMember)o;
           t = p.text.toString(Default.literalColor);
             {
             if(
             (t.indexOf("case")>-1) || (t.indexOf("default")>-1)
             ){
               {
               if(
               countMembersInGroup == 0
               ){
               selection.start.moveToNextElement();
               gr_start++;
               continue L53;
               }
               }
             selection.end.moveToPreviousElement();
             gr_end = i-1;
             break L53;
             }
             }
           countMembersInGroup++;
           }
         selection.start.moveToNextElement();
           {
           if(
           countMembersInGroup == 0
           ){
           Sketch newMember = new Sketch(Scheme.SIMPLE,
           new Branch(Scheme.SIMPLE, new BaseLanguageJava()),
           new BaseLanguageJava());
           newMember.parent = br;
           br.insert(newMember, br.body.size());
           break L54;
           }
           }
         gr_end = i-1;
         }
         }
       if(
       gr_start <= gr_end
       ){
       if(
       (selection.start != null) && (selection.end != null)
       ){
       Sketch newSk = selection.convert2simple(0,0,new BaseLanguageJava());
       newSk.comment = new Row("..block", Default.commentColor);
       extraBlocks(newSk);
       i -= gr_end - gr_start;
       i--;
       }
       }
       }
     }
    public static void labelTable(Sketch s)
     {
     labels = new Vector();
     lableTableRec(s);
     }
    public static void lableTableRec(Sketch s)
     {
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Branch br = (Branch)(s.body.elementAt(i));
        L55:
        for(
        int j = 0; j < br.body.size(); j++
        )
         {
         Object o = br.member(j);
           {
           if(
           o instanceof Sketch
           ){
           lableTableRec((Sketch)o);
           continue L55;
           }
           }
         if(
         o instanceof PrimitiveMember
         ){
         PrimitiveMember p = (PrimitiveMember)o;
         if(
         (p.type == PrimitiveMember.SIMPLE) &&
         (p.text.rows.size() == 1)
         ){
         String str = p.text.row(0).toString();
         int len = str.length();
         if(
         (len > 1) && (str.charAt(len-1) == ':')
         ){
          L56:
          for(
          int k = j+1; ; k++
          )
           {
             {
             if(
             k >= br.body.size()
             ){
             break L56;
             }
             }
           o = br.member(k);
           if(
           o instanceof Sketch
           ){
           labels.addElement(
           str.substring(0,len-1).trim());
           labels.addElement(o);
           break;
           }
           }
         }
         }
         }
         }
       }
     }
    public static void breaks(Sketch s)
     {
      L57:
       {
         {
         if(
         s.comment.toString().compareTo("return") == 0
         ){
         s.comment = new Row("..return", Default.commentColor);
         Branch br = (Branch)(s.body.elementAt(0));
         Text t = new Text();
         int ip;
         String pstr;
          for(
          ip = 0; ip < br.body.size() - 1; ip++
          )
           {
           pstr =
           ((PrimitiveMember)(br.member(ip))).text.toString();
           t.insert(new Row(pstr, Default.foregroundColor), ip);
           }
         pstr =
         ((PrimitiveMember)(br.member(ip))).text.toString();
         pstr = pstr.substring(0,pstr.length()-1);
         t.insert(new Row(pstr, Default.foregroundColor), ip);
         t.remove(t.rows.size() - 1);
         PrimitiveMember ns = (PrimitiveMember)(br.body.elementAt(0));
         Sketch x = (Sketch)(s.parent.parent);
         boolean error = false;
          {try
           {
            for(
            ;x.type != Scheme.MODULE;
            )
             {
             x = (Sketch)(x.parent.parent);
             }
           }
           catch
           (NullPointerException e)
           {
           ns.text.comment = new Row("*** RETURN OUTSIDE OF METHODS! ***",
           Default.conditionColor);
           error = true;
           AmDialog d =
           new AmDialog
           (frame, AmLocale.Source_syntax_error(),AmDialog.B_OK,
           AmLocale.Illegal()+" 'return'.");
           Arrow ar = new Arrow(Arrow.STRONG, Integer.MAX_VALUE);
           ar.text = t;
           br.body.addElement(ar);
           br.body.removeElementAt(0);
           }
          }
           {
           if(
           !error
           ){
           int level = x.level();
           Arrow ar = new Arrow(Arrow.STRONG, level);
           ar.text = t;
           br.body.removeElementAt(0);
           br.body.addElement(ar);
           int np = br.body.size()-1;
            for(
            ip = 0; ip < np; ip++
            )
             {
             br.body.removeElementAt(0);
             }
           }
           }
         break L57;
         }
         }
         {
         if(
         s.comment.toString().compareTo("break") == 0
         ){
         s.comment = new Row("..break", Default.commentColor);
         Branch br = (Branch)(s.body.elementAt(0));
         PrimitiveMember ns = (PrimitiveMember)(br.body.elementAt(0));
         Text t = ns.text;
          L60:
           {
             {
             if(
             (t.rows.size() == 1) &&
             (t.row(0).elements.size() > 2)
             ){
             String label = t.row(0).toString();
             label = label.substring(0,label.length()-1).trim();
             int labelIndex = -1;
             String lab;
              for(
              int k = 0; k < labels.size(); k += 2
              )
               {
               lab = (String)(labels.elementAt(k));
               if(
               label.compareTo(lab) == 0
               ){
               labelIndex = k;
               break;
               }
               }
              L58:
               {
                 {
                 if(
                 labelIndex == -1
                 ){
                 ns.text.comment = new Row("*** ILLEGAL BREAK! ***",
                 Default.conditionColor);
                 AmDialog d =
                 new AmDialog
                 (frame, AmLocale.Source_syntax_error(),AmDialog.B_OK,
                 AmLocale.Illegal()+" 'break'. ");
                 Arrow ar = new Arrow(Arrow.STRONG, Integer.MAX_VALUE);
                 ar.text = t;
                 br.body.addElement(ar);
                 br.body.removeElementAt(0);
                 break L58;
                 }
                 }
               //Sketch arrowEnd = (Sketch)(labels.elementAt(labelIndex+1));
               Sketch x = (Sketch)(s.parent.parent);
                L59:
                for(
                ;(x != null)&& (x.parent != null);
                )
                 {
                  for(
                  int k = 0; k < labels.size(); k += 2
                  )
                   {
                   lab = (String)(labels.elementAt(k));
                   if(
                   (label.compareTo(lab) == 0)&&
                   ((Sketch)(labels.elementAt(k+1)) == x)
                   ){
                   break L59;
                   }
                   }
                 x = (Sketch)(x.parent.parent);
                 }
               int level = x.level();
                 {
                 if(
                 level > 0
                 ){
                 br.body.removeElementAt(0);
                 Arrow ar = new Arrow(Arrow.STRONG, level);
                 ar.text = t;
                 br.body.addElement(ar);
                 break L58;
                 }
                 }
               ns.text.comment = new Row("*** ILLEGAL BREAK! ***",
               Default.conditionColor);
               AmDialog d =
               new AmDialog
               (frame, AmLocale.Source_syntax_error(),AmDialog.B_OK,
               AmLocale.Illegal()+" 'break'. ");
               Arrow ar = new Arrow(Arrow.STRONG, Integer.MAX_VALUE);
               ar.text = t;
               br.body.addElement(ar);
               br.body.removeElementAt(0);
               }
             break L60;
             }
             }
           Sketch x = (Sketch)(s.parent.parent);
            for(
            ;(x != null)&& (x.parent != null) &&
            (x.comment.toString().indexOf("..switch") != 0)&&
            (x.comment.toString().indexOf("..for") != 0)&&
            (x.comment.toString().indexOf("..do") != 0)&&
            (x.comment.toString().indexOf("..while") != 0);
            )
             {
             x = (Sketch)(x.parent.parent);
             }
           int level = x.level();
             {
             if(
             level > 0
             ){
             br.body.removeElementAt(0);
             Arrow ar = new Arrow(Arrow.STRONG, level);
             ar.text = t;
             br.body.addElement(ar);
             break L60;
             }
             }
           ns.text.comment = new Row("*** ILLEGAL BREAK! ***",
           Default.conditionColor);
           AmDialog d =
           new AmDialog
           (frame, AmLocale.Source_syntax_error(),AmDialog.B_OK,
           AmLocale.Illegal()+" 'break'. ");
           Arrow ar = new Arrow(Arrow.STRONG, Integer.MAX_VALUE);
           ar.text = t;
           br.body.addElement(ar);
           br.body.removeElementAt(0);
           }
         break L57;
         }
         }
       if(
       s.comment.toString().compareTo("continue") == 0
       ){
       s.comment = new Row("..continue", Default.commentColor);
       Branch br = (Branch)(s.body.elementAt(0));
       PrimitiveMember ns = (PrimitiveMember)(br.body.elementAt(0));
       Text t = ns.text;
        L63:
         {
           {
           if(
           (t.rows.size() == 1) &&
           (t.row(0).elements.size() > 2)
           ){
           String label = t.row(0).toString();
           label = label.substring(0,label.length()-1).trim();
           int labelIndex = -1;
           String lab;
            for(
            int k = 0; k < labels.size(); k += 2
            )
             {
             lab = (String)(labels.elementAt(k));
             if(
             label.compareTo(lab) == 0
             ){
             labelIndex = k;
             break;
             }
             }
            L61:
             {
               {
               if(
               labelIndex == -1
               ){
               ns.text.comment = new Row("*** ILLEGAL CONTINUE! ***",
               Default.conditionColor);
               AmDialog d =
               new AmDialog
               (frame, AmLocale.Source_syntax_error(),AmDialog.B_OK,
               AmLocale.Illegal()+" 'continue'. ");
               Arrow ar = new Arrow(Arrow.STRONG, Integer.MAX_VALUE);
               ar.text = t;
               br.body.addElement(ar);
               br.body.removeElementAt(0);
               break L61;
               }
               }
             //Sketch arrowEnd = (Sketch)(labels.elementAt(labelIndex+1));
             Sketch x = (Sketch)(s.parent.parent);
              L62:
              for(
              ;(x != null)&& (x.parent != null);
              )
               {
                for(
                int k = 0; k < labels.size(); k += 2
                )
                 {
                 lab = (String)(labels.elementAt(k));
                 if(
                 (label.compareTo(lab) == 0)&&
                 ((Sketch)(labels.elementAt(k+1)) == x)
                 ){
                 break L62;
                 }
                 }
               x = (Sketch)(x.parent.parent);
               }
             int level = x.level();
               {
               if(
               level > 0
               ){
               br.body.removeElementAt(0);
               Arrow ar = new Arrow(Arrow.WEAK, level+1);
               ar.text = t;
               br.body.addElement(ar);
               break L61;
               }
               }
             ns.text.comment = new Row("*** ILLEGAL CONTINUE! ***",
             Default.conditionColor);
             AmDialog d =
             new AmDialog
             (frame, AmLocale.Source_syntax_error(),AmDialog.B_OK,
             AmLocale.Illegal()+" 'continue'. ");
             Arrow ar = new Arrow(Arrow.STRONG, Integer.MAX_VALUE);
             ar.text = t;
             br.body.addElement(ar);
             br.body.removeElementAt(0);
             }
           break L63;
           }
           }
         Sketch x = (Sketch)(s.parent.parent);
          for(
          ;(x != null)&& (x.parent != null) &&
          (x.comment.toString().indexOf("..switch") != 0)&&
          (x.comment.toString().indexOf("..for") != 0)&&
          (x.comment.toString().indexOf("..do") != 0)&&
          (x.comment.toString().indexOf("..while") != 0);
          )
           {
           x = (Sketch)(x.parent.parent);
           }
         int level = x.level();
           {
           if(
           level > 0
           ){
           br.body.removeElementAt(0);
           Arrow ar = new Arrow(Arrow.WEAK, level+1);
           ar.text = t;
           br.body.addElement(ar);
           break L63;
           }
           }
         ns.text.comment = new Row("*** ILLEGAL CONTINUE! ***",
         Default.conditionColor);
         AmDialog d =
         new AmDialog
         (frame, AmLocale.Source_syntax_error(),AmDialog.B_OK,
         AmLocale.Illegal()+ " 'continue'.");
         Arrow ar = new Arrow(Arrow.STRONG, Integer.MAX_VALUE);
         ar.text = t;
         br.body.addElement(ar);
         br.body.removeElementAt(0);
         }
       }
       }
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Branch br = (Branch)(e.nextElement());
        for(
        Enumeration ee = br.body.elements(); ee.hasMoreElements();
        )
         {
         Object o = ee.nextElement();
         if(
         o instanceof Sketch
         ){
         breaks((Sketch)o);
         }
         }
       }
     }
    static void setBranchHeadColor(Sketch s)
     {
      for(
      int k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
        for(
        int j = 0; j < br.head.size(); j++
        )
         {
         PrimitiveHead h = br.primitiveHead(j);
          for(
          int m = 0; m < h.text.rows.size(); m++
          )
           {
           Row r = h.text.row(m);
            for(
            int n = 0; n < r.elements.size(); n++
            )
             {
             r.getElement(n);
             r.sy.color = Default.branchHeadColor;
             }
           }
         }
        for(
        int i = 0; i < br.body.size(); i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof Sketch
         ){
         setBranchHeadColor((Sketch)o);
         }
         }
       }
       {
       if(
       s.head.size() > 0
       ){
       PrimitiveHead h = s.primitiveHead(0);
       if(
       h.type == PrimitiveHead.SWITCH
       ){
        for(
        int j = 0; j < s.head.size(); j++
        )
         {
         h = s.primitiveHead(j);
          for(
          int m = 0; m < h.text.rows.size(); m++
          )
           {
           Row r = h.text.row(m);
            for(
            int n = 0; n < r.elements.size(); n++
            )
             {
             r.getElement(n);
             r.sy.color = Default.branchHeadColor;
             }
           }
         }
       }
       }
       }
     }
    void joinHeads(Sketch s)
     {
     int k, j;
      for(
      k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
        for(
        j = 0; j < br.body.size(); j++
        )
         {
         Object o = br.member(j);
         if(
         o instanceof Sketch
         ){
         joinHeads((Sketch)o);
         }
         }
       }
     String comm = s.comment.toString();
       {
       if(
       (comm.compareTo("..for")==0)||
       (comm.compareTo("..switch")==0)||
       (comm.compareTo("..while")==0)
       ){
       Row r0 = s.primitiveHead(0).text.row(0);
        for(
        ;s.head.size() > 1;
        )
         {
         Row r = s.primitiveHead(1).text.row(0);
          for(
          int i = 1; i < r.elements.size(); i++
          )
           {
           r0.elements.addElement(r.elements.elementAt(i));
           }
         r0.planSize();
         s.head.removeElementAt(1);
         }
        L64:
        for(
        int i = 1; i < r0.elements.size(); i++
        )
         {
         r0.getElement(i);
           {
           if(
           r0.sy.c == ' '
           ){
           continue L64;
           }
           }
           {
           if(
           r0.sy.c == '('
           ){
            L65:
             {
               {
               if(
               comm.compareTo("..while")==0
               ){
               ((Symbol)(r0.element(i))).c = ';';
               break L65;
               }
               }
             r0.remove(i);
             }
           }
           }
         break;
         }
        L66:
        for(
        int i = r0.elements.size()-1; i > 0 ; i--
        )
         {
         r0.getElement(i);
           {
           if(
           r0.sy.c == ' '
           ){
           continue L66;
           }
           }
           {
           if(
           r0.sy.c == ')'
           ){
            L67:
             {
               {
               if(
               comm.compareTo("..while")==0
               ){
               ((Symbol)(r0.element(i))).c = ';';
               break L67;
               }
               }
             r0.remove(i);
             }
           }
           }
         break;
         }
       }
       }
     }
    void openParenthInConditions(Sketch s)
     {
      for(
      int k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
        L68:
        for(
        int j = 0; j < br.body.size(); j++
        )
         {
         Object o = br.member(j);
           {
           if(
           o instanceof Sketch
           ){
           Sketch sk = (Sketch)o;
           openParenthInConditions(sk);
           continue L68;
           }
           }
         Primitive p = (Primitive)o;
         if(
         p.type == Primitive.CONDITION
         ){
         Text t = p.text;
         int i  = t.rows.size();
         if(
         i>0
         ){
         Row rFirst = t.row(0);
         rFirst.trim();
         Row rLast =t.row(i-1);
         rLast.trim();
         if(
         !rFirst.isTrivial() && !rLast.isTrivial()
         ){
         rFirst.getElement(1);
         Symbol s1 = rFirst.sy;
         rLast.getElement(rLast.elements.size() - 1);
         Symbol s2 = rLast.sy;
         if(
         (s1.c == '(')  && (s2.c == ')')
         ){
         rFirst.remove(1);
         rFirst.planSize();
         rLast.remove(rLast.elements.size() - 1);
         rLast.planSize();
         }
         }
         }
         }
         }
       }
     }
   static boolean changed;
    public void reduce(Sketch s)
     {
     changed = true;
      for(
      ;changed;
      )
       {
       changed = false; reduceSimples(s);
       }
     }
    static void reduceSimples(Sketch s)
     {
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Branch br = (Branch)(e.nextElement());
        L69:
        for(
         int i = 0; i < br.body.size(); i++
        )
         {
         Object o = br.body.elementAt(i);
         if(
         o instanceof Sketch
         ){
         Sketch innerSketch = (Sketch)o;
         String xinner = innerSketch.comment.toString();
         String xbr = br.comment.toString();
           {
           if(
           innerSketch.head.size() > 0
           ){
           reduceSimples(innerSketch);
           continue L69;
           }
           }
           {
           if(
           rule1(br, innerSketch, i)
           ){
           changed = true; i--;
           continue L69;
           }
           }
           {
           if(
           rule15(br, innerSketch, i)
           ){
           changed = true;
           i--;
           continue L69;
           }
           }
          L70:
           {
             {
             if(
             s.type == Scheme.SIMPLE
             ){
               {
               if(
               rule11(br, innerSketch, i)
               ){
               changed = true;i--;
               continue L69;
               }
               }
             break L70;
             }
             }
           if(
           s.type == Scheme.LOOP
           ){
           if(
           rule12(br, innerSketch, i)
           ){
           changed = true;i--;
           continue L69;
           }
           }
           }
           {
           if(
           rule7(br, innerSketch, i)
           ){
           changed = true;i--;
           continue L69;
           }
           }
         reduceSimples(innerSketch);
         }
         }
       }
     }
    static boolean rule1(Branch br, Sketch Pi2, int i)
     {
       {
       if(
       
       ((Pi2.comment.isTrivial())
       || (Pi2.comment.toString().indexOf("..") == 0)
       )
       && (Pi2.body.size() == 1)
       
       ){
       Branch Pi2br = (Branch)(Pi2.body.elementAt(0));
       if(
       Pi2br.body.size() == 0
       ){
       br.body.removeElementAt(i);
       return(
       true
       );
       }
       }
       }
     return(
     false
     );
     }
    static boolean rule11(Branch br, Sketch Pi2, int i)
     {
       {
       if(
       Pi2.type != Sketch.SIMPLE
       ){
       return(
       false
       );
       }
       }
       {
       if(
       Pi2.body.size() > 1
       ){
       return(
       false
       );
       }
       }
      for(
      int j = i+1; j < br.body.size(); j++
      )
       {
       Object o = br.body.elementAt(j);
         {
         if(
         o instanceof Sketch
         ){
         return(
         false
         );
         }
         }
         {
         if(
         o instanceof Arrow
         ){
         return(
         false
         );
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
         {
         if(
         !ns.text.isTrivial()
         ){
         return(
         false
         );
         }
         }
       }
       {
       if(
       (Pi2.comment.isTrivial()) ||
       (Pi2.comment.toString().indexOf("..") == 0)
       ){
       Branch Pi2br = (Branch)(Pi2.body.elementAt(0));
       Group gr2 = new Group(Pi2br);
       gr2.start = 0;
       gr2.end = Pi2br.body.size()-2;
       Group gr1 = new Group(br);
       gr1.start = 0;
       gr1.end = i-1;
       if(
       gr1.isCC() || (!gr2.containsMemberArrow())
       ){
       Pi2.open();
       return(
       true
       );
       }
       }
       }
     return(
     false
     );
     }
    static boolean rule12(Branch br, Sketch Pi2, int i)
     {
       {
       if(
       Pi2.type != Sketch.SIMPLE
       ){
       return(
       false
       );
       }
       }
       {
       if(
       Pi2.body.size() > 1
       ){
       return(
       false
       );
       }
       }
      for(
      int j = i+1; j < br.body.size(); j++
      )
       {
       Object o = br.body.elementAt(j);
         {
         if(
         o instanceof Sketch
         ){
         return(
         false
         );
         }
         }
         {
         if(
         o instanceof Arrow
         ){
         return(
         false
         );
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
         {
         if(
         !ns.text.isTrivial()
         ){
         return(
         false
         );
         }
         }
       }
       {
       if(
       (Pi2.comment.isTrivial()) ||
       (Pi2.comment.toString().indexOf("..") == 0)
       ){
       Branch Pi2br = (Branch)(Pi2.body.elementAt(0));
       Group gr2 = new Group(Pi2br);
       gr2.start = 0;
       gr2.end = Pi2br.body.size()-2;
       Group gr1 = new Group(br);
       gr1.start = 0;
       gr1.end = i-1;
       if(
       gr1.isCC() || (
       !gr2.containsMemberArrow() &&
       !br.parent.isHeadless()
       )
       ){
       Pi2.withdrawArrows(Pi2.level());
       Pi2.open();
       return(
       true
       );
       }
       }
       }
     return(
     false
     );
     }
    static boolean rule15(Branch br, Sketch Pi2, int i)
     {
       {
       if(
       Pi2.type != Scheme.SIMPLE
       ){
       return(
       false
       );
       }
       }
       {
       if(
       Pi2.body.size() > 1
       ){
       return(
       false
       );
       }
       }
       {
       if(
       (Pi2.comment.isTrivial()) || (Pi2.comment.toString().indexOf("..") == 0)
       ){
       Branch Pi2br = (Branch)(Pi2.body.elementAt(0));
       Group gr2 = new Group(Pi2br);
       gr2.start = 0;
       gr2.end = Pi2br.body.size()-1;
         {
         if(
         Pi2.containsArrow(Pi2.level())
         ){
         return(
         false
         );
         }
         }
       Group gr1 = new Group(br);
       gr1.start = 0;
       gr1.end = i-1;
       if(
       (gr1.isCC() && gr2.isCC()) || gr2.isLinear()
       ){
       Pi2.open();
       return(
       true
       );
       }
       }
       }
     return(
     false
     );
     }
    static boolean rule7(Branch br, Sketch Pi2, int i)
     {
     int j = i+1;
     int iArrow2 = -1;
      L71:
      for(
      ;;j++
      )
       {
         {
         if(
         j == br.body.size()
         ){
         return(
         false
         );
         }
         }
       Object o = br.body.elementAt(j);
         {
         if(
         o instanceof Sketch
         ){
         return(
         false
         );
         }
         }
         {
         if(
         o instanceof Arrow
         ){
         iArrow2 = j;
         break L71;
         }
         }
       if(
       o instanceof PrimitiveMember
       ){
       PrimitiveMember ns = (PrimitiveMember)o;
         {
           {
           if(
           ns.text.isTrivial()
           ){
           continue L71;
           }
           }
         return(
         false
         );
         }
       }
       }
       {
       if(
       iArrow2 == -1
       ){
       return(
       false
       );
       }
       }
     Branch Pi2br = (Branch)(Pi2.body.elementAt(0));
     j = Pi2br.body.size()-1;
     int iArrow1 = -1;
      L72:
      for(
      ;;j--
      )
       {
         {
         if(
         j < 0
         ){
         return(
         false
         );
         }
         }
       Object o = Pi2br.body.elementAt(j);
         {
         if(
         o instanceof Sketch
         ){
         return(
         false
         );
         }
         }
         {
         if(
         o instanceof Arrow
         ){
         iArrow1 = j;
         break L72;
         }
         }
       if(
       o instanceof PrimitiveMember
       ){
       PrimitiveMember ns = (PrimitiveMember)o;
         {
           {
           if(
           ns.text.isTrivial()
           ){
           continue L72;
           }
           }
         return(
         false
         );
         }
       }
       }
       {
       if(
       iArrow1 == -1
       ){
       return(
       false
       );
       }
       }
     Group gr2 = new Group(Pi2br);
     gr2.start = 0;
     gr2.end = iArrow1-1;
       {
       if(
       !gr2.isCC()
       ){
       return(
       false
       );
       }
       }
     Arrow ar1 = (Arrow)(Pi2br.body.elementAt(iArrow1));
     Pi2br.body.removeElementAt(iArrow1);
     br.body.removeElementAt(iArrow2);
     br.body.insertElementAt(ar1, iArrow2);
     return(
     true
     );
     }
    public  boolean normalize(SketchyText skt0,
    SketchyText skt1,
    AmFrame dialogTargetFrame)
     {
     frame = dialogTargetFrame;
     skt1.main.insert(skt0.main.branch(0).makeCopy(),1);
     skt1.main.removeMember(0);
     skt1.main.baseLanguage = new BaseLanguageJava();
     label = 0;
     normalize(skt1.main);
     return(
     true
     );
     }
    private boolean normalize(Sketch s)
     {
      for(
      int k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
       scopeConditions(br);
       }
      for(
      int k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
        for(
        int i = 0; i < br.body.size(); i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof Sketch
         ){
         if(
         normalize((Sketch)o)
         ){
         i--;
         }
         }
         }
       }
       {
       if(
       s.level() > 0
       ){
       String comm = s.comment.toString();
         {
         if(
         (comm.length() >=2) &&
         (comm.substring(0,2).compareTo("//") == 0)
         ){
         int i = s.parent.body.indexOf(s);
         s.parent.body.removeElementAt(i);
         return(
         true
         );
         }
         }
       if(
       s.type == Scheme.MODULE
       ){
         {
         if(
         s.head.size() == 0
         ){
         s.open();
         return(
         true
         );
         }
         }
       if(
       s.primitiveHead(0).type == PrimitiveHead.LOOP
       ){
       String htext = s.primitiveHead(0).text.toString();
       Branch br = s.branch(0);
        for(
        int i = 0; i < br.body.size(); i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof PrimitiveMember
         ){
         PrimitiveMember p = (PrimitiveMember)o;
         if(
         p.type == Primitive.SIMPLE
         ){
         if(
         !p.text.isTrivial()
         ){
          for(
          int j = 0; j < htext.length(); j++
          )
           {
           p.text.row(0).insert(
           new Symbol(htext.charAt(j)),
           j+1);
           }
         }
         }
         }
         }
       s.head.removeAllElements();
       s.open();
       return(
       true
       );
       }
       }
       }
       }
      for(
      int k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
        for(
        int i = 0; i < br.body.size(); i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof PrimitiveMember
         ){
         PrimitiveMember p = (PrimitiveMember)o;
         if(
         (p.type == Primitive.SIMPLE)&&
         (p.text.isTrivial())
         ){
         br.removeMember(i);
         i--;
         }
         }
         }
       }
     eliminateUnreachables(s);
     int sLevel = s.level();
      for(
      int k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
         {
         if(
         br.type == Scheme.SIMPLE
         ){
         if(
         br.head.size() == 1
         ){
         PrimitiveHead he = br.primitiveHead(0);
         String heStr = he.text.toString().trim();
          L73:
           {
             {
             if(
             (he.type == PrimitiveHead.CASE) &&
             (heStr.compareTo(":") == 0)
             ){
             he.type = PrimitiveHead.DEFAULT;
             break L73;
             }
             }
           if(
           (he.type == PrimitiveHead.CATCH) &&
           (heStr.compareTo("") == 0)
           ){
           he.type = PrimitiveHead.FINALLY;
           }
           }
         }
         }
         }
        for(
        int i = 0; i < br.body.size(); i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof Arrow
         ){
         Arrow ar = (Arrow)o;
         Scheme destin = ar.destination(br);
           {
           if(
           destin instanceof Branch
           ){
           destin = destin.parent;
           if(
           destin.type != Scheme.LOOP
           ){
           ar.type = Arrow.STRONG;
           ar.level--;
           }
           }
           }
         if(
         ar.level < sLevel
         ){
           {
           if(
           (destin != null) &&
           (destin.type != Scheme.MODULE)
           ){
           String dComment =
           destin.comment.toString().trim();
           if(
           dComment.indexOf("[AMADEUSlabel:") < 0
           ){
           destin.comment = new Row(
           "[AMADEUSlabel:" +
           "L" + label +
           "]" + dComment,
           Default.commentColor
           );
           label++;
           }
           }
           }
         if(
         destin.parent == null
         ){
         AmDialog d =
         new AmDialog
         (frame, AmLocale.Error(),AmDialog.B_OK,
         AmLocale.Normalize() + ":" +
         AmLocale.Break_to_outer_level() + "!");
         }
         }
         }
         }
       }
     return(
     false
     );
     }
    private void eliminateUnreachables(Sketch s)
     {
      for(
      int k = 0; k < s.body.size(); k++
      )
       {
       Branch br = s.branch(k);
        for(
        int i = 0; i < br.body.size() ; i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof Arrow
         ){
         if(
         i != (br.body.size() - 1)
         ){
         int j = i+1;
          for(
          ;j < br.body.size();
          )
           {
           br.removeMember(j);
           }
         AmDialog d =
         new AmDialog
         (frame, AmLocale.Warning(),AmDialog.B_OK,
         AmLocale.Normalize() + ":" +
         AmLocale.Unreachables() + "!");
         return;
         }
         }
         }
       }
     }
    private void scopeConditions(Branch br)
     {
      for(
      ;!conditionsScoped(br);
      )
       {
       LOOP:
        L74:
        for(
        int i = 0; ; i++
        )
         {
         Object o = br.member(i);
         if(
         o instanceof PrimitiveMember
         ){
         PrimitiveMember p = (PrimitiveMember)o;
         if(
         p.type == Primitive.CONDITION
         ){
          for(
          int j = i+1; ;j++
          )
           {
           o = br.member(j);
           if(
           o instanceof Arrow
           ){
           Arrow ar = (Arrow)o;
           Selection sel =
           new Selection(
           new Cursor(br,p),
           new Cursor(br,ar));
           Sketch sk =
           sel.convert2simple(0,0,new BaseLanguageJava());
           scopeConditions(sk.branch(0));
           break L74;
           }
           }
         }
         }
         }
       }
     }
   static int label;
   static Branch br1;
   static String indent =
   "                                                             ";
   static int currentLevel = 0;
   static final int EMPTY = -2;
   static final int NOT_NORMALIZED = -1;
   static final int LINEAR = 0;
   static final int IF0 = 1;
   static final int IF = 2;
   static final int PSEUDOLINEAR = 3;
    private static Sketch getSKMmodel(Sketch s)
     {
     Branch br = s.branch(0);
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
       if(
       o instanceof Sketch
       ){
       Sketch sk = (Sketch)o;
         {
           {
           if(
           (sk.view.type == View.BOX)
           && (sk.baseLanguage.type == BaseLanguage.NONE)
           ){
           return(
           sk
           );
           }
           }
         Sketch tulem = getSKMmodel(sk);
         if(
         tulem != null
         ){
         return(
         tulem
         );
         }
         }
       }
       }
     return(
     null
     );
     }
    public  boolean textualize(SketchyText skt0,
    SketchyText skt1,
    AmFrame dialogTargetFrame)
     {
     frame = dialogTargetFrame;
     Sketch sNew = skt1.main;
     Sketch s = skt0.main.makeCopy();
     Sketch mudel = getSKMmodel(s);
       {
       if(
       mudel != null
       ){
       Item36Listener.textualizeInplace(mudel, dialogTargetFrame);
       }
       }
     label = 0;
     normalize(s);
     sNew.baseLanguage = new BaseLanguageJava();
     sNew.branch(0).baseLanguage = new BaseLanguageJava();
     Branch br = s.branch(0);
     br1 = sNew.branch(0);
     br1.body.removeElementAt(0);
      L75:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof PrimitiveMember
         ){
         textualize((PrimitiveMember)o);
         continue L75;
         }
         }
       if(
       o instanceof Sketch
       ){
       textualize((Sketch)o);
       }
       }
     return(
     true
     );
     }
    private void textualize(Primitive p)
     {
       {
       if(
       p.text.isTrivial()
       ){
       return;
       }
       }
      for(
      int i = 0; i < p.text.rows.size(); i++
      )
       {
       insertLine(p.text.row(i).toString());
       }
     }
    private void textualizeCondition(Primitive p)
     {
     insertLine("if(");
      for(
      int i = 0; i < p.text.rows.size(); i++
      )
       {
       insertLine(p.text.row(i).toString());
       }
     insertLine("){");
     }
    private void textualizeReturn(Arrow a)
     {
       {
       if(
       a.text.isTrivial()
       ){
       insertLine("return;");
       return;
       }
       }
     insertLine("return(");
      for(
      int i = 0; i < a.text.rows.size(); i++
      )
       {
       insertLine(a.text.row(i).toString());
       }
     insertLine(");");
     }
    private void textualize(PrimitiveHead he)
     {
     String pref = "";
     String suff = "";
      switch(
      he.type
      )
      {
       case
        PrimitiveHead.LOOP:
       pref = "for("; suff = ")";
       break;
       case
        PrimitiveHead.SWITCH:
        pref = "switch("; suff = ")";
       break;
       case
        PrimitiveHead.TRY:
        pref = "{try";
       break;
       case
        PrimitiveHead.CASE:
        pref = "case";
       break;
       case
        PrimitiveHead.DEFAULT:
       pref = "case";
       String heText = he.text.toString().trim();
         {
         if(
         heText.compareTo(":")==0
         ){
         pref = "default";
         }
         }
       break;
       case
        PrimitiveHead.CATCH:
        pref = "catch";
       break;
       case
        PrimitiveHead.FINALLY:
        pref = "finally";
       break;
      }
       {
       if(
       pref.length() > 0
       ){
       insertLine(pref);
       }
       }
       {
       if(
       he.text.isTrivial()
       ){
       return;
       }
       }
      for(
      int i = 0; i < he.text.rows.size(); i++
      )
       {
       insertLine(he.text.row(i).toString());
       }
       {
       if(
       suff.length() > 0
       ){
       insertLine(suff);
       }
       }
     }
    private void insertLine(String str)
     {
     str = indent.substring(
     0, Math.min(indent.length(),
     currentLevel+1))
     + str;
     Text newT = new Text();
     newT.rows.removeElementAt(0);
     newT.rows.addElement(
     new Row(unicode(str), Default.foregroundColor));
     br1.body.addElement(
     new PrimitiveMember(Primitive.SIMPLE, newT));
     }
    private String unicode(String s)
     {
     StringBuffer tulem = new StringBuffer();
     String unisuff = "";
      L76:
      for(
      int i = 0; i < s.length(); i++
      )
       {
       int c = (int)s.charAt(i);
         {
         if(
         c < 256
         ){
         tulem.append(s.charAt(i));
         continue L76;
         }
         }
       unisuff = Integer.toHexString(c);
         {
         if(
         unisuff.length() < 4
         ){
         tulem.append("\\u0" + unisuff);
         continue L76;
         }
         }
       tulem.append("\\u" + unisuff);
       }
     return(
     tulem.toString()
     );
     }
    private void textualize(Sketch sk)
     {
     currentLevel++;
     String str = sk.comment.toString();
       {
       if(
       str.indexOf("[AMADEUSlabel:") == 0
       ){
       insertLine(str.substring(14, str.indexOf("]"))+":");
       }
       }
     boolean isSwitch = false;
     boolean isTry = false;
     int i;
      L77:
       {
         {
         if(
         (sk.type == Scheme.LOOP) && (sk.head.size() == 0)
         ){
         insertLine("for(;;)");
         break L77;
         }
         }
        for(
        i = 0; i < sk.head.size(); i++
        )
         {
          L78:
           {
             {
             if(
             sk.primitiveHead(i).type == PrimitiveHead.SWITCH
             ){
             isSwitch = true;
             break L78;
             }
             }
           if(
           sk.primitiveHead(i).type == PrimitiveHead.TRY
           ){
           isTry = true;
           }
           }
         textualize(sk.primitiveHead(i));
         }
       }
       {
       if(
       isSwitch
       ){
       insertLine("{");
       }
       }
      for(
      i = 0; i < sk.body.size(); i++
      )
       {
       textualize(sk.branch(i));
       }
       {
       if(
       isSwitch || isTry
       ){
       insertLine("}");
       }
       }
     currentLevel--;
     }
    private void textualize(Branch b)
     {
     int conditionsOpenedCount = 0;
     String sss = b.comment.toString();
     currentLevel++;
     boolean isCase = false;
     int i;
      for(
      i = 0; i < b.head.size(); i++
      )
       {
         {
         if(
         (b.primitiveHead(i).type == PrimitiveHead.CASE) ||
         (b.primitiveHead(i).type == PrimitiveHead.CASE)
         ){
         isCase = true;
         }
         }
       textualize(b.primitiveHead(i));
       }
       {
       if(
       !isCase
       ){
       insertLine("{");
       }
       }
      switch(
      branchBodyKind(b)
      )
      {
       case
        EMPTY:
       break;
       case
        LINEAR:
        L79:
        for(
        i = 0; i < b.body.size(); i++
        )
         {
         Object o = b.member(i);
           {
           if(
           o instanceof Sketch
           ){
           textualize((Sketch)o);
           continue L79;
           }
           }
         textualize((PrimitiveMember)o);
         }
       break;
       case
        IF0:
        L80:
        for(
        i = 0; i < b.body.size(); i++
        )
         {
         Object o = b.member(i);
           {
           if(
           o instanceof Sketch
           ){
           textualize((Sketch)o);
           continue L80;
           }
           }
         PrimitiveMember p = (PrimitiveMember)o;
           {
           if(
           p.type == Primitive.SIMPLE
           ){
           textualize(p);
           continue L80;
           }
           }
         textualizeCondition(p);
         conditionsOpenedCount++;
         }
       String elsebreak = "";
         {
         if(
         (b.parent.type == Scheme.LOOP) &&
         b.parent.isHeadless()
         ){
         elsebreak = "else break;";
         }
         }
        for(
        int ii = 0; ii < conditionsOpenedCount; ii++
        )
         {
         insertLine("}"+elsebreak);
         }
       break;
       case
        IF:
       case
        PSEUDOLINEAR:
       conditionsOpenedCount = 0;
        L81:
        for(
        i = 0; i < b.body.size(); i++
        )
         {
         Object o = b.member(i);
           {
           if(
           o instanceof Sketch
           ){
           textualize((Sketch)o);
           continue L81;
           }
           }
           {
           if(
           o instanceof Arrow
           ){
           Arrow ar = (Arrow)o;
           int len = b.level() - ar.level;
             {
             if(
             (b.head.size() > 0) &&
             (((b.primitiveHead(0).type == PrimitiveHead.CASE) ||
             (b.primitiveHead(0).type == PrimitiveHead.DEFAULT)) &&
             (len == 1))
             ){
             insertLine("break;");
             continue L81;
             }
             }
             {
             if(
             (b.parent.type == Scheme.LOOP) &&
             (len <= 1)
             ){
              L82:
               {
                 {
                 if(
                 len == 0
                 ){
                 insertLine("continue;");
                 break L82;
                 }
                 }
               if(
               len == 1
               ){
               insertLine("break;");
               }
               }
             continue L81;
             }
             }
             {
             if(
             (len == 1) && (b.parent.type == Scheme.MODULE)
             ){
             textualizeReturn(ar);
             continue L81;
             }
             }
             {
               {
               if(
               len > 1
               ){
               Scheme x = ar.destination(b);
                 {
                 if(
                 x instanceof Branch
                 ){
                 x = x.parent;
                 }
                 }
                L83:
                 {
                   {
                   if(
                   x.type == Scheme.MODULE
                   ){
                   textualizeReturn(ar);
                   break L83;
                   }
                   }
                 String str = x.comment.toString();
                 str = " " +
                 str.substring(14,
                 str.indexOf("]"));
                   {
                   if(
                   ar.type == Arrow.STRONG
                   ){
                   insertLine("break" +
                   str +
                   ";");
                   break L83;
                   }
                   }
                 insertLine("continue" +
                 str +
                 ";");
                 }
               continue L81;
               }
               }
             continue L81;
             }
           }
           }
         PrimitiveMember p = (PrimitiveMember)o;
           {
           if(
           p.type == Primitive.SIMPLE
           ){
             {
             if(
             !p.text.isTrivial()
             ){
             textualize(p);
             }
             }
           continue L81;
           }
           }
         textualizeCondition(p);
         conditionsOpenedCount++;
         }
        for(
        int ii = 0; ii < conditionsOpenedCount; ii++
        )
         {
         insertLine("}");
         }
       break;
       default
       :
       {
       return;
       }
      }
       {
       if(
       !isCase
       ){
       insertLine("}");
       }
       }
     currentLevel--;
     }
    private boolean conditionsScoped(Branch b)
     {
     int i;
     int n = b.body.size() - 1;
      for(
      i = 0; i < n; i++
      )
       {
       Object o = b.member(i);
       if(
       o instanceof PrimitiveMember
       ){
       PrimitiveMember p = (PrimitiveMember)o;
       if(
       p.type == Primitive.CONDITION
       ){
        for(
         i++; i < n; i++
        )
         {
         o = b.member(i);
         if(
         o instanceof Arrow
         ){
         return(
         false
         );
         }
         }
       }
       }
       }
     return(
     true
     );
     }
    private int branchBodyKind(Branch b)
     {
     int i;
     int nontrivialsCount = 0;
     int arrowsCount = 0;
     int conditionsCount = 0;
      L84:
      for(
      i = 0; i < b.body.size(); i++
      )
       {
       Object o = b.member(i);
         {
         if(
         o instanceof Sketch
         ){
         nontrivialsCount++;
         continue L84;
         }
         }
         {
         if(
         o instanceof Arrow
         ){
           {
           if(
           (conditionsCount > 0) &&
           (i != b.body.size() - 1)
           ){
           return(
           NOT_NORMALIZED
           );
           }
           }
         nontrivialsCount++;
         arrowsCount++;
         continue L84;
         }
         }
       PrimitiveMember p = (PrimitiveMember)o;
         {
         if(
         p.type == Primitive.CONDITION
         ){
         nontrivialsCount++;
         conditionsCount++;
         continue L84;
         }
         }
         {
         if(
         p.text.isTrivial()
         ){
         return(
         NOT_NORMALIZED
         );
         }
         }
       nontrivialsCount++;
       }
       {
       if(
       nontrivialsCount == 0
       ){
       return(
       EMPTY
       );
       }
       }
       {
       if(
       (arrowsCount == 0) && (conditionsCount == 0)
       ){
       return(
       LINEAR
       );
       }
       }
       {
       if(
       (conditionsCount == 0) && (arrowsCount >0)
       ){
       return(
       PSEUDOLINEAR
       );
       }
       }
       {
       if(
       (arrowsCount == 0) && (conditionsCount > 0)
       ){
       return(
       IF0
       );
       }
       }
     return(
     IF
     );
     }
    void prepareTex(Sketch s)
     {
     prepareTex(s.comment);
      for(
      int j = 0;j < s.head.size(); j++
      )
       {
       prepareTex(s.primitiveHead(j).text);
       prepareTex(s.primitiveHead(j).text.comment);
       }
      L85:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Branch br = s.branch(i);
         {
         if(
         br.baseLanguage.type != BaseLanguage.JAVA
         ){
         continue L85;
         }
         }
       prepareTex(br.comment);
        for(
        int j = 0;j < br.head.size(); j++
        )
         {
         prepareTex(br.primitiveHead(j).text);
         prepareTex(br.primitiveHead(j).text.comment);
         }
        L86:
        for(
        int j = 0; j < br.body.size(); j++
        )
         {
         Object o = br.member(j);
           {
           if(
           o instanceof Sketch
           ){
           Sketch sk = (Sketch)o;
           sk.baseLanguage.prepareTex(sk);
           continue L86;
           }
           }
         Primitive p = (Primitive)o;
         prepareTex(p.text);
         prepareTex(p.text.comment);
         }
       }
     return;
     }
    private void prepareTex(Row r)
     {
     int nOrig = r.elements.size();
      L87:
      for(
      int j = 1; j < r.elements.size(); j++
      )
       {
       char c0 = 'x', c1 = 'x', c2 = 'x';
       r.getElement(j);
         {
         if(
         r.sy != null
         ){
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('~', Default.literalColor), j);
           r.insert(new Symbol('o', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('a', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('o', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('u', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('~', Default.literalColor), j);
           r.insert(new Symbol('O', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('A', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('O', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('U', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
           {
           if(
           r.sy.c == '_'
           ){
           r.insert(new Symbol('\\', Default.literalColor), j);
           j++;
           continue L87;
           }
           }
         c2 = Character.toLowerCase(r.sy.c);
         }
         }
         {
         if(
         j > 2
         ){
         r.getElement(j-1);
           {
           if(
           r.sy != null
           ){
           c1 = Character.toLowerCase(r.sy.c);
           }
           }
         r.getElement(j-2);
         if(
         r.sy != null
         ){
         c0 = Character.toLowerCase(r.sy.c);
         }
         }
         }
         {
         if(
         c2 == '\"'
         ){
           {
           if(
           c0 != c1
           ){
           continue L87;
           }
           }
           {
           if(
           (c1 == 'a')||(c1 == 'o')||(c1 == 'u')
           ){
           r.insert(new Symbol('\"', Default.literalColor), j-1);
           j++;
           }
           }
         continue L87;
         }
         }
       if(
       c2 == '~'
       ){
       if(
       (c0 == 'o') && (c1 == 'o')
       ){
       r.insert(new Symbol('~', Default.literalColor), j-1);
       j++;
       }
       }
       }
      L88:
      for(
      int j = 1; j < r.elements.size(); j++
      )
       {
       char c1 = 'x', c2 = 'x';
       r.getElement(j);
         {
         if(
         r.sy != null
         ){
         c2 = Character.toLowerCase(r.sy.c);
         }
         }
         {
         if(
         j > 1
         ){
         r.getElement(j-1);
         if(
         r.sy != null
         ){
         c1 = Character.toLowerCase(r.sy.c);
         }
         }
         }
         {
         if(
         c2 == '\"'
         ){
           {
           if(
           (c1 == 'a')||(c1 == 'o')||(c1 == 'u')
           ){
           r.remove(j);
           r.insert(new Symbol('\"', Default.literalColor), j-1);
           r.insert(new Symbol('\\', Default.literalColor), j-1);
           j++;
           }
           }
         continue L88;
         }
         }
       if(
       (c2 == '~') && (c1 == 'o')
       ){
       r.remove(j);
       r.insert(new Symbol('~', Default.literalColor), j-1);
       r.insert(new Symbol('\\', Default.literalColor), j-1);
       j++;
       }
       }
       {
       if(
       nOrig != r.elements.size()
       ){
       r.planSize();
       }
       }
     return;
     }
    private void prepareTex(Text t)
     {
      for(
      int i = 0; i < t.rows.size(); i++
      )
       {
       Row r = t.row(i);
       int nOrig = r.elements.size();
        L89:
        for(
        int j = 1; j < r.elements.size(); j++
        )
         {
         r.getElement(j);
         if(
         r.sy != null
         ){
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('o', Default.literalColor), j);
           r.insert(new Symbol('~', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('a', Default.literalColor), j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('o', Default.literalColor), j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('u', Default.literalColor), j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('O', Default.literalColor), j);
           r.insert(new Symbol('~', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('A', Default.literalColor), j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('O', Default.literalColor), j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
           {
           if(
           r.sy.c == ''
           ){
           r.remove(j);
           r.insert(new Symbol('U', Default.literalColor), j);
           r.insert(new Symbol('\"', Default.literalColor), j);
           r.insert(new Symbol('\\', Default.literalColor), j);
           j += 2;
           continue L89;
           }
           }
          L90:
           {
             {
             if(
             (r.sy.c == '=') ||
             (r.sy.c == '+') ||
             (r.sy.c == '-') ||
             (r.sy.c == '*') ||
             (r.sy.c == '/') ||
             (r.sy.c == '<') ||
             (r.sy.c == '>')
             ){
             r.insert(new Symbol('$', Default.literalColor), j);
             r.insert(new Symbol('$', Default.literalColor), j+2);
             j++;
             break L90;
             }
             }
             {
             if(
             (r.sy.c == '{') || (r.sy.c == '}')
             ){
             r.insert(new Symbol('\\', Default.literalColor), j);
             r.insert(new Symbol('$', Default.literalColor), j);
             r.insert(new Symbol('$', Default.literalColor), j+3);
             j += 2;
             break L90;
             }
             }
             {
             if(
             r.sy.c == '|'
             ){
             r.remove(j);
             r.insert(new Symbol('$', Default.literalColor), j++);
             r.insert(new Symbol('\\', Default.literalColor), j++);
             r.insert(new Symbol('m', Default.literalColor), j++);
             r.insert(new Symbol('i', Default.literalColor), j++);
             r.insert(new Symbol('d', Default.literalColor), j++);
             r.insert(new Symbol('$', Default.literalColor), j);
             break L90;
             }
             }
             {
             if(
             r.sy.c == '\\'
             ){
             r.remove(j);
             r.insert(new Symbol('$', Default.literalColor), j++);
             r.insert(new Symbol('\\', Default.literalColor), j++);
             r.insert(new Symbol('b', Default.literalColor), j++);
             r.insert(new Symbol('a', Default.literalColor), j++);
             r.insert(new Symbol('c', Default.literalColor), j++);
             r.insert(new Symbol('k', Default.literalColor), j++);
             r.insert(new Symbol('s', Default.literalColor), j++);
             r.insert(new Symbol('l', Default.literalColor), j++);
             r.insert(new Symbol('a', Default.literalColor), j++);
             r.insert(new Symbol('s', Default.literalColor), j++);
             r.insert(new Symbol('h', Default.literalColor), j++);
             r.insert(new Symbol('$', Default.literalColor), j);
             break L90;
             }
             }
             {
             if(
             (r.sy.c == '&') ||
             (r.sy.c == '%') ||
             (r.sy.c == '&')	                                   ||
             (r.sy.c == '#') ||
             (r.sy.c == '_')
             ){
             r.insert(new Symbol('\\', Default.literalColor), j);
             j++;
             break L90;
             }
             }
           if(
           (r.sy.c == '~') ||
           (r.sy.c == '^')
           ){
           r.insert(new Symbol('\\', Default.literalColor), j);
           r.insert(new Symbol('}', Default.literalColor), j+2);
           r.insert(new Symbol('{', Default.literalColor), j+2);
           j+=3;
           }
           }
         }
         }
       if(
       nOrig != r.elements.size()
       ){
       r.planSize();
       }
       }
     return;
     }
   }
