interface CursorMovements{ 
 
   // liikumine reas ----------------------------------------
   // eeldab: row
    void moveToRowHome();
    void moveToRowEnd();
   
    // liikumine primitiivis ----------------------------
    // eeldab: primitive
    void moveToPrimitiveText();// peremees-primitiivi teksti algusse
    void moveToPrimitiveTextEnd();// peremees-primitiivi teksti loppu
    void moveToPrimitiveComment();// peremees-primitiivi kommentaari algusse
    void moveToPrimitiveEnd(); // peremees-primitiivi kommentaari loppu
	
    // liikumine pa"ises ------------------------------
    // eeldab: pa"is pole tyhi
    void moveToHeadEnd(); // viimase lihtpa"ise loppu   
	  
    // liikunised skeemis: algusse, loppu, pa"isele, kehassse
    // eeldab: scheme ja inScheme(v.a. meetodis moveToParentHome)     
    void moveToParentHome(); // minna peremees-skeemi (kommentaari) algusse
    void moveToParentEnd(); // minna peremees-skeemi (keha viimase liikme) loppu
			    // kui keha pole, siis pa"ise loppu
			    // kui ka pa"ist pole, siis skeemi algusse
    boolean moveToHead(); // minna peremees-skeemi pa"ise algusse
    boolean moveToBody(); // minna peremees-skeemi keha esimesele liikmele 
			  // (kui keha pole tyhi)
    	
    // suunatud liikumine yhe sammu vo~rra ------------------------
    // eeldab: kui inScheme, siis kursor on paigas
    //         kui !inScheme, siis ainult scheme (liigub skeemialgusse)
    boolean moveDown();
    boolean moveRight();			                  
    boolean moveUp();
    boolean moveLeft();
}