 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
  class Item52Listener implements ActionListener
   {
   AmFrame frame;
    Item52Listener(AmFrame fr)
     {
     frame = fr;
     }
    public void actionPerformed(ActionEvent event)
     {
     AmCanvas c = frame.viewArea;
     Editor editor = frame.contents.editor;
     Caret caret = editor.caret;
     Color col;
      L0:
       {
         {
         if(
         caret.scheme instanceof Sketch
         ){
         col = Default.sketchHeadColor;
         break L0;
         }
         }
       col = Default.branchHeadColor;
       }
     PrimitiveHead h =
     new PrimitiveHead(PrimitiveHead.SIMPLE, new Text(col));
     insertPrimitiveHead(frame, h);
     }
    public static void insertPrimitiveHead(AmFrame frame, PrimitiveHead h)
     {
     AmCanvas c = frame.viewArea;
     Editor editor = frame.contents.editor;
     Caret caret = editor.caret;
     int i = caret.scheme.head.size();
      L1:
       {
         {
         if(
         caret.inHead()
         ){
         h.type = caret.primitive.type;
         i = caret.scheme.head.indexOf(caret.primitive)+1;
         break L1;
         }
         }
         {
         if(
         caret.inBody()
         ){
          L2:
           {
             {
             if(
             i == 0
             ){
             h.type = PrimitiveHead.SIMPLE;
             break L2;
             }
             }
           h.type = caret.scheme.primitiveHead(i-1).type;
           }
         break L1;
         }
         }
         {
         if(
         i == 0
         ){
           {
           if(
           caret.scheme.type == Scheme.LOOP
           ){
           h.type = PrimitiveHead.LOOP;
           }
           }
         break L1;
         }
         }
       h.type = caret.scheme.primitiveHead(i-1).type;
       }
     editor.insertHead(caret.scheme, i, h);
     frame.contents.main.view.plan(c.hd, c.vd);
     c.caretToScreen();
     c.own = true; c.repaint();
     }
   }
