 import  java.io.*;
 import  java.awt.*;
 import  java.util.*;
  class Row extends Rectangle
   {
   Vector elements;
   transient int maxDescent;
   transient Symbol sy;
   transient AmImage im;
   transient HyperElement hy;
   transient int prevX;
   transient int prevY;
   transient int prevW;
   transient int prevH;
    Row(Font font, Color color)
     {
     elements = new Vector();
     width = 0; height = 0;
     insert(new Symbol(Default.leadingChar, font, color), 0);
     x = -1;
     y = -1;
     width = -1;
     height = -1;
     planSize();
     }
    Row(Color color)
     {
     elements = new Vector();
     width = 0; height = 0;
     insert(new Symbol(Default.leadingChar, color), 0);
     x = -1;
     y = -1;
     width = -1;
     height = -1;
     planSize();
     }
    Row(String s, Color color)
     {
     this(color);
     Symbol symbol;
      for(
      int i = 0; i < s.length(); i++
      )
       {
       symbol = new Symbol(s.charAt(i), Default.font, color);
       insert(symbol, i+1);
       }
     x = -1;
     y = -1;
     width = -1;
     height = -1;
     planSize();
     }
    Object element(int i)
     {
     return(
     elements.elementAt(i)
     );
     }
    void getElement(int i)
     {
     Object o = element(i);
      L0:
       {
         {
         if(
         o instanceof Symbol
         ){
         sy = (Symbol)o;
         im = null;
         hy = null;
         break L0;
         }
         }
         {
         if(
         o instanceof AmImage
         ){
         sy = null;
         im = (AmImage)o;
         hy = null;
         break L0;
         }
         }
       sy = null;
       im = null;
       hy = (HyperElement)o;
       }
     }
    int width(int i, int j)
     {
     int w = 0;
      L1:
      for(
      int k = i; k <= j; k++
      )
       {
       getElement(k);
         {
         if(
         sy != null
         ){
         w += sy.width();
         continue L1;
         }
         }
       if(
       im != null
       ){
       w += im.width();
       continue;
       }
       }
     return(
     w
     );
     }
    public boolean isTrivial()
     {
      for(
      int i = 1; i < elements.size(); i++
      )
       {
       getElement(i);
         {
         if(
         im != null
         ){
         return(
         false
         );
         }
         }
       if(
       sy != null
       ){
       if(
       sy.c != ' '
       ){
       return(
       false
       );
       }
       }
       }
     return(
     true
     );
     }
    boolean isRichModel()
     {
      for(
      int i = 0, n = elements.size(); i < n; i++
      )
       {
       getElement(i);
         {
         if(
         (im != null) || (hy != null)
         ){
         return(
         true
         );
         }
         }
       if(
       (sy != null) && (((int)(sy.c)) > 255)
       ){
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    void insert(Symbol s, int i)
     {
     elements.insertElementAt(s, i);
     }
    void append(Symbol s)
     {
     elements.addElement(s);
     }
    void insert(AmImage im, int i)
     {
     elements.insertElementAt(im,i);
     }
    void insert(HyperElement hy, int i)
     {
     elements.insertElementAt(hy,i);
     }
    void remove(int i)
     {
       {
       if(
       elements.size() > 1
       ){
       elements.removeElementAt(i);
       }
       }
     }
    void removeAll()
     {
      for(
      ;elements.size() > 1;
      )
       {
       remove(1);
       }
     }
    Row makeCopy()
     {
     Row r = new Row(Default.foregroundColor);
      L2:
      for(
      int i = 0; i < elements.size(); i++
      )
       {
       getElement(i);
         {
         if(
         sy != null
         ){
         r.insert(new Symbol(sy.c, sy.font, sy.color), i+1);
         continue L2;
         }
         }
       if(
       im != null
       ){
       r.insert(im.makeCopy(), i+1);
       }
       }
     r.remove(0);
     r.planSize();
     return(
     (
     r
     )
     );
     }
    void trim()
     {
     int j;
     int i = 1;
     boolean isChanged = false;
      L3:
      for(;;)
       {
         {
         if(
         i == elements.size()
         ){
         break L3;
         }
         }
       getElement(i);
         {
         if(
         (sy == null) || !Character.isWhitespace(sy.c)
         ){
         j = elements.size() - 1;
          L4:
          for(;;)
           {
             {
             if(
             j == 0
             ){
             break L4;
             }
             }
           getElement(j);
             {
             if(
             (sy == null) || !Character.isWhitespace(sy.c)
             ){
             break L4;
             }
             }
           remove(j--); isChanged = true;
           }
         break L3;
         }
         }
       remove(i); isChanged = true;
       }
       {
       if(
       isChanged
       ){
       planSize();
       }
       }
     }
    public String toString()
     {
     StringBuffer t = new StringBuffer();
      for(
      int i = 1; i < elements.size(); i++
      )
       {
       getElement(i);
       if(
       sy != null
       ){
       t.append(sy.c);
       }
       }
     return(
     t.toString()
     );
     }
    public String toString(Color col)
     {
     StringBuffer t = new StringBuffer();
      for(
      int i = 1; i < elements.size(); i++
      )
       {
       getElement(i);
       if(
       sy != null
       ){
       if(
       sy.color != col
       ){
       t.append(sy.c);
       }
       }
       }
     return(
     t.toString()
     );
     }
    void plan(int x0, int y0)
     {
     x = x0; y = y0;
     }
    void planSize()
     {
     int h;
     prevW = width;
     prevH = height;
     width = 0;
     height = 0;
     maxDescent = 0;
      L5:
      for(
      int i = 0; i < elements.size(); i++
      )
       {
       getElement(i);
         {
         if(
         sy != null
         ){
         width += sy.width();
         int descent = sy.descent();
         h = sy.ascent() + descent;
           {
           if(
           h > height
           ){
           height = h;
           }
           }
           {
           if(
           descent > maxDescent
           ){
           maxDescent = descent;
           }
           }
         continue L5;
         }
         }
       if(
       im != null
       ){
       width += im.width();
       h = im.height();
       if(
       h > height
       ){
       height = h;
       }
       }
       }
     }
    public void draw(Graphics g)
     {
     prevX = x; prevY = y;
     prevW = width; prevH = height;
     int xx = x;
     int yy = y + height - maxDescent;
     int n = elements.size();
     getElement(0);
     g.setFont(sy.font);
     Character cc = new Character(sy.c);
      L6:
       {
         {
         if(
         n == 1
         ){
         g.setColor(sy.color);
         break L6;
         }
         }
       g.setColor(Default.backgroundColor);
       }
     g.drawString(cc.toString(), xx, yy);
     xx += sy.width();
      L7:
      for(
      int i = 1; i < n; i++
      )
       {
       getElement(i);
         {
         if(
         sy != null
         ){
         cc = new Character(sy.c);
         g.setFont(sy.font);
         g.setColor(sy.color);
         g.drawString(cc.toString(), xx, yy);
         xx += sy.width();
         continue L7;
         }
         }
       if(
       im != null
       ){
       im.draw(g, xx, y);
       xx += im.width();
       continue;
       }
       }
     }
    public Color isMonochrome()
     {
     Color color = ((Symbol)(elements.elementAt(0))).color;
      for(
      int j = 1; j < elements.size(); j++
      )
       {
       getElement(j);
         {
         if(
         sy == null
         ){
         return(
         null
         );
         }
         }
       if(
       sy.color != color
       ){
       return(
       null
       );
       }
       }
     return(
     color
     );
     }
    public void invalidate()
     {
     prevX = -1;
     }
    void toggleColor(int start, int end)
     {
      for(
      int i = start; i <= end; i++
      )
       {
       getElement(i);
       if(
       sy != null
       ){
       int R = sy.color.getRed() + 43;
       int G = sy.color.getGreen() + 161;
       int B = sy.color.getBlue() + 83;
         {
         if(
         R > 255
         ){
         R -= 255;
         }
         }
         {
         if(
         G > 255
         ){
         G -= 255;
         }
         }
         {
         if(
         B > 255
         ){
         B -= 255;
         }
         }
       sy.color = new Color(R, G, B);
       }
       }
     }
    void toggleColor()
     {
     toggleColor(0, elements.size()-1);
     }
    void setColor(int start, int end, Color col)
     {
      for(
      int i = start; i <= end; i++
      )
       {
       getElement(i);
       if(
       sy != null
       ){
       sy.color = col;
       }
       }
     }
    public void setColor(Color col)
     {
     setColor(0, elements.size()-1, col);
     }
    void setFont(int start, int end, Font font)
     {
      for(
      int i = start; i <= end; i++
      )
       {
       getElement(i);
       if(
       sy != null
       ){
       sy.font = font;
       }
       }
     planSize();
     }
    void setFont(Font font)
     {
     setFont(0, elements.size()-1, font);
     }
    void setStyle(int start, int end, Color col, Font font)
     {
      for(
      int i = start; i <= end; i++
      )
       {
       getElement(i);
       if(
       sy != null
       ){
       sy.color = col;
       sy.font = font;
       }
       }
     planSize();
     }
    void setStyle(Color col, Font font)
     {
     setStyle(0, elements.size()-1, col, font);
     }
    Row(String s)
     {
     int index_elements = 1;
     int index_str = 0;
     int str_begin = 0;
     int str_end = 0;
     boolean el0 = false;
     int i;
     String tmp_s = "";
     Color cur_color = new Color(0);
     Font cur_font = new Font("TimesRoman",0,10);
     elements = new Vector();
      L8:
      for(
      ;true;
      )
       {
       str_begin= s.indexOf("<font",str_begin);
         {
         if(
         str_begin == -1
         ){
           {
           if(
           el0 == false
           ){
           insert(new Symbol(Default.leadingChar,Default.font,Default.foregroundColor), 0);
           }
           }
         el0=true;
         break L8;
         }
         }
       index_str = s.indexOf(">",str_begin);
       str_begin = s.indexOf("\"#",str_begin) +2;
       str_end = s.indexOf("\"",str_begin);
       cur_color = HTMLStringtoColor(s.substring(str_begin,str_end));
       str_begin = s.indexOf("\"", str_end+1)+1;
       str_end = s.indexOf("\"",str_begin + 1);
       cur_font = HTMLStringtoFont(s.substring(str_begin, str_end));
         {
         if(
         el0 == false
         ){
         insert(new Symbol(Default.leadingChar,cur_font,cur_color), 0);
         el0=true;
         }
         }
       str_begin = index_str;
       str_end = s.indexOf("<", str_begin);
         {
         if(
         str_end == -1
         ){
         str_end = s.length();
         }
         }
       tmp_s = s.substring(str_begin+1, str_end);
       tmp_s = Replace(tmp_s,"&#60;","<");
       tmp_s = Replace(tmp_s,"&#62;",">");
        for(
        i=0;i<tmp_s.length();i++
        )
         {
         insert (new Symbol(tmp_s.charAt(i),cur_font,cur_color),index_elements++);
         }
       str_begin = str_end+1;
       if(
       str_begin>=s.length()
       ){
       break;
       }
       }
     width = 0; height = 0;
     x = -1;
     y = -1;
     width = -1;
     height = -1;
     planSize();
     }
    String Replace(String target,String s1,String s2)
     {
     int i=0;
     int str_begin=0;
     int str_end=0;
     String tmp_str = "";
     String ret = "";
      for(;;)
       {
       str_end = target.indexOf(s1, str_begin);
         {
         if(
         str_end == -1
         ){
         return(
         ret + target.substring(str_begin,target.length())
         );
         }
         }
       ret = ret + target.substring(str_begin, str_end)+s2;
       str_begin = str_end + s1.length();
       }
     }
    public String ColortoHTMLString(Color c)
     {
     String r;
     String g;
     String b;
     Integer tmp = new Integer(0);
     r=tmp.toHexString(c.getRed());
     g =tmp.toHexString(c.getGreen());
     b =tmp.toHexString(c.getBlue());
       {
       if(
       r.length()==1
       ){
       r = "0"+r;
       }
       }
       {
       if(
       g.length()==1
       ){
       g = "0"+g;
       }
       }
       {
       if(
       b.length()==1
       ){
       b = "0"+b;
       }
       }
     return(
     "\"#"+ r + g+ b +"\" "
     );
     }
    public String FonttoHTMLString(Font f)
     {
     return(
     "\""+f.getName()+"\""
     );
     }
    public Color HTMLStringtoColor(String s)
     {
     Integer tmp = new Integer(0);
     return(
     new Color(tmp.parseInt(s.substring(0,2),16),
     tmp.parseInt(s.substring(2,4),16),tmp.parseInt(s.substring(4,6),16))
     );
     }
    public Font HTMLStringtoFont(String s)
     {
     String tmp_str;
      for(
      int i=0;i<AmFont.n;i++
      )
       {
       if(
       s.equals(AmFont.font[i].getName())
       ){
       return(
       AmFont.font[i]
       );
       }
       }
     return(
     Default.font
     );
     }
    public String toHTMLString()
     {
     StringBuffer t = new StringBuffer();
     int i;
     boolean opened = false;
     String cur_color="" ;
     String cur_font="" ;
     String ret;
       {
       if(
       elements.size()<=1
       ){
       return(
       ""
       );
       }
       }
      L10:
      for(
      i = 1; i < elements.size(); i++
      )
       {
       getElement(i);
       if(
       sy != null
       ){
         {
         if(
         opened == false
         ){
         t.append("<font color = " +ColortoHTMLString(sy.color) + "face = " + FonttoHTMLString(sy.font) +">");
         opened = true;
          L9:
           {
             {
             if(
             sy.c == '<'
             ){
             t.append("&#60;");
             break L9;
             }
             }
             {
             if(
             sy.c == '>'
             ){
             t.append("&#62;");
             break L9;
             }
             }
           t.append(sy.c);
           }
         cur_color = ColortoHTMLString(sy.color);
         cur_font = FonttoHTMLString(sy.font);
         continue L10;
         }
         }
         {
         if(
         cur_color.compareTo(ColortoHTMLString(sy.color))!=0 || cur_font.compareTo(FonttoHTMLString(sy.font))!=0
         ){
         t.append("</font>");
         t.append("<font color = " +ColortoHTMLString(sy.color) + "face = " + FonttoHTMLString(sy.font) +">");
         cur_color = ColortoHTMLString(sy.color);
         cur_font = FonttoHTMLString(sy.font);
         }
         }
         {
         if(
         sy.c == '<'
         ){
         t.append("&#60;");
         continue L10;
         }
         }
         {
         if(
         sy.c == '>'
         ){
         t.append("&#62;");
         continue L10;
         }
         }
       t.append(sy.c);
       }
       }
     t.append("</font>");
     ret = t.toString();
     return(
     ret
     );
     }
    public void tag2Img()
     {
     String r=toString();
     //Row rida=this;
     Row rida=makeCopy();
     Color col; 
     //rida=new Row(r,col);
     removeAll();
     //rida.removeAll();
     int len=r.length();
     int co=1;
      L13:
      for(
      int i=0;i<len;i++
      )
       {
       //Symbol sym=new Symbol(r.charAt(i),col);
       rida.getElement(i);
       Symbol sym = rida.sy;
         {
         if(
         r.charAt(i)=='<'
         ){
          L12:
           {
             {
             if(
             r.charAt(i+1)=='I'
             ){
              L11:
               {
                 {
                 if(
                 (r.substring(i+2,i+10).compareTo("MG SCR= ")==0)
                 ){
                 int puk=r.indexOf('>',i);
                 String nimi=r.substring(i+10,puk);
                 Am.pictureBoard.processIMGs(this,co,nimi);
                 co++;
                 i=puk;
                 break L11;
                 }
                 }
               insert(sym,co);
               co++;
               }
             break L12;
             }
             }
           insert(sym,co);
           co++;
           }
         continue L13;
         }
         }
       insert(sym,co);
       co++;
       }
     planSize();
     return;
     }
    public void img2tag()
     {
     String str="";
     int j=0;
     String sss=this.toString();
     int pik=sss.length();
      L14:
      for(
      int i=1;i<elements.size();i++
      )
       {
       Object o=this.element(i);
         {
         if(
         o instanceof AmImage
         ){
         AmImage imi=(AmImage)o;
         String st="<IMG SCR= "+imi.location+"  >";
         str=str+st;
         continue L14;
         }
         }
       if(
       j<pik
       ){
       char cc=sss.charAt(j);
       j++;
       str=str+cc;
       }
       }
     Row rida=new Row(str,Default.foregroundColor);
     removeAll();
      for(
      int i = 1; i < rida.elements.size(); i++
      )
       {
       elements.addElement(rida.elements.elementAt(i));
       }
     planSize();
     return;
     }
   }
