 import java.awt.*;
  class Selection
   {
   AmCanvas c;
   Cursor start;
   Cursor end;
   transient Scheme parent;
   static final int NONE = 0;
   static final int PRIMITIVE2PRIMITIVE = 1;
   static final int SCHEME2PRIMITIVE = 2;
   static final int PRIMITIVE2SCHEME = 3;
   static final int SCHEME2SCHEME = 4;
   static final int SCHEMECOMMENT2SCHEMECOMMENT = 5;
   static final int OUTER = 6;
   static final int PRIMITIVE = 7;
   static final int PRIMITIVETEXT = 8;
   static final int PRIMITIVECOMMENT = 9;
    Selection(AmCanvas ca, Cursor c1, Cursor c2)
     {
     c = ca;
     start = c1; end = c2; 
     enableMenu();
     return;
     }
    Selection(Cursor c1, Cursor c2)
     {
     c = null;
     start = c1; end = c2;
     }
    public void enableMenu()
     {
     int kind = kind();
       {
       if(
       kind == NONE
       ){
       return;
       }
       }
     AmMenu menuBar = c.frame.menuBar;
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Delete(), true);
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Replace(), true);
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Cut(), true);
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Copy(), true);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Toggle(), true);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Enclose(), true);
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Textualize()+"<", true);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Toggle()+" "+
     AmLocale.text_color(), true);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Set()+" "+
     AmLocale.text_style(), true);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Default()+" "+
     AmLocale.text_color(), true);
      L0:
       {
         {
         if(
         ((kind == OUTER) ||
         ((kind == SCHEME2SCHEME) && (start.scheme == end.scheme)
         && (start.scheme instanceof Sketch)))
         ){
         menuBar.setEnabled(AmLocale.Tools(), true);
         break L0;
         }
         }
       menuBar.setEnabled(AmLocale.Tools(), false);
       }
      L1:
       {
         {
         if(
         ((kind == OUTER) ||
         ((kind == SCHEME2SCHEME) && (start.scheme == end.scheme)))
         ){
         menuBar.setEnabled(AmLocale.View(), true);
         menuBar.setEnabled(AmLocale.Base(), true);
         break L1;
         }
         }
       menuBar.setEnabled(AmLocale.View(), false);
       menuBar.setEnabled(AmLocale.Base(), false);
       }
     }
    void cancel()
     {
     AmMenu menuBar = c.frame.menuBar;
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Cut(), false);
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Copy(), false);
      L2:
       {
         {
         if(
         (Am.clipboard.obj == null)
         ){
         menuBar.setEnabled(AmLocale.Edit(), AmLocale.Paste(), false);
         menuBar.setEnabled(AmLocale.Edit(), "?"+AmLocale.Paste(), false);
         break L2;
         }
         }
       menuBar.setEnabled(AmLocale.Edit(), AmLocale.Paste(), true);
       menuBar.setEnabled(AmLocale.Edit(), "?"+AmLocale.Paste(), true);
       }
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Toggle(), false);
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Enclose(), false);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Toggle()+" "+
     AmLocale.text_color(), false);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Set()+" "+
     AmLocale.text_style(), false);
     menuBar.setEnabled(AmLocale.Edit(),AmLocale.Default()+" "+
     AmLocale.text_color(), false);
     menuBar.setEnabled(AmLocale.Edit(), AmLocale.Textualize()+"<", false);
     menuBar.setEnabled(AmLocale.Tools(), false);
     menuBar.setEnabled(AmLocale.View(), false);
     menuBar.setEnabled(AmLocale.Base(), false);
     start = null;
     end = null;
     }
    Scheme parent()
     {
      switch(
      kind()
      )
      {
       case
        PRIMITIVE:
       case
        PRIMITIVETEXT:
       case
        PRIMITIVE2PRIMITIVE:
       case
        PRIMITIVE2SCHEME:
       return(
       start.scheme
       );
       case
        SCHEME2PRIMITIVE:
       return(
       end.scheme
       );
       case
        SCHEME2SCHEME:
       return(
       start.scheme.parent
       );
      }
     return(
     null
     );
     }
    int kind()
     {
     int startIndex, endIndex;
       {
       if(
       ((start == null) || (end == null))
       ){
       return(
       NONE
       );
       }
       }
      L4:
       {
         {
         if(
         (start.scheme == end.scheme)
         ){
           {
             {
             if(
             (start.inScheme() && end.inScheme())
             ){
               {
               if(
               ((start.primitive == end.primitive) &&
               start.inPrimitive() &&
               !start.inTextComment() &&
               end.inTextComment()
               )
               ){
               return(
               PRIMITIVE
               );
               }
               }
               {
               if(
               ((start.primitive == end.primitive) &&
               start.inPrimitive() &&
               end.inPrimitive() &&
               !start.inTextComment() &&
               !end.inTextComment()
               )
               ){
               return(
               PRIMITIVETEXT
               );
               }
               }
               {
               if(
               ((start.primitive == end.primitive) &&
               start.inPrimitive() &&
               end.inPrimitive() &&
               start.inTextComment() &&
               end.inTextComment()
               )
               ){
               return(
               PRIMITIVECOMMENT
               );
               }
               }
               {
               if(
               (start.inSchemeComment() && end.inSchemeComment())
               ){
                 {
                 return(
                 SCHEMECOMMENT2SCHEMECOMMENT
                 );
                 }
               }
               }
               {
               if(
               (start.inBody() != end.inBody())
               ){
               return(
               NONE
               );
               }
               }
              L3:
               {
                 {
                 if(
                 (start.inBody())
                 ){
                 startIndex = start.scheme.body.indexOf(start.primitive);
                 endIndex = start.scheme.body.indexOf(end.primitive);
                 break L3;
                 }
                 }
               startIndex = start.scheme.head.indexOf(start.primitive);
               endIndex = start.scheme.head.indexOf(end.primitive);
               }
               {
               if(
               (startIndex < endIndex)
               ){
               return(
               PRIMITIVE2PRIMITIVE
               );
               }
               }
               {
               if(
               (startIndex == endIndex)
               ){
                 {
                 if(
                 (start.noInRow <= end.noInRow)
                 ){
                 return(
                 PRIMITIVE2PRIMITIVE
                 );
                 }
                 }
               }
               }
             return(
             NONE
             );
             }
             }
           if(
           (!start.inScheme() || !end.inScheme())
           ){
             {
               {
               if(
               (start.scheme.parent == null)
               ){
               return(
               OUTER
               );
               }
               }
             return(
             SCHEME2SCHEME
             );
             }
           }
           }
         break L4;
         }
         }
         {
         if(
         (start.scheme.parent == end.scheme)
         ){
           {
           if(
           (!end.inBody())
           ){
           return(
           NONE
           );
           }
           }
         startIndex = start.scheme.parent.body.indexOf(start.scheme);
         endIndex = end.scheme.body.indexOf(end.primitive);
           {
           if(
           (startIndex < endIndex)
           ){
           return(
           SCHEME2PRIMITIVE
           );
           }
           }
         return(
         NONE
         );
         }
         }
         {
         if(
         (start.scheme == end.scheme.parent)
         ){
           {
           if(
           (!start.inBody())
           ){
           return(
           NONE
           );
           }
           }
         startIndex = start.scheme.body.indexOf(start.primitive);
         endIndex = end.scheme.parent.body.indexOf(end.scheme);
           {
           if(
           (startIndex < endIndex)
           ){
           return(
           PRIMITIVE2SCHEME
           );
           }
           }
         return(
         NONE
         );
         }
         }
         {
         if(
         (start.scheme.parent != end.scheme.parent)
         ){
         return(
         NONE
         );
         }
         }
         {
         if(
         (start.scheme.parent == null)
         ){
         return(
         OUTER
         );
         }
         }
       startIndex = start.scheme.parent.body.indexOf(start.scheme);
       endIndex =  start.scheme.parent.body.indexOf(end.scheme);
       if(
       (startIndex <= endIndex)
       ){
       return(
       SCHEME2SCHEME
       );
       }
       }
     return(
     NONE
     );
     }
    Rectangle area()
     {
     int k = kind();
       {
       if(
       (k != NONE)
       ){
       Scheme a = start.scheme, b = end.scheme;
        switch(
        k
        )
        {
         case
          PRIMITIVE:
         return(
         new Rectangle(start.primitive.text.x-1,
         start.primitive.text.y-1,
         start.primitive.text.width+2,
         start.primitive.text.height+2)
         );
         case
          PRIMITIVETEXT:
         int x = start.row.x;
         int y = start.row.y;
         int h = end.row.y + end.row.height - start.row.y;
         int w = start.primitive.text.width(start.rowNo(), end.rowNo());
         return(
         new Rectangle(x-1, y-1, w+2, h+2)
         );
         case
          PRIMITIVECOMMENT:
         x = start.row.x;
         y = start.row.y;
         h = end.row.y + end.row.height - start.row.y;
         w = start.row.width;
         return(
         new Rectangle(x-1, y-1, w+2, h+2)
         );
         case
          PRIMITIVE2PRIMITIVE:
         x = start.primitive.text.x;
         y = start.primitive.text.y;
         h = end.primitive.text.y + end.primitive.text.height
         - start.primitive.text.y;
         w = start.primitive.text.width;
         int l;
          L6:
           {
             {
             if(
             (start.inBody())
             ){
             int i = start.scheme.body.indexOf(start.primitive);
             int j = end.scheme.body.indexOf(end.primitive);
              for(
              i = i+1; i <= j; i++
              )
               {
               Object o = start.scheme.member(i);
                L5:
                 {
                   {
                   if(
                   (o instanceof Sketch)
                   ){
                   l = ((Scheme)o).view.width;
                   break L5;
                   }
                   }
                 l = ((Primitive)o).text.width;
                 }
               if(
               (l > w)
               ){
               w = l;
               }
               }
             break L6;
             }
             }
           if(
           (start.inHead())
           ){
           int i = start.scheme.head.indexOf(start.primitive);
           int j = end.scheme.head.indexOf(end.primitive);
            for(
            i = i+1; i <= j; i++
            )
             {
             PrimitiveHead he = start.scheme.primitiveHead(i);
             l = he.text.width;
             if(
             (l > w)
             ){
             w = l;
             }
             }
           }
           }
         return(
         new Rectangle(x-1, y-1, w+2, h+2)
         );
         case
          SCHEME2PRIMITIVE:
         x = a.view.x;
         y = a.view.y;
         w = a.view.width;
         h = end.primitive.text.y +
         end.primitive.text.height - y;
         int i = a.parent.body.indexOf(a);
         int j = b.body.indexOf(end.primitive);
          for(
          i = i+1; i <= j; i++
          )
           {
           Object o = a.parent.member(i);
            L7:
             {
               {
               if(
               (o instanceof Sketch)
               ){
               l = ((Scheme)o).view.width;
               break L7;
               }
               }
               {
               if(
               (i < j)
               ){
               l = ((Primitive)o).text.width;
               break L7;
               }
               }
             l = ((Primitive)o).text.width(
             0,
             end.rowNo());
             }
           if(
           (l > w)
           ){
           w = l;
           }
           }
         return(
         new Rectangle(x-1, y-1, w+2, h+2)
         );
         case
          PRIMITIVE2SCHEME:
         x = start.primitive.text.x;
         y = start.primitive.text.y;
         w = start.primitive.text.width;
         h = b.view.y +
         b.view.height - y;
         j = b.parent.body.indexOf(b);
         i = a.body.indexOf(start.primitive);
          for(
          i = i+1; i <= j; i++
          )
           {
           Object o = a.member(i);
            L8:
             {
               {
               if(
               (o instanceof Sketch)
               ){
               l = ((Scheme)o).view.width;
               break L8;
               }
               }
             l = ((Primitive)o).text.width;
             }
           if(
           (l > w)
           ){
           w = l;
           }
           }
         return(
         new Rectangle(x-1, y-1, w+2, h+2)
         );
         case
          SCHEMECOMMENT2SCHEMECOMMENT:
         return(
         new Rectangle(a.comment.x-1, a.comment.y-1,
         a.comment.width+2, a.comment.height+2)
         );
         case
          SCHEME2SCHEME:
         case
          OUTER:
           {
           if(
           (a == b)
           ){
           return(
           new Rectangle(a.view.x-1, a.view.y-1,
           a.view.width+2, a.view.height+2)
           );
           }
           }
         x = a.view.x;
         y = a.view.y;
         w = a.view.width;
         h = b.view.y + b.view.height - y;
         i = a.parent.body.indexOf(a);
         j = b.parent.body.indexOf(b);
          for(
          i = i+1; i <= j; i++
          )
           {
           Object o = a.parent.member(i);
            L9:
             {
               {
               if(
               (o instanceof Sketch)
               ){
               l = ((Scheme)o).view.width;
               break L9;
               }
               }
             l = ((Primitive)o).text.width;
             }
           if(
           (l > w)
           ){
           w = l;
           }
           }
         return(
         new Rectangle(x-1, y-1, w+2, h+2)
         );
        }
       }
       }
     return(
     null
     );
     }
    public void expand()
     {
     int k = kind();
       {
       if(
       (start == end)
       ){
        L10:
         {
           {
           if(
           (start.inSchemeComment())
           ){
           start.row = null;
           break L10;
           }
           }
           {
           if(
           ((start.scheme instanceof Branch) &&
           (k == SCHEME2SCHEME))
           ){
           start.scheme = start.scheme.parent;
           start.moveToParentHome();
           start.row = null;
           end = start;
           break L10;
           }
           }
           {
           if(
           (k == PRIMITIVETEXT)
           ){
           end = start.makeCopy();
           end.moveToTextComment();
           break L10;
           }
           }
         if(
         (k == PRIMITIVECOMMENT)
         ){
         start = start.makeCopy();
         start.moveToPrimitiveText();
         }
         }
       enableMenu();
       }
       }
     }
    void convert2head(byte headType)
     {
     int k = kind();
       {
       if(
       ((k != PRIMITIVE2PRIMITIVE) &&
       (k != PRIMITIVETEXT))
       ){
       return;
       }
       }
     int istart = start.scheme.body.indexOf(start.primitive);
     int iend = start.scheme.body.indexOf(end.primitive);
     parent = parent();
     Sketch block =
     (Sketch)(parent.member(iend+1));
      for(
      int i = istart; i <= iend; i++
      )
       {
       Text t =
       ((PrimitiveMember)(parent.member(i))).text;
       PrimitiveHead h = new PrimitiveHead(headType, t);
       h.text = t;
       h.text.setColor(Default.sketchHeadColor);
       block.head.addElement(h);
       }
      for(
      int i = istart; i <= iend; i++
      )
       {
       parent.removeMember(istart);
       }
     }
    Sketch convert2simple()
     {
     return(
     convert2simple(1, 1)
     );
     }
    Sketch convert2simple(BaseLanguage bl)
     {
     return(
     convert2simple(1, 1, bl)
     );
     }
    Sketch convert2simple(int ii, int jj, BaseLanguage bl)
     {
     Sketch s = convert2simple(ii, jj);
       {
       if(
       (s != null)
       ){
       s.baseLanguage = bl;
       ((Branch)(s.member(0))).baseLanguage = bl;
       }
       }
     return(
     s
     );
     }
    Sketch convert2simple(int ii, int jj)
     {
     int kind = kind();
       {
       if(
       (start.inHead() || (kind == NONE) || (kind == OUTER))
       ){
       return(
       null
       );
       }
       }
     Sketch newMember = new Sketch(Scheme.SIMPLE,
     new Branch(Scheme.SIMPLE, null),
     null);
     parent = parent();
     newMember.parent = parent;
     Branch br = newMember.branch(0);
     int istart = 0;
     int iend = 0;
      switch(
      kind
      )
      {
       case
        PRIMITIVE:
       case
        PRIMITIVETEXT:
       case
        PRIMITIVE2PRIMITIVE:
       istart = parent.body.indexOf(start.primitive);
       iend = parent.body.indexOf(end.primitive);
       break;
       case
        SCHEME2PRIMITIVE:
       istart = parent.body.indexOf(start.scheme);
       iend = parent.body.indexOf(end.primitive);
       break;
       case
        PRIMITIVE2SCHEME:
       istart = parent.body.indexOf(start.primitive);
       iend = parent.body.indexOf(end.scheme);
       break;
       case
        SCHEME2SCHEME:
       istart = parent.body.indexOf(start.scheme);
       iend = parent.body.indexOf(end.scheme);
       break;
      }
     int k = 1;
      L11:
      for(
      int i = istart+ii; i <= iend-jj; i++
      )
       {
       Object o = parent.member(i);
         {
         if(
         (o instanceof PrimitiveMember)
         ){
         br.insert((PrimitiveMember)o, k++);
         continue L11;
         }
         }
       br.insert((Sketch)o, k++);
       }
     br.removeMember(0);
     parent.insert(newMember, iend+1);
      for(
      int i = istart; i <= iend; i++
      )
       {
       parent.removeMember(istart);
       }
     newMember.incrementArrows(newMember.level(), 1);
     return(
     newMember
     );
     }
    public String toString(Color col)
     {
     parent = parent();
     StringBuffer t = new StringBuffer();
     int istart = start.scheme.body.indexOf(start.primitive);
     int iend = start.scheme.body.indexOf(end.primitive);
      for(
      int i = istart; i <= iend; i++
      )
       {
       Primitive p = (Primitive)(parent.member(i));
       t.append(p.text.toString(col));
       }
     return(
     t.toString()
     );
     }
    private void bite(int xx, Graphics g)
     {
     int x, y, w, h;
       {
       if(
       (start == end)
       ){
       return;
       }
       }
       {
       if(
       (start.noInRow > 1)
       ){
       x = start.row.x-1;
       y = start.row.y-1;
       w = start.row.width(0, start.noInRow-1)+2;
       h = start.row.height+2;
        L12:
         {
           {
           if(
           (Default.selectionFill)
           ){
           g.fillRect(x, y, w, h);
           break L12;
           }
           }
         g.drawRect(x, y, w, h);
         }
       }
       }
       {
       int first = end.noInRow;
       int last = end.row.elements.size();
       if(
       (first <= last)
       ){
       int w1 = end.row.width(0, first-1);
       x = end.row.x-1 + w1;
       y = end.row.y-1;
       w = xx - (end.row.x - 2 + w1 + 4)+2;
       h = end.row.height+2;
        L13:
         {
           {
           if(
           (Default.selectionFill)
           ){
           g.fillRect(x, y, w, h);
           break L13;
           }
           }
         g.drawRect(x, y, w, h);
         }
       }
       }
     }
    public void draw(Graphics g)
     {
     g.setColor(Default.selectionColor);
     g.setXORMode(Default.backgroundColor);
     Rectangle r = area();
       {
       if(
       r == null
       ){
       return;
       }
       }
      L14:
       {
         {
         if(
         (Default.selectionFill)
         ){
         g.fillRect(r.x, r.y, r.width, r.height);
         break L14;
         }
         }
       g.drawRect(r.x, r.y, r.width, r.height);
       }
      switch(
      kind()
      )
      {
       case
        PRIMITIVETEXT:
       case
        PRIMITIVECOMMENT:
       case
        SCHEMECOMMENT2SCHEMECOMMENT:
       bite(r.x+r.width+1, g);
       break;
       default
       :
       {
       break;
       }
      }
     g.setPaintMode();
     }
    public void drawx(Graphics g)
     {
     g.setColor(Default.selectionColor);
     g.setXORMode(Default.backgroundColor);
     Rectangle r = area();
      L15:
       {
         {
         if(
         (Default.selectionFill)
         ){
         g.fillRect(r.x, r.y, r.width, r.height);
         break L15;
         }
         }
       g.drawRect(r.x, r.y, r.width, r.height);
       }
      switch(
      kind()
      )
      {
       case
        PRIMITIVETEXT:
       case
        PRIMITIVECOMMENT:
       case
        SCHEMECOMMENT2SCHEMECOMMENT:
       bite(r.x+r.width+1, g);
       break;
       default
       :
       {
       break;
       }
      }
     g.setPaintMode();
     }
    Selection makeCopy()
     {
     Cursor cur = start.makeCopy();
       {
       if(
       (start == end)
       ){
       return(
       new Selection(c, cur, cur)
       );
       }
       }
     return(
     new Selection(c, cur, end.makeCopy())
     );
     }
   }
