 import java.util.*;
 import java.awt.*;
  class Text extends Rectangle
   {
   Row comment;
   Vector rows;
    Text()
     {
     rows = new Vector();
     Row r = new Row(Default.foregroundColor);
     rows.addElement(r);
     comment = new Row(Default.commentColor);
     plan(0, 0);
     }
    Text(Color col)
     {
     rows = new Vector();
     Row r = new Row(col);
     rows.addElement(r);
     comment = new Row(Default.commentColor);
     plan(0, 0);
     }
    Row row(int i)
     {
     return(
     (Row)rows.elementAt(i)
     );
     }
    void insert(Row r, int i)
     {
     rows.insertElementAt(r, i);
     }
    void remove(int i)
     {
     if(
     (rows.size() > 1)
     ){
     rows.removeElementAt(i);
     }
     }
    void plan(int x0, int y0)
     {
     x = x0; y = y0;
     Row r = null;
     height = 0;
     width = 0;
     int w;
     int n = rows.size();
      for(
      int i = 0; i < n; i++
      )
       {
       r = row(i);
       r.plan(x0, y0);
       height += r.height;
       y0 += r.height;
       w = r.width;
         {
         if(
         (i == (n-1))
         ){
         w += comment.width;
         }
         }
       if(
       (w > width)
       ){
       width = w;
       }
       }
     comment.plan(x0 + r.width, r.y);
     }
    void draw(Graphics g)
     {
      for(
      Enumeration e = rows.elements(); e.hasMoreElements();
      )
       {
       Row r = (Row)(e.nextElement());
       r.draw(g);
       }
     comment.draw(g);
     }
    Text makeCopy()
     {
     Text t = new Text();
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       t.insert(row(i).makeCopy(), i+1);
       }
     t.remove(0);
     t.comment = comment.makeCopy();
     t.plan(0, 0);
     return(
     t
     );
     }
    void trim()
     {
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       row(i).trim();
       }
     comment.trim();
     }
    void joinRow(int i)
     {
       {
       if(
       i == 0
       ){
       return;
       }
       }
       {
       if(
       i > rows.size()-1
       ){
       return;
       }
       }
     Row givenrow = row(i);
     Row prevrow =  row(i-1);
     int j = prevrow.elements.size()-1;
      for(
      int k = 1; k < givenrow.elements.size(); k++
      )
       {
       givenrow.getElement(k);
       prevrow.insert(givenrow.sy, ++j);
       }
     rows.removeElementAt(i);
     prevrow.planSize();
     }
    void splitRow(int i, int x)
     {
     Row givenrow = row(i);
     givenrow.getElement(x-1);
     Row nextrow = new Row(givenrow.sy.font, givenrow.sy.color);
     insert(nextrow, i+1);
     int z = 1;
     int y = 0;
      for(
      int k = x; k < givenrow.elements.size(); k++
      )
       {
       y++;
       givenrow.getElement(k);
       nextrow.insert(givenrow.sy, z++);
       }
      for(
      ;(--y >= 0);
      )
       {
       givenrow.remove(x);
       }
     givenrow.planSize();
     nextrow.planSize();
     }
    String toString(Color col)
     {
     StringBuffer t = new StringBuffer();
      for(
      Enumeration e = rows.elements(); e.hasMoreElements();
      )
       {
       Row r = (Row)(e.nextElement());
       t.append(r.toString(col)+" ");
       }
     return(
     t.toString()
     );
     }
    public String toString()
     {
     StringBuffer t = new StringBuffer();
     int i;
      for(
      i = 0; i < (rows.size()-1); i++
      )
       {
       Row r = row(i);
       t.append(r.toString()+"\n");
       }
     t.append(row(i).toString());
     return(
     t.toString()
     );
     }
    boolean isMonochrome(Color color)
     {
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       Row r = row(i);
        for(
        int j = 0; j < r.elements.size(); j++
        )
         {
         r.getElement(j);
           {
           if(
           (r.sy == null)
           ){
           return(
           false
           );
           }
           }
         if(
         (r.sy.color != color)
         ){
         return(
         false
         );
         }
         }
       }
     return(
     true
     );
     }
    Color isMonochrome()
     {
     Color color = row(0).isMonochrome();
       {
       if(
       (color == null)
       ){
       return(
       null
       );
       }
       }
      for(
      int i = 1; i < rows.size(); i++
      )
       {
       if(
       (row(i).isMonochrome() != color)
       ){
       return(
       null
       );
       }
       }
     return(
     color
     );
     }
    boolean isRichModel()
     {
       {
       if(
       comment.isRichModel()
       ){
       return(
       true
       );
       }
       }
      for(
      int i = 0, n = rows.size(); i < n;  i++
      )
       {
       if(
       row(i).isRichModel()
       ){
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    boolean isTrivial()
     {
      for(
      Enumeration e = rows.elements(); e.hasMoreElements();
      )
       {
       if(
       (!((Row)(e.nextElement())).isTrivial())
       ){
       return(
       false
       );
       }
       }
     return(
     true
     );
     }
    int width(int i)
     {
     int w = 0;
      for(
      ; i < rows.size(); i++
      )
       {
       int l = row(i).width;
       if(
       (l > w)
       ){
       w = l;
       }
       }
     return(
     w
     );
     }
    int width(int i, int j)
     {
     int w = 0;
      for(
      ; i <= j; i++
      )
       {
       int l = row(i).width;
       if(
       (l > w)
       ){
       w = l;
       }
       }
     return(
     w
     );
     }
    void invalidate()
     {
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       row(i).invalidate();
       }
     comment.invalidate();
     }
    void toggleColor(boolean comm)
     {
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       row(i).toggleColor();
       }
       {
       if(
       (comm)
       ){
       comment.toggleColor();
       }
       }
     }
    void setColor(Color col)
     {
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       row(i).setColor(col);
       }
     }
    void setColor(Color col, Color commcol)
     {
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       row(i).setColor(col);
       }
     comment.setColor(commcol);
     }
    void setStyle(Color col, Font font)
     {
      for(
      int i = 0; i < rows.size(); i++
      )
       {
       row(i).setStyle(col, font);
       }
     }
    public void img2tag()
     {
      for(
      int i=0;i<rows.size();i++
      )
       {
       row(i).img2tag();
       }
     }
    public void tag2Img()
     {
     int len=rows.size();
      for(
      int i=0;i<rows.size();i++
      )
       {
       row(i).tag2Img();
       }
     }
   }
