 import java.util.*;
 import java.awt.*;
  class UndoSetStyleInRow extends Undo
   {
   Row r;
   Selection keepSelection;
   Vector colors;
   Vector fonts;
   int i;
   int j;
    UndoSetStyleInRow(Selection sel, Row rr, int ii, int jj)
     {
     keepSelection = sel.makeCopy();
     r = rr;
     i = ii;
     j = jj;
     colors = new Vector();
     fonts = new Vector();
      for(
      int k = i; k <= jj; k++
      )
       {
       r.getElement(k);
       if(
       (r.sy != null)
       ){
       colors.addElement(r.sy.color);
       fonts.addElement(r.sy.font);
       }
       }
     }
    public  void undo(Editor ed)
     {
      L0:
       {
         {
         if(
         ed.isRedoing
         ){
         ed.stack.push(new UndoSetStyleInRow(keepSelection,r,i,j));
         break L0;
         }
         }
       ed.redoStack.push(new UndoSetStyleInRow(keepSelection,r,i,j));
       }
      for(
      int m = 0, k = i; k <= j; k++, m++
      )
       {
       r.getElement(k);
       if(
       (r.sy != null)
       ){
       r.sy.color = (Color)(colors.elementAt(m));
       r.sy.font = (Font)(fonts.elementAt(m));
       }
       }
     }
   }
