 import java.util.*;
 import java.awt.*;
  class ViewDTree extends View
   {
   static Color color = Default.sketchLineColor;
   static Color colorBr = Default.branchHeadColor;
   static Color colorLine = Color.lightGray;
   static int iconw;
   static int iconh;
   static int laius;
   static int fontSize = Default.font.getSize();
   static final int vd = fontSize;
   static int h = fontSize-6;
   static int w =  (3*h)/2;
   static int hp = h-2;
   static int dp = hp/2+4;
   static int hd = w;
    ViewDTree(Scheme s)
     {
     super(s);
     type = View.DTREE;
     }
    public Rectangle getLineArea(Scheme s)
     {
     return(
     new Rectangle(s.view.x, s.view.y, hd, s.view.height)
     );
     }
    private void drawSkLine(Graphics g, Scheme s)
     {
     Rectangle rk = getLineArea(s);
     int xx= rk.x, yy=rk.y,  korgus=rk.height;laius=rk.width;
     int xja = xx-dp;
     int dd = (s.comment.width == 0)? 0 :
     vd;
     int yja = yy + (s.comment.height - dd) / 2;
     int yjl = yy + korgus - 8;
     g.setColor(colorLine);
       {
       if(
       (s.level()!=0 && (s.parent.view.type == View.DTREE))
       ){
       g.drawLine(xja, yja + dp-4, xja+dp, yja + dp-4);
       }
       }
     g.drawLine(xja+dp+1+w/2, yja+h, xja+dp+1+ w/2, yjl);
     g.drawLine(xja+dp+1-3+w/2,yjl+4,xja+dp+1+w/2,yjl);
     g.drawLine(xja+dp+1+w/2,yjl,xja+dp+1+w/2+3,yjl+4);
      L0:
       {
         {
         if(
         (s instanceof Branch)
         ){
         g.setColor(colorBr);
         break L0;
         }
         }
       g.setColor(color);
       }
      switch(
      s.type
      )
      {
       case
        Scheme.LOOP:
       case
        Scheme.MODULE:
       int vahe;
        L1:
         {
           {
           if(
           (s.type == Scheme.MODULE)
           ){
           vahe = 1;
           break L1;
           }
           }
         vahe =2;
         }
       g.drawRect(xja+dp+1 ,yja-1, w, h);
       g.drawRect(xja+dp+1+vahe , yja-1+vahe , 
                                     w-2*vahe , h-2*vahe);
       break;
       default
       :
       {
       g.drawRect(xja+dp+1 ,yja-1, w , h);
       break;
       }
      }
     }
    public void  plan(int x0, int y0)
     {
       {
       if(
        (sk.icon)
       ){
       x = x0 + 1;
       width = w+3;
       height = w+3;
       int dd1 = (sk.comment.width == 0)? 0 :
       vd;
       y = y0 + (sk.comment.height - dd1);
       return;
       }
       }
     int yy= y0 ;
     int ww = 0;
     sk.comment.y = yy+h-vd+3 ;
     sk.comment.x = x0+w+3;
     yy += (4*vd)/3;
       {
       if(
       (sk.comment.width > ww)
       ){
       ww = sk.comment.width;
       }
       }
       {
       if(
       (sk.head.size() != 0)
       ){
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
         he.text.plan(x0+w+3, yy);
         yy += he.text.height+vd/3;
         if(
         (he.text.width > ww)
         ){
         ww = he.text.width;
         }
         }
       yy += vd/2;
       }
       }
      L2:
      for(
      int i = 0; i < sk.body.size(); i++
      )
       {
       Object o = sk.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme ss = (Scheme)o;
           {
           ss.view.plan(x0+hd, yy);
           if(
           (ss.view.width > ww)
           ){
           ww = ss.view.width;
           }
           }
         yy += ss.view.height + vd/3 ;
         continue L2;
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
       ns.text.plan(x0+w+3 , yy);
       yy += ns.text.height + vd/3;
       if(
       (ns.text.width > ww)
       ){
       ww = ns.text.width;
       }
       }
     x = x0; y = y0;
     width = ww+hd;
     height = yy-y0;
     }
    public void  draw(Graphics g)
     {
     Scheme s = super.sk;
       {
       if(
       (s.icon)
       ){
       g.setColor(colorLine);
       g.drawLine(x-hp/2-4, y + hp/2, x, y + hp/2);
        L3:
         {
           {
           if(
           (s instanceof Sketch)
           ){
           g.setColor(color);
           break L3;
           }
           }
         g.setColor(colorBr);
         }
        switch(
        s.type
        )
        {
         case
          Scheme.LOOP:
         case
          Scheme.MODULE:
         int vahe;
          L4:
           {
             {
             if(
             (s.type == Scheme.MODULE)
             ){
             vahe = 1;
             break L4;
             }
             }
           vahe = 2;
           }
         g.drawRect(x+1 ,y-1, w, h);
         g.drawRect(x+1+vahe , y-1+vahe , w-2*vahe , h-2*vahe);
         g.drawLine(x+1, y-1,x+1+w,y-1+h);
         break;
         default
         :
         {
         g.drawRect(x+1 ,y-1, w , h);
         g.drawLine(x+1, y-1,x+1+w,y-1+h);
         break;
         }
        }
        L5:
         {
           {
           if(
           (!s.comment.isTrivial())
           ){
           g.setColor(Default.commentColor);
           g.drawString(s.comment.toString(),x + 2*hd+8,y + h );
           break L5;
           }
           }
         if(
         (s.head.size() != 0)
         ){
          L6:
           {
             {
             if(
             (s instanceof Sketch)
             ){
             g.setColor(color);
             break L6;
             }
             }
           g.setColor(colorBr);
           }
         g.drawString(s.primitiveHead(0).text.row(0).toString(),
         x + 2*hd + 8 , y + h);
         }
         }
       int X=x,Y=y+h/2-1;
        L7:
         {
           {
           if(
           (s instanceof Sketch)
           ){
           drawArrowsForIcon(g,(Sketch)s,X,Y,s.level());
           break L7;
           }
           }
         int m = s.body.size();
          for(
           int j=0;j<m;j++
          )
           {
           Object o = ((Branch)s).member(j);
             {
             if(
             (o instanceof Sketch)
             ){
             drawArrowsForIcon(g, (Sketch)o,X,Y,s.level());
             }
             }
           if(
           (o instanceof Arrow)
           ){
           drawIconArrow(g,(Branch)s,(Arrow)o,X,Y,s.level());
           }
           }
         }
       return;
       }
       }
       {
       drawSkLine(g,s);
       s.comment.draw(g);
       }
     int yy = s.comment.height + (2*vd)/3-2;
     int x1 = x + hd/2 + 2;
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead he = (PrimitiveHead)(e.nextElement());
       he.text.draw(g);
       g.setColor(color);
        switch(
         he.type
        )
        {
         case
          PrimitiveHead.LOOP:
         g.setFont(Default.font);
         g.drawString("*", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.SWITCH:
         g.setFont(Default.font);
         g.drawString("??", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CASE:
         case
          PrimitiveHead.DEFAULT:
         g.setFont(Default.font);
         g.drawString("?", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.TRY:
         g.setFont(Default.font);
         g.drawString("!!", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CATCH:
         case
          PrimitiveHead.FINALLY:
         g.setFont(Default.font);
         g.drawString("!", x1, y+yy + he.text.height*3/4);
         break;
        }
       yy += he.text.height;
       }
      L8:
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Object o = e.nextElement();
         {
         if(
         (o instanceof Scheme)
         ){
         ((Scheme)o).view.draw(g);
         continue L8;
         }
         }
         {
         if(
          (o instanceof Arrow)
         ){
         Arrow ar = (Arrow)o;
         ar.text.draw(g);
         Scheme sc =ar.destination((Branch)s);
         int endx = sc.view.x+w/2+2;
         int yy0=ar.text.y+((Row)(ar.text.rows.elementAt(0))).height/2+2;
          L9:
           {
             {
             if(
              (ar.type == Arrow.WEAK)
             ){
             drawWeakArrow(g,ar.text.x,yy0,endx);
             break L9;
             }
             }
           drawStrongArrow(g,ar.text.x,yy0,endx);
           }
         continue L8;
         }
         }
       if(
       (o instanceof PrimitiveMember)
       ){
       PrimitiveMember ns = (PrimitiveMember)o;
        switch(
         ns.type
        )
        {
         case
          Primitive.CONDITION:
         g.setFont(Default.font);
         g.setColor(Default.conditionColor);
         g.drawString("?", x1, ns.text.y + ns.text.height*3/4);
         break;
        }
       ns.text.draw(g);
       }
       }
     }
    private void drawStrongArrow(Graphics g, int startX, int Y,int endX)
     {
     g.setColor(Default.arrowColor);
     g.drawLine(startX, Y, endX,Y);
     g.drawLine(endX,Y,endX+4,Y-2);
     g.drawLine(endX,Y,endX+4,Y+2);
     }
    private void drawWeakArrow(Graphics g, int startX, int Y,int endX)
     {
     g.setColor(Default.arrowColor);
      for(
      int i=endX;i<startX;i+=laius*2/3
      )
       {
       g.drawLine(i,Y,i+laius/3,Y);
       }
     g.drawLine(endX,Y,endX+4,Y-2);
     g.drawLine(endX,Y,endX+4,Y+2);
     }
    private void drawArrowsForIcon(Graphics g, Sketch s,int X,int Y, int iconLevel)
     {
     int n=s.body.size();
      for(
       int i=0 ;i<n; i++
      )
       {
       Branch br=s.branch(i);
       int m= br.body.size();
        for(
        int j=0;j<m;j++
        )
         {
         Object o=br.member(j);
           {
           if(
           (o instanceof Sketch)
           ){
           drawArrowsForIcon(g,(Sketch)o,X,Y,iconLevel);
           }
           }
         if(
         (o instanceof Arrow)
         ){
         drawIconArrow(g,br,(Arrow)o,X,Y,iconLevel);
         }
         }
       }
     }
    private void drawIconArrow(Graphics g, Branch br,Arrow ar,int X,int Y, int iconLevel)
     {
     int endX;
     Scheme sc = ar.destination(br);
       {
       if(
       (sc.level()>=iconLevel)
       ){
       return;
       }
       }
     endX = sc.view.x+w/2+2;
      L10:
       {
         {
         if(
         (ar.type ==Arrow.WEAK)
         ){
         drawWeakArrow(g,X,Y,endX);
         break L10;
         }
         }
       drawStrongArrow(g,X,Y,endX);
       }
     }
    public void pointLocation(Point p, Scheme s)
     {
       {
       if(
       (result != null)
       ){
       return;
       }
       }
       {
       if(
       (!s.view.contains(p))
       ){
       return;
       }
       }
       {
       if(
       (s.icon)
       ){
       result = new Cursor(s);
       return;
       }
       }
      L11:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme sk = (Scheme)o;
         pointLocation(p, sk);
           {
           if(
           (result != null)
           ){
           return;
           }
           }
         continue L11;
         }
         }
       result = new Cursor(s);
       System.out.println("ViewSketchy: on mitteskeem");
         {
         if(
         (pointLocation(p, ((PrimitiveMember)o).text))
         ){
         System.out.println("ViewSketchy: punkt on mitteskeemis");
         result.primitive = (PrimitiveMember)o;
         result.noInRow = 1;
         Row r = result.row;
         int shift = (((Symbol)r.elements.elementAt(0)))
         .width();
          L12:
          for(
          i = 1; i < r.elements.size(); i++
          )
           {
             {
             if(
             ((r.x + shift) > p.x)
             ){
             break L12;
             }
             }
           result.noInRow++;
           r.getElement(i);
             {
             if(
             (r.sy != null)
             ){
             shift += r.sy.width();
             continue L12;
             }
             }
           ;
           }
         return;
         }
         }
       System.out.println("ViewSketchy: punkt pole mitteskeemis");
       result = null;
       }
       {
       if(
       (getLineArea(s).contains(p))
       ){
       result = new Cursor(s);
       return;
       }
       }
     result = new Cursor(s);
       {
       if(
       (pointLocation(p, s.comment))
       ){
       result.primitive = null;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0)))
       .width();
        L13:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L13;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L13;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     result = new Cursor(s);
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead h = (PrimitiveHead)(e.nextElement());
       if(
       (pointLocation(p, h.text))
       ){
       result.primitive = h;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0)))
       .width();
        L14:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L14;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L14;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     }
    void adjustComment(AmCanvas c,
    int oldW, int oldH, int caretShift)
     {
     c.frame.contents.affected = sk;
      L15:
       {
         {
         if(
         (sk instanceof Sketch)
         ){
         sk.invalidate(x + oldW);
         c.X = sk.comment.x + c.start.x;
         c.Y = y - sk.comment.height/2 + c.start.y;
         c.W = oldW  + 2;
         c.H = height + sk.comment.height;
         break L15;
         }
         }
       c.X = sk.comment.x + caretShift;
       c.W = oldW - caretShift + 2;
         {
         if(
         (sk.comment.elements.size() == 1)
         ){
         c.X = sk.comment.x;
         c.W = oldW + 2;
         }
         }
       c.X = c.X + c.start.x;
       c.Y = sk.comment.y + c.start.y;
       c.H = oldH;
       }
     }
    void adjustTextComment(AmCanvas c, Row comm,
    int oldW, int oldH, int caretShift)
     {
     c.frame.contents.affected = sk;
     c.X = comm.x + caretShift;
     c.W = oldW - caretShift + 2;
       {
       if(
       (comm.elements.size() == 1)
       ){
       c.X = comm.x;
       c.W = oldW + 2;
       }
       }
     c.X = c.X + c.start.x;
     c.Y = comm.y + c.start.y - 2;
     c.H = oldH + 4;
     }
    void adjustText(AmCanvas c, Text t, Row r,
    int oldW, int oldH, int caretShift)
     {
     c.frame.contents.affected = sk;
     int wadd = 0;
       {
       if(
       (t.rows.indexOf(r) == t.rows.size()-1)
       ){
       wadd = t.comment.width;
       }
       }
     c.X = r.x + caretShift;
     c.W = oldW - caretShift + wadd + 2;
       {
       if(
       (r.elements.size() == 1)
       ){
       c.X = r.x;
       c.W = oldW + wadd + 2;
       }
       }
     c.X += c.start.x;
     c.Y = r.y + c.start.y;
     c.H = oldH;
     }
    void adjustText(AmCanvas c, Text t, Row r)
     {
     r.invalidate();
     c.prepare(r.y-2);
     }
    void adjustText(AmCanvas c, Text t, Row r1, Row r2,
    int oldW, int oldH)
     {
     c.X = r1.x + c.start.x;
     c.Y = r1.y + c.start.y - 2;
     int i = t.rows.indexOf(r1);
     int j = t.rows.indexOf(r2);
     c.W = t.width(i,j);
     int cw = t.comment.width;
       {
       if(
       ((j == t.rows.size()-1)
       && ((r2.width + cw) > c.W))
       ){
       c.W = r2.width + cw;
       }
       }
     c.W = Math.max(c.W, oldW);
     c.H = r2.y - r1.y + 1 + r2.height;
     c.H = Math.max(c.H, oldH);
      for(
      int k = i; k < j; k++
      )
       {
       (t.row(k)).invalidate();
       }
     }
    void adjustIcon(AmCanvas c)
     {
      switch(
      c.selection.kind()
      )
      {
       case
        Selection.PRIMITIVE2PRIMITIVE:
       c.prepare(c.selection.start.primitive.text.y - 4);
       break;
       case
        Selection.SCHEME2PRIMITIVE:
       c.prepare(c.selection.start.scheme.view.y - 4);
       break;
       case
        Selection.PRIMITIVE2SCHEME:
       c.prepare(c.selection.start.primitive.text.y - 4);
       break;
       case
        Selection.SCHEME2SCHEME:
       c.prepare(c.selection.start.scheme.view.y - 4);
       break;
       default
       :
       {
       return;
       }
      }
     }
    void adjust(AmCanvas c, Primitive p, boolean cut)
     {
     c.prepare(p.text.y - 2);
     }
    void adjust(AmCanvas c, Scheme s, boolean cut)
     {
     c.prepare(s.view.y - 2);
     }
    void adjust(AmCanvas c, Primitive p, Scheme affected)
     {
     Rectangle rec =
     affected.view.getLineArea(
     affected);
     c.X = rec.x;
     c.Y = p.text.y;
     c.W = p.text.x +
     p.text.width - rec.x;
     c.H = p.text.height;
     p.text.invalidate();
     c.frame.contents.affected = affected;
     c.X += c.start.x; c.Y += c.start.y;
     }
    void adjustArrowMap(AmCanvas c, Arrow ar, boolean prolonged)
     {
      L16:
       {
         {
         if(
         (prolonged)
         ){
         int len = sk.level() - ar.level;
         Scheme x = sk;
          for(
          int i = 0; i < len; i++
          )
           {
           x = x.parent;
           }
           {
           if(
           (x instanceof Branch)
           ){
           x = x.parent;
           }
           }
         c.frame.contents.affected = x;
         c.X = x.view.x + c.start.x;
         c.Y = ar.text.y + c.start.y;
         c.W = ar.text.x - x.view.x;
         c.H = ar.text.height + 2;
         break L16;
         }
         }
       int len = sk.level() - ar.level + 1;
       Scheme x = sk;
        for(
        int i = 0; i < len; i++
        )
         {
         x = x.parent;
         }
         {
         if(
         (x instanceof Branch)
         ){
         x = x.parent;
         }
         }
       c.frame.contents.affected = x;
       c.X = x.view.x + c.start.x;
       c.Y = ar.text.y + c.start.y;
       c.W = ar.text.x - x.view.x;
       c.H = ar.text.height + 2;
       }
     }
    public void adjustSchemeMap(AmCanvas c, Scheme s)
     {
       {
       if(
       (s instanceof Branch)
       ){
       s = s.parent;
       }
       }
     Rectangle rec = getLineArea(s);
     c.X = rec.x + c.start.x;
     c.Y = rec.y + c.start.y;
     c.W = rec.width;
     c.H = rec.height+2;
     c.frame.contents.affected = s;
     }
    void adjustSelection(AmCanvas c, Selection sel)
     {
     c.frame.contents.affected = sel.start.scheme;
      switch(
      sel.kind()
      )
      {
       case
        Selection.PRIMITIVETEXT:
       sel.start.primitive.text.invalidate();
       break;
       case
        Selection.PRIMITIVECOMMENT:
       sel.start.primitive.text.comment.invalidate();
       break;
       case
        Selection.SCHEMECOMMENT2SCHEMECOMMENT:
       Scheme s = sel.start.scheme;
       s.invalidateRest(s.view.y - 4);
       Rectangle rec = sel.area();
       c.X = rec.x + c.start.x;
       c.W = rec.width;
       Selection sx = new Selection(
       new Cursor(s), new Cursor(s));
       rec = sx.area();
       c.Y = rec.y + c.start.y;
       c.H = rec.height;
       return;
       case
        Selection.PRIMITIVE2PRIMITIVE:
       break;
       case
        Selection.SCHEME2PRIMITIVE:
       break;
       case
        Selection.PRIMITIVE2SCHEME:
       break;
       case
        Selection.SCHEME2SCHEME:
       break;
      }
     Rectangle rec = sel.area();
     c.X = rec.x + c.start.x;
     c.Y = rec.y + c.start.y;
     c.W = rec.width;
     c.H = rec.height;
     }
   }
