 import java.awt.*;
 import java.awt.event.*;
 import java.util.*;
  class AmMouseListener implements MouseListener
   {
   AmCanvas c;
   transient boolean newSelection;
   transient boolean oldSelection;
   transient int selectedLevel, currentLevel;
   transient boolean ico;
    AmMouseListener(AmCanvas cc)
     {
     c = cc;
     }
    public void mousePressed(MouseEvent e)
     {
       {
       if(
       (c.frame.contents == null)
       ){
       return;
       }
       }
     int m = e.getModifiers();
       {
       if(
       ((m != 0) && (m & InputEvent.BUTTON1_MASK) == 0)
       ){
       return;
       }
       }
     c.mouseDragged = false;
     Graphics g = c.getGraphics(); g.translate(c.start.x, c.start.y);
     Point p =  new Point(e.getX(), e.getY());
     p.x -= c.start.x; p.y -= c.start.y;
     oldSelection = (c.selection.kind() != Selection.NONE);
     View.result = null;
     c.frame.contents.main.view.pointLocation(p, c.frame.contents.main);
     newSelection = View.result != null;
       {
       if(
       (newSelection)
       ){
       if(
       (View.result.row != null)
       ){
       Caret caret = c.frame.contents.editor.caret;
       g.setColor(Default.backgroundColor);
       caret.draw(g);
       caret.goTo(View.result);
        for(
        ;p.x > (caret.row.x+caret.shift);
        )
         {
         caret.moveRight();
         }
       g.setColor(Default.caretColor);
       caret.draw(g);
       }
       }
       }
       {
       if(
       (oldSelection)
       ){
       c.selection.draw(g);
       c.selection.cancel();
       }
       }
       {
       if(
       (newSelection)
       ){
       Cursor cursor = View.result.makeCopy();
       c.selection = new Selection(c, cursor, cursor);
       c.selection.draw(g);
       }
       }
     }
    public void mouseClicked(MouseEvent e)
     {
       {
       if(
       c.frame.contents == null
       ){
       return;
       }
       }
     Graphics g = c.getGraphics();
     g.translate(c.start.x, c.start.y);
       {
       if(
       e.isMetaDown()
       ){
         {
           {
           if(
           e.getClickCount() == 1
           ){
           Point p =  new Point(e.getX(), e.getY());
           p.x -= c.start.x; p.y -= c.start.y;
           oldSelection = (c.selection.kind() != Selection.NONE);
           View.result = null;
           c.frame.contents.main.view.pointLocation(
                                                                   p, c.frame.contents.main);
           newSelection = (View.result != null) && !View.result.inScheme();
            L0:
             {
               {
               if(
               newSelection
               ){
               Scheme s = View.result.scheme;
                 {
                 if(
                 s.parent == null
                 ){
                 return;
                 }
                 }
                 {
                 if(
                 oldSelection
                 ){
                 c.selection.draw(g);
                 c.selection.cancel();
                 }
                 }
                 {
                 if(
                 !s.icon
                 ){
                 Caret caret = c.frame.contents.editor.caret;
                 caret.draw(g);
                  for(
                  ;(caret.row.y+caret.height-2) > s.view.y;
                  )
                   {
                   caret.moveUp();
                   }
                 caret.draw(g);
                 }
                 }
               s.icon = !s.icon;
               c.frame.contents.main.view.plan(c.hd, c.vd);
               Cursor cursor = View.result.makeCopy();
               c.selection = new Selection(c, cursor, cursor);
               c.selection.draw(g);
               break L0;
               }
               }
             int kind = c.selection.kind();
               {
               if(
               kind == Selection.NONE
               ){
               return;
               }
               }
             Object first, last;
             first = c.selection.start.primitive;
             last = c.selection.end.primitive;
              switch(
              kind
              )
              {
               case
                Selection.PRIMITIVE2PRIMITIVE:
                 {
                 if(
                 !c.selection.start.inBody()
                 ){
                 return;
                 }
                 }
               break;
               case
                Selection.SCHEME2PRIMITIVE:
               first = c.selection.start.scheme;
               break;
               case
                Selection.PRIMITIVE2SCHEME:
               last = c.selection.end.scheme;
               break;
               case
                Selection.SCHEME2SCHEME:
               first = c.selection.start.scheme;
               last = c.selection.end.scheme;
               break;
               default
               :
               {
               return;
               }
              }
             Scheme parent = c.selection.parent();
               {
               if(
               (oldSelection)
               ){
               c.selection.draw(g);
               }
               }
             int i = parent.body.indexOf(first);
             int j = parent.body.indexOf(last);
              for(
              int k = i; k <= j; k++
              )
               {
               Object o = parent.member(k);
               if(
               o instanceof Scheme
               ){
               Scheme member = (Scheme)o;
               member.icon = !member.icon;
               if(
               member.icon
               ){
               Caret caret = c.frame.contents.editor.caret;
               caret.draw(g);
                for(
                ;((caret.row.y+caret.height-2)> member.view.y) &&((caret.row.y+caret.height-2)<= (member.view.y)+member.view.height-1);
                )
                 {
                 caret.moveUp();
                 }
               caret.draw(g);
               }
               }
               }
             c.frame.contents.main.view.plan(c.hd, c.vd);
             c.selection.draw(g);
             }
           c.own = true;
           c.selectionToScreen();
            c.repaint();
           return;
           }
           }
         newSelection = (View.result != null) &&!View.result.inScheme();
         if(
         (newSelection)
         ){
         Scheme source = View.result.scheme;
           {
           selectedLevel = 0;
           Scheme x = source;
            for(
            ;x.parent!=null;selectedLevel++, x=x.parent
            )
             {
             ;
             }
           }
         currentLevel = 0;
         ico = source.icon;
         c.frame.contents.editor.caret.draw(g);
         setIcons(c.frame.contents.main, source);
         c.frame.contents.editor.caret.draw(g);
         c.frame.contents.main.view.plan(c.hd, c.vd);
         c.selectionToScreen();
         c.own = true; c.repaint();
         }
         }
       return;
       }
       }
       {
       if(
       (c.mouseDragged)
       ){
       return;
       }
       }
     //g = c.getGraphics();
      L1:
       {
         {
         if(
         e.getClickCount() == 2
         ){
           {
           if(
           newSelection
           ){
           //g.translate(c.start.x, c.start.y);
           c.selection.draw(g);
           c.selection.expand();
           c.selection.draw(g);
           }
           }
         break L1;
         }
         }
       if(
       e.getClickCount() > 2
       ){
       System.out.println(
       "AmMouseListener: clicked: count = "+e.getClickCount());
       AmFrame frame = c.frame;
       if(
       frame.isProjectDescriptionFrame()
       ){
         {
         if(
         ProjectBoard.isProjectFileNameGrayed(frame)
         ){
         return;
         }
         }
       AmProjectFileFrame newProjectFileFrame 
       = Am.addProjectFileFrame(frame);
       newProjectFileFrame.menuBar.setEnabled(AmLocale.File(),
       AmLocale.Open(), true);
       newProjectFileFrame.menuBar.setEnabled(AmLocale.File(),
       AmLocale.Save(), true);
       newProjectFileFrame.setLocation(new Point(350, 50));
       frame.setLocation(new Point(50, 50));
       frame.setSize(300, 600);
       Item01Listener.openIntoFrame(
                                               newProjectFileFrame, frame);
       }
       }
       }
     }
    public void mouseReleased(MouseEvent e)
     {
     }
    public void mouseEntered(MouseEvent e)
     {
     }
    public void mouseExited(MouseEvent e)
     {
     }
    private void setIcons(Scheme s, Scheme s0)
     {
       {
       if(
       ((currentLevel == selectedLevel) && (s != s0))
       ){
         {
         if(
         (ico && !s.icon)
         ){
         if(
         (!s.icon)
         ){
         Caret caret = c.frame.contents.editor.caret;
          for(
          ;(s.view.contains(caret.row.x,caret.row.y+caret.height-2)) ||
          caret.scheme.icon;
          )
           {
           caret.moveUp();
           }
         }
         }
         }
       s.icon = ico;
       }
       }
     currentLevel++;
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Object o = e.nextElement();
       if(
       (o instanceof Scheme)
       ){
       setIcons((Scheme)o, s0);
       }
       }
     currentLevel--;
     }
   }
