 import java.util.*;
 import java.awt.*;
 import java.io.*;
  class BaseLanguageXML extends BaseLanguage
   {
   static AmFrame frame;
   static AmCanvas c;
    BaseLanguageXML()
     {
     type = XML;
     }
    public  boolean sketchify(SketchyText skt0,
    SketchyText skt1,
    AmFrame dialogTargetFrame)
     {
     boolean onProloog = false;
     Symbol syx = null;
     Sketch s0 = skt0.main;
     Branch b0 = s0.branch(0);
     PrimitiveMember p = null;
       {
       if(
       b0.body.size() > 0
       ){
       p = (PrimitiveMember)(b0.member(0));
       String rida1 = p.text.toString();
         {
         if(
         rida1.startsWith("<?xml")
         ){
         onProloog = true;
         syx = (Symbol)(p.text.row(0).elements.elementAt(3));
         p.text.row(0).remove(3);
         p.text.row(0).insert(
         new Symbol('z', Default.foregroundColor), 3);
         }
         }
       }
       }
     String fnimi0 = Default.tempSketchifyXmlSource;
     skt0.file = new AmFile(skt0);
     skt0.file.name = fnimi0;
     skt0.file.writeTextFile(fnimi0);
       {
       if(
       onProloog
       ){
       p.text.row(0).remove(3);
       p.text.row(0).insert(syx, 3);
       }
       }
     String fnimi1 = Default.tempSketchifyXmlSketchified;
     Xml2Sketch.inName = fnimi0;
     Xml2Sketch.outName = fnimi1;
     Xml2Sketch.xml2sketch();
     frame = dialogTargetFrame;
     skt1.file = new AmFile(skt1);
     skt1.file.name = fnimi1;
     skt1.frame = dialogTargetFrame;
     skt1.frame.contents = skt1;
     skt1.file.importsFile();
     Branch b = skt1.main.branch(0);
      L0:
      for(
      int i = 0; i < b.body.size(); i++
      )
       {
       Object o = b.member(i);
         {
         if(
         !(o instanceof Primitive)
         ){
         continue L0;
         }
         }
       p = (PrimitiveMember)o;
       if(
       p.text.toString().equals(Xml2Sketch.DTDkohamrk)
       ){
       b.removeMember(i);
       Sketch dtdModule = null;
        {try
         {
         dtdModule = DTD.getDTDModule(fnimi0);
         }
         catch
         (FileNotFoundException e)
         {
         System.out.println("FNF");//e.getMessage());
         System.exit(0);
         }
         catch
         (IOException e)
         {
         System.out.println("IO");//e.getMessage());
         System.exit(0);
         }
         catch
         (ParseException e)
         {
         System.out.println("PARSE");//e.getMessage());
         System.exit(0);
         }
        }
       if(
       dtdModule != null
       ){
       b.insert(dtdModule, i);
         {
         if(
         dtdModule.body.size() == 0
         ){
         dtdModule.insert(
         new Branch(Scheme.SIMPLE,
         new BaseLanguageXML()), 0);
         }
         }
       break;
       }
       }
       }
       {
       if(
       onProloog
       ){
       s0 = skt1.main;
       b0 = s0.branch(0);
       p = null;
         {
         if(
         b0.body.size() > 0
         ){
         Object o = b0.member(0);
         if(
         o instanceof PrimitiveMember
         ){
         p = (PrimitiveMember)(o);
         String rida1 = p.text.toString();
           {
           if(
           rida1.startsWith("zml") && 
           (p.type == Primitive.CONDITION)
           ){
           p.text.row(0).remove(1);
           p.text.row(0).insert(
           new Symbol('x', Default.conditionColor), 1);
           }
           }
         }
         }
         }
       }
       }
     return(
     true
     );
     }
    boolean normalize(SketchyText skt0, SketchyText skt1,
    AmFrame f)
     {
     System.out.println("BaseLangXML!!!!");
     return(
     false
     );
     }
   static byte gotType;
   static BaseLanguage gotBaseLanguage;
   static byte gotViewType;
   static boolean gotIcon;
   static String gotFace;
   static int gotSize;
   static int gotStyle;
   static int gotColorR;
   static int gotColorG;
   static int gotColorB;
   static String gotSrc;
   static int gotAlign;
   static String comment;
   static Row row;
   static Vector heads;
   static Vector branches;
    void reduce(Sketch s)
     {
     reduceRek(s);
     }
    static void reduceRek(Sketch s)
     {
       {
       getAttributes(s);
       s.type = gotType;
       View.newView(gotViewType, s);
       s.baseLanguage = gotBaseLanguage;
       s.icon = gotIcon;
       s.comment = new Row("", Default.commentColor);
       }
     Branch br = s.branch(0);
     int n = br.body.size();
      for(
      int i = 0; i < n; i++
      )
       {
       tdeldaSkeemiLiige(s, (Sketch)(br.member(0)));
       }
     s.removeMember(0);
     }
    private static void getAttributes(Scheme s)
     {
     gotType = 0;
     gotBaseLanguage = BaseLanguage.newBaseLanguage((byte)0);
     gotViewType = 0;
     gotIcon = false;
     int n = s.head.size();
      for(
      int i = 0; i < n ; i++
      )
       {
       PrimitiveHead he = s.primitiveHead(0);
       String r = he.text.toString();
        L1:
         {
           {
           if(
           r.indexOf("type=\"") == 0
           ){
           gotType = (byte)(r.charAt(6) - '0');
           break L1;
           }
           }
           {
           if(
           r.indexOf("base=\"") == 0
           ){
           byte b = (byte)(r.charAt(6) - '0');
           gotBaseLanguage = BaseLanguage.newBaseLanguage(b);
           break L1;
           }
           }
           {
           if(
           r.indexOf("view=\"") == 0
           ){
           gotViewType = (byte)(r.charAt(6) - '0');
           break L1;
           }
           }
         if(
         r.indexOf("icon=\"") == 0
         ){
          L2:
           {
             {
             if(
             r.indexOf("\"no\"") == 5
             ){
             gotIcon = false;
             break L2;
             }
             }
           gotIcon = true;
           }
         }
         }
       s.removePrimitiveHead(0);
       }
     }
    static void tdeldaSkeemiLiige(Sketch s, Sketch sk)
     {
     String comm = sk.comment.toString();
      L3:
       {
         {
         if(
         comm.equals("COMMENT")
         ){
         s.comment = getComment(sk);
         break L3;
         }
         }
         {
         if(
         comm.equals("PRIMITIVE_HEAD")
         ){
         s.insert(getPrimitiveHead(sk, true), s.head.size());
         break L3;
         }
         }
       if(
       comm.equals("BRANCH")
       ){
       Branch newBr = getBranch(sk);
       s.insert(newBr, s.body.size());
       }
       }
     }
    static Row getComment(Sketch sk)
     {
     Row r = getRow(sk);
     //r.setColor(Default.commentColor);
     return(
     r
     );
     }
    static PrimitiveHead getPrimitiveHead(Sketch sk, boolean isSketchHead)
     {
     int type = 0;
       {
       if(
       sk.head.size() != 0
       ){
       String str = sk.primitiveHead(0).text.row(0).toString();
       type = Integer.parseInt(str.substring(6,7));
       }
       }
     Branch br = sk.branch(0);
     Sketch sktxt = (Sketch)(br.member(0));
     sk.remove();
     Text t = getText(sktxt);
      L4:
       {
       String comm = sk.comment.toString();
         {
         if(
         isSketchHead
         ){
         t.setColor(Default.sketchHeadColor);
         break L4;
         }
         }
       t.setColor(Default.branchHeadColor);
       }
     return(
     new PrimitiveHead((byte)type, t)
     );
     }
    static PrimitiveMember getPrimitive(Sketch sk)
     {
     int type = Primitive.SIMPLE;
       {
       if(
       sk.head.size() != 0
       ){
       String str = sk.primitiveHead(0).text.row(0).toString();
       type = Integer.parseInt(str.substring(6,7));
       }
       }
     Branch br = sk.branch(0);
     Sketch sktxt = (Sketch)(br.member(0));
     sk.remove();
     Text t = getText(sktxt);
       {
       if(
       type == Primitive.CONDITION
       ){
       t.setColor(Default.conditionColor);
       }
       }
     return(
     new PrimitiveMember((byte)type, t)
     );
     }
    static Arrow getArrow(Sketch sk)
     {
     int type = Primitive.STRONG_ARROW;
     int level = 0;
     String str;
      L5:
       {
         {
         if(
         sk.head.size() == 2
         ){
         str = sk.primitiveHead(0).text.row(0).toString();
         type = Integer.parseInt(str.substring(6,7));
         str = sk.primitiveHead(1).text.row(0).toString();
         //level = Integer.parseInt(str.substring(7,8));
         break L5;
         }
         }
       str = sk.primitiveHead(0).text.row(0).toString();
       //level = Integer.parseInt(str.substring(7,8));
       }
     String str1 = str.substring(7, str.lastIndexOf("\""));
     level = Integer.parseInt(str1);
     Branch br = sk.branch(0);
     Sketch sktxt = (Sketch)(br.member(0));
     sk.remove();
     Text t = getText(sktxt);
     Arrow ar = new Arrow((byte)type, level);
     ar.text = t;
     return(
     ar
     );
     }
    static Text getText(Sketch sk)
     {
     Text res = new Text();
     Branch br = sk.branch(0);
     int n = br.body.size();
     int j = 0;
      for(
      int i = 0; i < n; i++
      )
       {
       Sketch ask = (Sketch)(br.member(0));
       Row r = getRow(ask);
        L6:
         {
           {
           if(
           ask.comment.toString().equals("ROW")
           ){
           res.insert(r, j++);
           break L6;
           }
           }
         //r.setColor(Default.commentColor);
         res.comment = r;
         }
       }
     res.remove(res.rows.size()-1);
     sk.remove();
     return(
     res
     );
     }
    static Row getRow(Sketch sk)
     {
     Branch br = sk.branch(0);
     sk.remove();
     Color leadingColor = null;
      L7:
       {
       comment = sk.comment.toString();
         {
         if(
         comment.equals("ROW")
         ){
         leadingColor = Default.foregroundColor;
         break L7;
         }
         }
       leadingColor = Default.commentColor;
       }
       {
       if(
       br.body.size() == 0
       ){
       return(
       new Row(leadingColor)
       );
       }
       }
       {
         {
         if(
         !isRichRow(sk)
         ){
         PrimitiveMember p = (PrimitiveMember)(br.member(0));
         row = p.text.row(0);
         String r = row.toString();
           {
           if(
           r.indexOf("<![CDATA[") == 0
           ){
           if(
           r.lastIndexOf("]]>") == r.length() - 3
           ){
            for(
            int i = 0; i < 3; i++
            )
             {
             row.remove(row.elements.size()-1);
             }
            for(
            int i = 0; i < 9; i++
            )
             {
             row.remove(0);
             }
            L8:
            for(;;)
             {
             r = row.toString();
             int k = r.indexOf("&#93;&#93;&#62;");
               {
               if(
               k < 0
               ){
               break L8;
               }
               }
             k++;
             row.getElement(k);
             Symbol sym = row.sy;
              for(
              int i = 0; i < 15; i++
              )
               {
               row.remove(k);
               }
             row.insert(new Symbol('>', sym.font, sym.color), k);
             row.insert(new Symbol(']', sym.font, sym.color), k);
             row.insert(new Symbol(']', sym.font, sym.color), k);
             }
           }
           }
           }
         row.setColor(leadingColor);
         return(
         row
         );
         }
         }
       row = new Row(leadingColor);
       int n = br.body.size();
        for(
        int i = 0; i < n; i++
        )
         {
         Sketch ask = (Sketch)(br.member(0));
          L9:
           {
           comment = ask.comment.toString();
             {
             if(
             comment.equals("SEGM")
             ){
             addElementsFromSegment(ask, row);
             break L9;
             }
             }
             {
             if(
             comment.equals("PICTURE")
             ){
             addElementPicture(ask, row);
             break L9;
             }
             }
           if(
           comment.equals("HYPERELEM")
           ){
           }
           }
         row.planSize();
         }
       //res.remove(res.rows.size()-1);
       //sk.remove();
       }
     return(
     row
     );
     }
    static Branch getBranch(Sketch sk)
     {
     getAttributes(sk);
     Branch res = new Branch(gotType, gotBaseLanguage);
     View.newView(gotViewType, res);
     res.icon = gotIcon;
     Branch br = sk.branch(0);
     int n = br.body.size();
      for(
      int i = 0; i < n; i++
      )
       {
       tdeldaHaruLiige(res, (Sketch)(br.member(0)));
       }
     res.removeMember(0);
     sk.remove();
     return(
     res
     );
     }
    static void tdeldaHaruLiige(Branch b, Sketch sk)
     {
     String comm = sk.comment.toString();
      L10:
       {
         {
         if(
         comm.equals("COMMENT")
         ){
         b.comment = getComment(sk);
         break L10;
         }
         }
         {
         if(
         comm.equals("PRIMITIVE_HEAD")
         ){
         b.insert(getPrimitiveHead(sk, false), b.head.size());
         break L10;
         }
         }
         {
         if(
         comm.equals("PRIMITIVE")
         ){
         PrimitiveMember p = getPrimitive(sk);
         b.insert(p, b.body.size());
         break L10;
         }
         }
         {
         if(
         comm.equals("ARROW")
         ){
         Arrow ar = getArrow(sk);
         b.insert(ar, b.body.size());
         break L10;
         }
         }
       if(
       comm.equals("SKETCH")
       ){
       reduceRek(sk);
       sk.remove();
       b.insert(sk, b.body.size());
       }
       }
     }
    static boolean isRichRow(Sketch sk)
     {
     Branch br = sk.branch(0);
     int n = br.body.size();
      for(
      int i = 0; i < n; i++
      )
       {
       Object o = br.member(i);
       if(
       o instanceof Sketch
       ){
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    private static void getSegmentAttributes(Sketch s)
     {
     gotFace = "TimesRoman";
     gotSize = 16;
     gotStyle = 0;
     gotColorR = 0;
     gotColorG = 0;
     gotColorB = 0;
     int n = s.head.size();
      for(
      int i = 0; i < n ; i++
      )
       {
       PrimitiveHead he = s.primitiveHead(0);
       String r = he.text.toString();
        L11:
         {
           {
           if(
           r.indexOf("face=\"") == 0
           ){
           gotFace = r.substring(6, r.length() - 1);
           break L11;
           }
           }
           {
           if(
           r.indexOf("size=\"") == 0
           ){
           gotSize =
           new Integer(r.substring(6, r.length() - 1)).intValue();
           break L11;
           }
           }
           {
           if(
           r.indexOf("style=\"") == 0
           ){
           gotStyle =
           new Integer(r.substring(7, r.length() - 1)).intValue();
           break L11;
           }
           }
         if(
         r.indexOf("color=\"") == 0
         ){
         StringTokenizer st = new StringTokenizer(r, "\",");
         st.nextToken();
         gotColorR = new Integer(st.nextToken()).intValue();
         gotColorG = new Integer(st.nextToken()).intValue();
         gotColorB = new Integer(st.nextToken()).intValue();
         }
         }
       s.removePrimitiveHead(0);
       }
     }
    static void addElementsFromSegment(Sketch sk, Row givenRow)
     {
     getSegmentAttributes(sk);
     Branch br = sk.branch(0);
     PrimitiveMember p = null;
      L12:
       {
         {
         if(
         br.body.size() == 0
         ){
         p = new PrimitiveMember(Primitive.SIMPLE, new Text());
         break L12;
         }
         }
        p = (PrimitiveMember)(br.member(0));
       }
     sk.remove();
     Row rida = p.text.row(0);
     String r = rida.toString();
       {
       if(
       r.indexOf("<![CDATA[") == 0
       ){
       if(
       r.lastIndexOf("]]>") == r.length() - 3
       ){
        L13:
        for(;;)
         {
         r = rida.toString();
         int k = r.indexOf("&#93;&#93;&#62;");
           {
           if(
           k < 0
           ){
           break L13;
           }
           }
         k++;
         rida.getElement(k);
         Symbol sym = rida.sy;
          for(
          int i = 0; i < 15; i++
          )
           {
           rida.remove(k);
           }
         rida.insert(new Symbol('>', sym.font, sym.color), k);
         rida.insert(new Symbol(']', sym.font, sym.color), k);
         rida.insert(new Symbol(']', sym.font, sym.color), k);
         }
       r = rida.toString();
       r = r.substring(9, r.length() - 3);
       r = replaceCharEntities(r);
       }
       }
       }
     Color col = new Color(gotColorR, gotColorG, gotColorB);
     Font font = new Font(gotFace, gotStyle, gotSize);
     AmFrame fr = (AmFrame)(Am.frames.elementAt(0));
     AmCanvas c = (AmCanvas)(fr.viewArea);
     Graphics g = c.getGraphics();
      for(
      int i = 0; i < r.length();  i++
      )
       {
       col = AmFont.color[AmFont.No(col)];
       font = AmFont.font[AmFont.No(font, g)];
       Symbol sm = new Symbol(r.charAt(i), font, col);
       givenRow.append(sm);
       }
     //sk.remove();
     }
    static String replaceCharEntities(String r)
     {
     String res = "";
      for(;;)
       {
       int i = r.indexOf("&#");
         {
         if(
         i<0
         ){
         return(
         res + r
         );
         }
         }
       res += r.substring(0, i);
       r = r.substring(i);
       int j = r.indexOf(";");
         {
         if(
         j < 0
         ){
         return(
         res+r
         );
         }
         }
       String olemiSisu = r.substring(2, j);
       int sisu = -1;
       boolean vaja = true;
        {try
         {
         sisu = new Integer(olemiSisu).intValue();
           {
           if(
           sisu < 128
           ){
           vaja = false;
           }
           }
         }
         catch
         (NumberFormatException e)
         {
         vaja = false;
         }
        }
        L14:
         {
           {
           if(
           vaja
           ){
           char c = (char)sisu;
           res += c;
           r = r.substring(j+1);
           break L14;
           }
           }
         res += r.substring(0, j+1);
         r = r.substring(j+1);
         }
       }
     }
    static void addElementPicture(Sketch sk, Row givenRow)
     {
     getPictureAttributes(sk);
     Branch br = sk.branch(0);
     sk.remove();
     int i = givenRow.elements.size();
     Am.pictureBoard.processIMGs(givenRow, i, gotSrc);
     givenRow.getElement(i);
     givenRow.im.align = gotAlign;
     givenRow.im.icon = gotIcon;
     }
    private static void getPictureAttributes(Sketch s)
     {
     gotSrc = "";
     gotIcon = false;
     gotAlign = AmImage.ALIGN_BOTTOM;
     int n = s.head.size();
      for(
      int i = 0; i < n ; i++
      )
       {
       PrimitiveHead he = s.primitiveHead(0);
       String r = he.text.toString();
        L15:
         {
           {
           if(
           r.indexOf("src=\"") == 0
           ){
           gotSrc = r.substring(5, r.length() - 1);
           break L15;
           }
           }
           {
           if(
           r.indexOf("align=\"") == 0
           ){
           gotAlign =
           new Integer(r.substring(7, r.length() - 1)).intValue();
           break L15;
           }
           }
         if(
         r.indexOf("icon=\"") == 0
         ){
          L16:
           {
             {
             if(
             r.indexOf("\"no\"") == 5
             ){
             gotIcon = false;
             break L16;
             }
             }
           gotIcon = true;
           }
         }
         }
       s.removePrimitiveHead(0);
       }
     }
   static Branch br1;
   static String indent = "                                                             ";
   static int currentLevel = 0;
    boolean textualize(SketchyText skt0, SketchyText skt1,
    AmFrame dialogTargetFrame)
     {
     frame = dialogTargetFrame;
     Sketch sNew = skt1.main;
     Sketch s = skt0.main;
     sNew.baseLanguage = new BaseLanguageXML();
     sNew.branch(0).baseLanguage = new BaseLanguageXML();
     Branch br = s.branch(0);
     br1 = sNew.branch(0);
     br1.body.removeElementAt(0);
     //insertLine("%This LaTex-text is generated by AMADEUS");
      L17:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof PrimitiveMember
         ){
         textualize((PrimitiveMember)o);
         continue L17;
         }
         }
       textualize((Sketch)o);
       }
     return(
     true
     );
     }
    private void textualize(Sketch sk)
     {
     currentLevel++;
     String comment = sk.comment.toString().trim();
     boolean commented = (comment.length() > 0);
     String endtag = "";
      L18:
      switch(
      sk.type
      )
      {
       case
       Scheme.SIMPLE:
         {
         if(
         commented
         ){
         endtag = "</"+comment+">";
         textualizeHead("<"+comment+" ",(Scheme)sk,">");
         }
         }
       break;
       case
       Scheme.MODULE:
       int n = sk.head.size();
         {
         if(
         n == 0
         ){
         new AmDialog
         (frame, AmLocale.Source_error(),AmDialog.B_OK,
         "DTD "+AmLocale.Head() + " "+
         AmLocale.missing() + "!");
         endtag = " ]>";
         insertRed("<!DOCTYPE  ????? [");
         break L18;
         }
         }
       PrimitiveHead h = (PrimitiveHead)(sk.head.elementAt(0));
         {
         if(
         h.type == PrimitiveHead.SIMPLE
         ){
         endtag = "]>";
         textualizeHead("<!", (Scheme)sk, " [");
         break L18;
         }
         }
         {
         if(
         h.type == PrimitiveHead.SWITCH
         ){
         endtag = "?>";
         textualizeHead("<?", (Scheme)sk, "");
         break L18;
         }
         }
       if(
       h.type == PrimitiveHead.TRY
       ){
       endtag = "]>";
       textualizeHead("<!DOCTYPE ", (Scheme)sk, " [");
       break;
       }
       case
       Scheme.LOOP:
       textualizeHead("<!-- ", (Scheme)sk, "");
       endtag = "-->";
       break;
      }
      for(
      int i = 0; i < sk.body.size(); i++
      )
       {
       textualize(sk.branch(i));
       }
     insertLine(endtag);
     currentLevel--;
     }
    private void textualize(Branch br)
     {
     String endtag = "";
      L19:
       {
         {
         if(
         br.type == Scheme.MODULE
         ){
         endtag = ">";
         break L19;
         }
         }
       if(
       br.type == Scheme.LOOP
       ){
       endtag = "-->";
       }
       }
     int n = br.head.size();
      L20:
       {
         {
         if(
         n != 1
         ){
         break L20;
         }
         }
         {
         if(
         br.type != Scheme.MODULE
         ){
         break L20;
         }
         }
       PrimitiveHead h = (PrimitiveHead)(br.head.elementAt(0));
         {
         if(
         h.type == PrimitiveHead.SIMPLE
         ){
         textualizeHead("<![", (Scheme)br, "[");
         endtag = "]]>";
         break L20;
         }
         }
         {
         if(
         h.type == PrimitiveHead.SWITCH
         ){
         textualizeHead("<!NOTATION ", (Scheme)br, "");
         endtag = ">";
         break L20;
         }
         }
         {
         if(
         h.type == PrimitiveHead.CASE
         ){
         textualizeHead("<!ENTITY ", (Scheme)br, "");
         endtag = ">";
         break L20;
         }
         }
         {
         if(
         h.type == PrimitiveHead.CATCH
         ){
         textualizeHead("<!ELEMENT ", (Scheme)br, "");
         endtag = ">";
         break L20;
         }
         }
       if(
       h.type == PrimitiveHead.LOOP
       ){
       textualizeHead("<!ATTLIST ", (Scheme)br, "");
       endtag = ">";
       }
       }
      L21:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         o instanceof Sketch
         ){
         textualize((Sketch)o);
         continue L21;
         }
         }
       textualize((PrimitiveMember)o);
       }
     insertLine(endtag);
     }
    private void textualizeHead(String start, Scheme s, String end)
     {
     int n = s.head.size();
       {
       if(
       n == 0
       ){
       insertLine(start + end);
       return;
       }
       }
       {
       if(
       n == 1
       ){
       textualize(start, s.primitiveHead(0).text, end);
       return;
       }
       }
      L22:
      for(
      int i = 0; i < n; i++
      )
       {
         {
         if(
         i==0
         ){
         textualize(start, s.primitiveHead(i).text,"");
         continue L22;
         }
         }
         {
         if(
         i==(n-1)
         ){
         textualize("", s.primitiveHead(i).text, end);
         continue L22;
         }
         }
       textualize(s.primitiveHead(i).text);
       }
     }
    private void textualize(PrimitiveMember p)
     {
     Text t = p.text;
       {
       if(
       p.type == Primitive.SIMPLE
       ){
       textualize(t);
       return;
       }
       }
     textualize("<?", t, "?>");
     }
    private void textualize(Text t)
     {
     textualize("", t, "");
     }
    private void textualize(String pref, Text t, String suf)
     {
       {
       if(
       t.isTrivial()
       ){
       return;
       }
       }
     int n = t.rows.size();
       {
       if(
       n == 1
       ){
       insertLine(pref+t.row(0).toString()+suf);
       return;
       }
       }
      L23:
      for(
      int i = 0; i < n; i++
      )
       {
         {
         if(
         i==0
         ){
         insertLine(pref+t.row(i).toString());
         continue L23;
         }
         }
         {
         if(
         i==(n-1)
         ){
         insertLine(t.row(i).toString()+suf);
         continue L23;
         }
         }
       insertLine(t.row(i).toString());
       }
     }
    private void insertLine(String str)
     {
       {
       if(
       str.length() == 0
       ){
       return;
       }
       }
     str = indent.substring(0, Math.min(indent.length(),
     currentLevel))+ str;
     Text newT = new Text();
     newT.rows.removeElementAt(0);
     newT.rows.addElement(
     new Row(str, Default.foregroundColor));
     br1.body.addElement(
     new PrimitiveMember(Primitive.SIMPLE, newT));
     }
    private void insertRed(String str)
     {
       {
       if(
       str.length() == 0
       ){
       return;
       }
       }
     str = indent.substring(0, Math.min(indent.length(),
     currentLevel+1))+ str;
     Text newT = new Text();
     newT.rows.removeElementAt(0);
     newT.rows.addElement(
     new Row(str, Default.conditionColor));
     br1.body.addElement(
     new PrimitiveMember(Primitive.SIMPLE, newT));
     }
    void prepareTex(Sketch s)
     {
     System.out.println("BaseLangXML!!!!");
     return;
     }
    byte nextPrimitiveHeadType(Scheme s, byte prev)
     {
      L24:
       {
         {
         if(
         s instanceof Sketch
         ){
           {
             {
             if(
             s.type == Scheme.MODULE
             ){
               {
               if(
               prev == PrimitiveHead.SIMPLE
               ){
               return(
               PrimitiveHead.TRY
               );
               }
               }
             return(
             prev
             );
             }
             }
             {
             if(
             s.type == Scheme.SIMPLE
             ){
             return(
             PrimitiveHead.SIMPLE
             );
             }
             }
            switch(
            prev
            )
            {
             case
              PrimitiveHead.SIMPLE:
             return(
             PrimitiveHead.LOOP
             );
             case
              PrimitiveHead.LOOP:
             return(
             PrimitiveHead.SWITCH
             );
             case
              PrimitiveHead.SWITCH:
             return(
             PrimitiveHead.TRY
             );
             case
              PrimitiveHead.TRY:
             return(
             PrimitiveHead.SIMPLE
             );
            }
           }
         break L24;
         }
         }
       Sketch psk = (Sketch)(s.parent);
         {
         if(
         psk.type == Scheme.SIMPLE
         ){
           {
             {
             if(
             s.type == Scheme.SIMPLE
             ){
             return(
             PrimitiveHead.SIMPLE
             );
             }
             }
           if(
           s.type == Scheme.MODULE
           ){
            switch(
            prev
            )
            {
             case
             PrimitiveHead.SIMPLE:
             return(
             PrimitiveHead.CASE
             );
             default
             :
             {
             return(
             PrimitiveHead.SIMPLE
             );
             }
            }
           }
           }
         break L24;
         }
         }
       if(
       psk.type == Scheme.MODULE
       ){
        switch(
        prev
        )
        {
         case
         PrimitiveHead.SIMPLE:
         return(
         PrimitiveHead.LOOP
         );
         case
         PrimitiveHead.LOOP:
         return(
         PrimitiveHead.CASE
         );
         case
         PrimitiveHead.CASE:
         return(
         PrimitiveHead.CATCH
         );
         case
         PrimitiveHead.CATCH:
         return(
         PrimitiveHead.LOOP
         );
         default
         :
         {
         return(
         PrimitiveHead.CATCH
         );
         }
        }
       }
       }
     return(
     prev
     );
     }
   }
