  class Branch extends Scheme
   {
    Branch(byte t, BaseLanguage bl)
     {
     super(t, bl);
     insert(new PrimitiveMember(Primitive.SIMPLE, new Text()), 0);
     }
    void insert(PrimitiveMember pm, int i)
     {
     body.insertElementAt(pm, i);
     }
    void add(PrimitiveMember pm)
     {
     insert(pm, body.size());
     }
    void insert(Sketch sk, int i)
     {
     body.insertElementAt(sk, i);
     sk.parent = this;
     }
    void add(Sketch sk)
     {
     insert(sk, body.size());
     }
    void insert(Branch br, int i)
     {
     System.out.println
     ("Sketch: illegal attempt to insert branch!");
     System.exit(0);
     }
    void removeMember(int i)
     {
     body.removeElementAt(i);
     }
    int level()
     {
       {
       if(
       parent == null
       ){
       return(
       0
       );
       }
       }
     return(
     parent.level() + 1
     );
     }
    Branch makeCopy()
     {
     Branch res = makeCopyRecurs();
     int incr = -level();
     res.incrementArrows(incr);
     return(
     res
     );
     }
    Branch makeCopyRecurs()
     {
     Branch res = new Branch((byte)0, null);
     res.type = type;
      for(
      int i=0; i < head.size(); i++
      )
       {
       PrimitiveHead h = primitiveHead(i);
       res.insert(h.makeCopy(), i);
       }
      L0:
      for(
      int i=0; i < body.size(); i++
      )
       {
       Object o = member(i);
         {
         if(
         (o instanceof Sketch)
         ){
         Sketch sk = (Sketch)o;
         Sketch s = sk.makeCopyRecurs();
         s.parent = res;
         res.insert(s, i+1);
         continue L0;
         }
         }
         {
         if(
         (o instanceof Arrow)
         ){
         Arrow ar = (Arrow)o;
         res.insert(ar.make_Copy(), i+1);
         continue L0;
         }
         }
       PrimitiveMember p = (PrimitiveMember)o;
       res.insert(p.makeCopy(), i+1);
       }
     res.removeMember(0);
     res.baseLanguage =
     BaseLanguage.newBaseLanguage(baseLanguage.type);
     res.comment = comment.makeCopy();
     res.parent = null;
     View.set(res, view.type);
     res.icon = icon;
     return(
     res
     );
     }
    boolean isRichModel()
     {
       {
       if(
       comment.isRichModel()
       ){
       return(
       true
       );
       }
       }
      for(
      int j = 0, m = head.size(); j < m; j++
      )
       {
       if(
       primitiveHead(j).isRichModel()
       ){
       return(
       true
       );
       }
       }
      for(
      int i = 0, n = body.size(); i < n; i++
      )
       {
       Object o = member(i);
        L1:
         {
           {
           if(
           o instanceof Sketch
           ){
             {
             if(
             ((Sketch)o).isRichModel()
             ){
             return(
             true
             );
             }
             }
           break L1;
           }
           }
         if(
         ((Primitive)o).isRichModel()
         ){
         return(
         true
         );
         }
         }
       }
     return(
     false
     );
     }
    public void incrementArrows(int incr)
     {
      L2:
      for(
      int i=0; i < body.size(); i++
      )
       {
       Object o = member(i);
         {
         if(
         o instanceof Sketch
         ){
         Sketch sk = (Sketch)o;
         sk.incrementArrows(incr);
         continue L2;
         }
         }
       if(
       o instanceof Arrow
       ){
       Arrow ar = (Arrow)o;
       ar.level += incr;
       ar.adjustType();
       }
       }
     }
   }
