 import java.util.*;
 import java.awt.*;
  class Martjanova
   {
    static void prepareAlgor(Sketch s)
     {
     s.comment = prepareComment(s.comment);
     s.comment.planSize();
      for(
      int j = 0; j < s.head.size(); j++
      )
       {
       s.primitiveHead(j).text = prepareText(s.primitiveHead(j).text,Default.sketchHeadColor);
       s.primitiveHead(j).text.comment = prepareComment(s.primitiveHead(j).text.comment);
       }
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Branch br = s.branch(i);
       br.comment = prepareComment(br.comment);
        for(
        int j = 0; j < br.head.size(); j++
        )
         {
         br.primitiveHead(j).text = prepareText(br.primitiveHead(j).text,Default.branchHeadColor);
         br.primitiveHead(j).text.comment = prepareComment(br.primitiveHead(j).text.comment);
         }
        L0:
        for(
        int j = 0; j < br.body.size(); j++
        )
         {
         Object o = br.member(j);
           {
           if(
           o instanceof Sketch
           ){
           prepareAlgor((Sketch)o);
           continue L0;
           }
           }
         Primitive p = (Primitive)o;
          L1:
           {
             {
             if(
             p.type == Primitive.CONDITION
             ){
             p.text = prepareText(p.text,Default.conditionColor);
             break L1;
             }
             }
           p.text = prepareText(p.text,Default.foregroundColor);
           }
         p.text.comment = prepareComment(p.text.comment);
         }
       }
     }
    static Row prepareComment(Row r)
     {
     String s = r.toString();
     String t = "";
      L2:
      for(
      int i = 0; i < s.length(); i++
      )
       {
       String st =  s.substring(i, i+1);
       String st2 ="";
       String st3 ="";
         {
         if(
         i>0
         ){
         st3 =s.substring(i-1, i);
         }
         }
         {
         if(
         i<(s.length()-1)
         ){
         st2 =s.substring(i+1, i+2);
         }
         }
         {
         if(
         st.equals("=")
         ){
           {
           if(
           st3.equals("<")
           ){
           t +="$\\leq$";
           continue L2;
           }
           }
           {
           if(
           st3.equals(">")
           ){
           t +="$\\geq$";
           continue L2;
           }
           }
           {
           if(
           st3.equals("!")
           ){
           t +="$\\neq$";
           continue L2;
           }
           }
           {
           if(
           ((!st2.equals("="))&&(!st3.equals("=")))
           ){
           t +="$:=$";
           continue L2;
           }
           }
           {
           if(
           st2.equals("=")
           ){
           continue L2;
           }
           }
           {
           if(
           st3.equals("=")
           ){
           t +="=";
           continue L2;
           }
           }
         }
         }
         {
         if(
         (st.equals(">"))&&(st2.equals("="))||
         (st.equals("<"))&&(st2.equals("="))||
         (st.equals("!"))&&(st2.equals("="))
         ){
         continue L2;
         }
         }
         {
         if(
         st.equals("<")
         ){
         t +="$<$";
         continue L2;
         }
         }
         {
         if(
         st.equals(">")
         ){
         t +="$>$";
         continue L2;
         }
         }
         {
         if(
         st.equals(" ")
         ){
         t +="\\ ";
         continue L2;
         }
         }
         {
         if(
         st.equals("_")
         ){
         t +="\\_";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\~O";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\~o";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\\"U";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\\"u";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\\"o";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\\"o";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\\"A";
         continue L2;
         }
         }
         {
         if(
         st.equals("")
         ){
         t +="\\\"a";
         continue L2;
         }
         }
         {
         if(
         st .equals("[")
         ){
         t +="$_{";
         continue L2;
         }
         }
         {
         if(
         st.equals("]")
         ){
         t +="}$";
         continue L2;
         }
         }
         {
         if(
         (!st.equalsIgnoreCase(""))||
         (!st.equalsIgnoreCase(""))||
         (!st.equalsIgnoreCase(""))||
         (!st.equalsIgnoreCase(""))||
         (!st.equals("_"))||(!st.equals(" "))
         ){
         t +=st;
         continue L2;
         }
         }
       }
     return(
     new Row(t,Default.commentColor)
     );
     }
    static Row prepareRow(Row r)
     {
     String s =r.toString();
     s=removeKeyWords(s);
     String uus ="";
      L3:
      for(
      int i =0;i<s.length();i++
      )
       {
       String st = s.substring(i,i+1);
       String st2 ="";
       String st3 ="";
         {
         if(
         i>0
         ){
         st3 =s.substring(i-1,i);
         }
         }
         {
         if(
         i<(s.length()-1)
         ){
         st2 =s.substring(i+1,i+2);
         }
         }
         {
         if(
         (i==0)||(i==(s.length()-1))
         ){
         uus +="$";
         }
         }
         {
         if(
         st.equals("_")
         ){
         uus +="\\_";
         continue L3;
         }
         }
         {
         if(
         st.equals("%")
         ){
         uus +="\\%";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\ddot a";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\ddot o";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\ddot u";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\ddot A";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\ddot O";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\ddot U";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\tilde o";
         continue L3;
         }
         }
         {
         if(
         st.equals("")
         ){
         uus +="\\tilde O";
         continue L3;
         }
         }
         {
         if(
         st.equals("[")
         ){
         uus +="_{";
         continue L3;
         }
         }
         {
         if(
         st.equals("]")
         ){
         uus +="}";
         continue L3;
         }
         }
         {
         if(
         st.equals("=")
         ){
           {
           if(
           st3.equals("<")
           ){
           uus +="\\leq";
           continue L3;
           }
           }
           {
           if(
           st3.equals(">")
           ){
           uus +="\\geq";
           continue L3;
           }
           }
           {
           if(
           st3.equals("!")
           ){
           uus +="\\neq";
           continue L3;
           }
           }
           {
           if(
           ((!st2.equals("="))&&(!st3.equals("=")))
           ){
           uus +=":=";
           continue L3;
           }
           }
           {
           if(
           st2.equals("=")
           ){
           continue L3;
           }
           }
           {
           if(
           st3.equals("=")
           ){
           uus +="=";
           continue L3;
           }
           }
         }
         }
         {
         if(
         (st.equals(">"))&&(st2.equals("="))||
         (st.equals("<"))&&(st2.equals("="))||
         (st.equals("!"))&&(st2.equals("="))
         ){
         continue L3;
         }
         }
         {
         if(
         st.equals("*")
         ){
         uus +="\\times ";
         continue L3;
         }
         }
         {
         if(
         st.equals("&")
         ){
           {
           if(
           st3.equals("&")
           ){
           uus +="\\vee ";
           continue L3;
           }
           }
           {
           if(
           st2.equals("&")
           ){
           uus +="";
           continue L3;
           }
           }
         }
         }
         {
         if(
         st.equals("|")
         ){
           {
           if(
           st3.equals("|")
           ){
           uus +="\\wedge ";
           continue L3;
           }
           }
           {
           if(
           st2.equals("|")
           ){
           uus +="";
           continue L3;
           }
           }
         }
         }
         {
         uus +=st;
         continue L3;
         }
       }
     return(
     new Row(uus,Default.foregroundColor)
     );
     }
    static Text prepareText(Text t,Color col)
     {
     Text tulemus = new Text(col);
      for(
      int i =0; i<t.rows.size();i++
      )
       {
       Row uus = prepareRow(t.row(i));
       uus.trim();
       tulemus.insert(uus, i);
       }
     tulemus.remove(tulemus.rows.size()-1);
     tulemus.comment=t.comment;
     tulemus.setColor(col);
     return(
     tulemus
     );
     }
    static String removeKeyWords(String s)
     {
     String lo1="int short byte long float double boolean char";
     String lo2=" public static void private final transient protected";
     String lo3="abstract native syncronized volatile";
     //String lo4="(int) (short) (byte) (long) (float) (double) (boolean) (char)";
     String loetelu =lo1+lo2+lo3;//+lo4;
     StringTokenizer st = new StringTokenizer(s," (),;[",true);
     String t = "";
      L4:
      for(
      ;st.hasMoreTokens();
      )
       {
       String stToken =st.nextToken();
         {
         if(
         stToken.length()==1
         ){
         t+=stToken+" ";
         continue L4;
         }
         }
       if(
       loetelu.indexOf(stToken)== -1
       ){
       t+=stToken +" ";
       continue;
       }
       }
     return(
     t
     );
     }
   }
