 import java.awt.*;
 import java.io.File;
  class ProjectBoard
   {
   static final String PATHS = "Paths";
   static final String OPEN = "Open-script";
   static final String SAVE = "Save-script";
   static final String IMPORT = "Import";
   static final String EXPORT_PLAIN_HTML = "Export plain-HTML";
   static final String EXPORT_XML = "Export XML";
   static final String TEXTUALIZE = "Textualize+Write text";
   static final String PRINT_PLAIN_TEX = "Print plain-TEX";
   static final String READ_TEXT_SKETCHIFY = "Read text+Sketchify<";
   static String er = (Am.isWindows)? "\\" : "/"; 
    static Cursor moveToProjectFileName(Sketch project, String pFName)
     {
     Cursor cur = new Cursor(project);
      for(
      ; cur.moveDown();
      )
       {
       if(
       cur.text != null
       ){
       if(
       (cur.text.toString().trim()).equals(pFName)
       ){
       return(
       cur
       );
       }
       }
       }
     return(
     null
     );
     }
    static Sketch getProjectSketch(Branch br)
     {
     Sketch sk = (Sketch)br.parent;
      L0:
      for(;;)
       {
         {
         if(
         sk.type == Scheme.MODULE
         ){
         break L0;
         }
         }
       br = (Branch)(sk.parent);
       sk = (Sketch)(br.parent);
       if(
       sk == null
       ){
       return(
       null
       );
       }
       }
       {
       if(
       sk.body.size() != 2
       ){
       return(
       null
       );
       }
       }
       {
       if(
       br != (Branch)(sk.member(1))
       ){
       return(
       null
       );
       }
       }
     return(
     sk
     );
     }
    static Sketch getAttributeSketch(Sketch project, String attName)
     {
     Branch br = project.branch(0);
      L1:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         !(o instanceof Sketch)
         ){
         continue L1;
         }
         }
       Sketch s = (Sketch)o;
       String str = s.primitiveHead(0).text.row(0).toString().trim();
       if(
       str.startsWith(attName)
       ){
       return(
       s
       );
       }
       }
     return(
     null
     );
     }
    static Sketch getSelectionOwnProject(AmFrame pDFrame)
     {
     AmCanvas c = (AmCanvas)(pDFrame.viewArea);
      L2:
      switch(
      c.selection.kind()
      )
      {
       case
       Selection.PRIMITIVE:
       case
       Selection.PRIMITIVETEXT:
       Branch br = (Branch)(c.selection.parent());
       Sketch sk = getProjectSketch(br);
         {
         if(
         sk == null
         ){
         break L2;
         }
         }
       return(
       sk
       );
       default
       :
       {
       break;
       }
      }
     return(
     null
     );
     }
    static String getProjectFileName(AmFrame pDFrame)
     {
     AmCanvas c = (AmCanvas)(pDFrame.viewArea);
      switch(
      c.selection.kind()
      )
      {
       case
       Selection.PRIMITIVE:
       case
       Selection.PRIMITIVETEXT:
       Branch br = (Branch)(c.selection.parent());
       Sketch sk = getProjectSketch(br);
         {
         if(
         sk == null
         ){
         return(
         null
         );
         }
         }
       colorProjectFileName(pDFrame, c.selection.start.primitive, 
                                        Color.lightGray); 
       return(
       c.selection.start.primitive.text.toString().trim()
       );
       default
       :
       {
       return(
       null
       );
       }
      }
     }
    static void colorProjectFileName(AmFrame pDFrame, 
           Primitive p, Color col)
     {
     p.text.setColor(col);
     AmCanvas c = (AmCanvas)(pDFrame.viewArea);
     Graphics g = c.getGraphics();
       {
       if(
       g == null
       ){
       return;
       }
       }
     g.translate(c.start.x, c.start.y);
     p.text.draw(g);
     }
    static boolean isProjectFileNameGrayed(AmFrame pDFrame)
     {
     AmCanvas c = (AmCanvas)(pDFrame.viewArea);
      switch(
      c.selection.kind()
      )
      {
       case
       Selection.PRIMITIVE:
       case
       Selection.PRIMITIVETEXT:
       Branch br = (Branch)(c.selection.parent());
       Sketch sk = getProjectSketch(br);
         {
         if(
         sk == null
         ){
         return(
         false
         );
         }
         }
       Row r = c.selection.start.primitive.text.row(0);
       r.getElement(0);
         {
         if(
         r.sy != null
         ){
         if(
         r.sy.color == Color.lightGray
         ){
         String s = 
            c.selection.start.primitive.text.row(0).toString().trim();
          for(
          int i = 0; i < Am.frames.size(); i++
          )
           {
           AmFrame fr = (AmFrame)(Am.frames.elementAt(i));
           if(
           fr instanceof AmProjectFileFrame
           ){
           if(
           fr.getTitle().indexOf(s) >= 0
           ){
           fr.show();
           break;
           }
           }
           }
         return(
         true
         );
         }
         }
         }
       return(
       false
       );
       default
       :
       {
       return(
       false
       );
       }
      }
     }
    static String[] getAttrElements(Sketch project, String attrName)
     {
     String[] tulem = null;
       {
       Sketch attrSk = getAttributeSketch(project, attrName);
       Branch attrBr = attrSk.branch(0);
       int k = attrBr.body.size();
       tulem = new String[k];
        for(
        int i = 0; i < k; i++
        )
         {
         PrimitiveMember attrPrimitive = (PrimitiveMember)(attrBr.member(i));
         String atribuut = attrPrimitive.text.toString().trim();
           {
           if(
           attrName.equals("Paths")
           ){
           if(
           !(atribuut.endsWith(er))
           ){
           atribuut = atribuut + er;
           }
           }
           }
         tulem[i] = atribuut;
         }
       }
     return(
     tulem
     );
     }
    static String getAttrElement(String[] elements, String elemLabel)
     {
      for(
      int i = 0; i < elements.length; i++
      )
       {
       if(
       elements[i].startsWith(elemLabel)
       ){
       return(
       elements[i].substring(elemLabel.length() + 1)
       );
       }
       }
     return(
     null
     );
     }
    static String getPathForScriptAction(Sketch project, 
    String scriptName, String actionLabel)
     {
     String[] paths = getAttrElements(project, PATHS);
     String[] actions = getAttrElements(project, scriptName);
     String action = getAttrElement(actions, actionLabel);
       {
       if(
       action == null
       ){
       return(
       null
       );
       }
       }
     //System.out.println("ProjectBoard: action=" + action +"."  );
     int i = action.indexOf("path=");
       {
       if(
       i == -1
       ){
       return(
       null
       );
       }
       }
     String pathLabel = action.substring(i+5);
     i = pathLabel.indexOf(" ");
       {
       if(
       i != -1
       ){
       pathLabel = pathLabel.substring(0, i);
       }
       }
     //System.out.println("ProjectBoard: pathlabel=" + pathLabel +"."  );
     String path = getAttrElement(paths, pathLabel);
     return(
     path
     );
     }
    static String getParamForScriptAction(Sketch project, 
    String scriptName, String actionLabel, String param)
     {
     String[] actions = getAttrElements(project, scriptName);
     String action = getAttrElement(actions, actionLabel);
     //int i = action.indexOf("ext=");
     int i = action.indexOf(param + "=");
       {
       if(
       i == -1
       ){
       return(
       null
       );
       }
       }
     //String par = action.substring(i+4);
     String par = action.substring(i+param.length()+1);
     i = par.indexOf(" ");
       {
       if(
       i != -1
       ){
       par = action.substring(0, i);
       }
       }
     return(
     par
     );
     }
    static void executeScript( String pFName, String misSkript, AmProjectFileFrame frame)
     {
     Sketch project = frame.ownProject;
     String path = null;
     //System.out.println("ProjectBoard: misSkript =" +misSkript   );
      L4:
       {
         {
         if(
         misSkript.equals(OPEN)
         ){
         path = getPathForScriptAction(project, OPEN, IMPORT);
         //System.out.println("ProjectBoard: path =" + path  );
           {
           if(
           path != null
           ){
           Item0100Listener.importInto(frame, path + pFName);
           frame.contents.file.name = path + pFName;
           frame.setTitle(AmFrame.TITLE0 + " - " + path + pFName);
           }
           }
         path = getPathForScriptAction(project, OPEN, EXPORT_PLAIN_HTML);
           {
           if(
           path != null
           ){
           Item04Listener.savePlainHtml(frame, path+pFName);
           }
           }
         path = getPathForScriptAction(project, OPEN, EXPORT_XML);
           {
           if(
           path != null
           ){
           Item07Listener.saveXml(frame, path+pFName);
           }
           }
         System.out.println("ProjectBoard: --> getPathForScriptAction");
         path = getPathForScriptAction(project, OPEN, READ_TEXT_SKETCHIFY);
         System.out.println("ProjectBoard: path =" + path  );
           {
           if(
           path != null
           ){
           Item0101Listener.readTextInto(frame, path + pFName);
            L3:
             {
             String bL = 
              getParamForScriptAction(
                project, OPEN, READ_TEXT_SKETCHIFY, "base");
             byte nr = -1;
              for(
              int i = 0; i < BaseLanguage.items.length; i++
              )
               {
               if(
               BaseLanguage.items[i].equals(bL)
               ){
               nr = (byte)i;
               break;
               }
               }
             System.out.println("ProjectBoard:executeScript:bLnr="+ 
             nr);
               {
               if(
               nr == -1
               ){
               break L3;
               }
               }
             BaseLanguage.setAll(frame.contents.main, nr);
             }
           Item64Listener.sketchifyInplace(frame, frame.contents.main);
           frame.contents.file.name = path + pFName;
           frame.setTitle(AmFrame.TITLE0 + " - " + path + pFName);
           }
           }
         break L4;
         }
         }
       if(
       misSkript.equals(SAVE)
       ){
       path = getPathForScriptAction(project, SAVE, EXPORT_PLAIN_HTML);
        L5:
         {
           {
           if(
           path == null
           ){
           break L5;
           }
           }
           {
           File dirictory = new File(path);
           if(
           ! dirictory.exists()
           ){
           if(
            !dirictory.mkdirs()
           ){
           }
           }
           }
         Item04Listener.savePlainHtml(frame, path+pFName);
         frame.menuBar.setEnabled(AmLocale.Edit(), 
         AmLocale.Undo(), false);
         frame.contents.editor.stack.setEmpty();
         }
       path = getPathForScriptAction(project, SAVE, EXPORT_XML);
        L6:
         {
           {
           if(
           path == null
           ){
           break L6;
           }
           }
         Item07Listener.saveXml(frame, path+pFName);
         frame.menuBar.setEnabled(AmLocale.Edit(), 
         AmLocale.Undo(), false);
         frame.contents.editor.stack.setEmpty();
         }
       path = getPathForScriptAction(project, SAVE, TEXTUALIZE);
       System.out.println("ProjectBoard:textualizedPath:"+ path +"x");
        L7:
         {
           {
           if(
           path == null
           ){
           break L7;
           }
           }
         SketchyText skt1 = new SketchyText(null);
         skt1.main.comment = 
         new Row("This sketchy text is generated by AMADEUS",
         Default.commentColor);
         frame.contents.main.baseLanguage.textualize(frame.contents, skt1, frame);
         skt1.file = new AmFile(skt1);
         String extension = 
         getParamForScriptAction(project, SAVE, TEXTUALIZE, "ext");
         int e = pFName.lastIndexOf('.');
         String textName = pFName;
           {
           if(
           e != -1
           ){
           textName = pFName.substring(0, e);
           }
           }
         textName = textName + "." + extension;
         skt1.file.name = path + textName;
         skt1.file.writeTextFile(skt1.file.name);
         }
       path = getPathForScriptAction(project, SAVE, PRINT_PLAIN_TEX);
       //System.out.println("ProjectBoard:texPath:"+ path +"x");
        L8:
         {
           {
           if(
           path == null
           ){
           break L8;
           }
           }
         String textName = pFName;
         int e = pFName.lastIndexOf('.');
           {
           if(
           e != -1
           ){
           textName = pFName.substring(0, e);
           }
           }
         String extension = 
         getParamForScriptAction(project, SAVE, PRINT_PLAIN_TEX, "ext");
          L9:
           {
             {
             if(
             extension == null
             ){
             textName = textName + ".tex";
             break L9;
             }
             }
           textName = textName + "." + extension;
           }
         String texFileName = path + textName;
         //System.out.println("ProjectBoard: exec saveScript: tex nimi: "+texFileName);
         Sketch source = frame.contents.main;
         String res = Sketch2TexPlain.s2t(source, texFileName); 
           {
           if(
           (res != null)
           ){
           AmDialog d = new AmDialog(frame, AmLocale.Print()+AmLocale.plain()+"-TEX",
           AmDialog.B_OK, AmLocale.Failed()+". "+ res);
           }
           }
         if(
         Am.isWindows
         ){
         ((AmCanvas)(frame.viewArea)).repaint();
         }
         }
       }
       }
     }
   }
