import java.io.*;
import java.util.*;
//import java.awt.Color;
//import java.awt.Font;

/**
 * Tehakse Skeemist HTML fail 
 *
 *@author Roman Ustich & J.Kiho
 */


class Sketch2Html {
//Roman Ustich    
    static int table_size=40;
    static int offset,offset2;
    static String[] m = new String[40];
    static boolean closed;
    static Stack SchemeStack = new Stack();
    static Stack IdStack = new Stack();
    static int countS;
    static int levelOfBlock = 0;//
//Roman Ustich
    static final String TITLE = "<HTML><BODY>AMADEUS html";
    
    static PrintWriter out;  // globaalne muutuja faili kirjutamiseks
    // kas reavahetus no~utud:
    static boolean lastNotEmptyText = false;
    //Roman Ustich
    static void closeRow(){
        
        write2file("<td colspan = \"" +str(table_size-offset - offset2) + "\" ></td></tr>");
        offset2 = 0;
        closed = true;
    }
    static void initPrint(){
        write2file("<tr>");
        for(int i=0;i<offset;i++)
    	write2file("<td><center><font color = \"blue\">"+m[i]+"</color></center></td>");
    }
    static void initPrint(int lev){
        write2file("<tr>");
        for(int i=0;i<lev;i++)
    	write2file("<td><center><font color = \"blue\">"+m[i]+"</color></center></td>");
    }  
  
  // Kirjutame etteantud stringi faili
    static void write2file (String buf) {

buf = code(buf);//teisendada suuremad koodidv	
    out.println(buf);
  } // write2file
  //seesama aga ilma LINEBREAKi - write2fileNoReturn
  static void write2fileNR(String buf){
buf = code(buf);//teisendada suuremad koodid	
    out.print(buf);
  }
static String code(String buf){
    StringBuffer sbuf = new StringBuffer();
    char c;
    for(int i = 0; i < buf.length(); i++){
	c = buf.charAt(i);
//System.out.println("Sketch2Html:"+((int)c));	
	if(((int)c) < 256) sbuf.append(c);
	else{
	    sbuf.append("&#");
	    sbuf.append(Integer.toString((int)c));
	    sbuf.append(';');   
	}
    }
    return sbuf.toString();
}
  // Kirjutab faili html-i headeri
  static void writeHeader(String title) {
    write2file("<!--- This file is generated by AMADEUS. --->");
    write2file(TITLE);
  }

  // Lotilde;petame html-i korralikult auml;ra ka
  static void writeFooter() {
    write2file("</BODY>");
    write2file("</HTML>");
  }
  static void printComment(String comm){
    //write2file("<font color = \"green\">");
    write2fileNR("<!8>");
    write2file(comm);
    //write2file("</font>");
  }
  
  static String generateId(){
    return(str(countS++));
  }


  // Kirjutatakse faili lihtliige
  static void writePrimitiveMember(PrimitiveMember p) {
    if(closed == false) closeRow();
        initPrint();
    
    
    //Roman Ustich
        
    switch (p.type){
      case Primitive.SIMPLE:
        write2file("<!20>");
        write2file("<td colspan = \"" + str(table_size-offset - offset2)+"\">");
        writeText(p.text, "");
        write2file("</td></tr>");
        write2file("<!9>");
        closed = true;
      break;
      case Primitive.CONDITION:
        write2file("<!21>");
        write2file("<td><font color =\"red\">?</font></td>");
        offset2 = 1;
        write2file("<td colspan = \"" + str(table_size-offset - offset2)+"\">");
        //write2file("<font color = \"red\">");
        writeText(p.text, "");
        //write2file("</font>");
        write2file("</td></tr>");
        offset2=0;
        closed = true;
        write2file("<!9>");
      break;
    }
    
  }
  
  
  /*
  static void writerow2file(Row r)
  {
    int i;
    boolean opened = false;
    String cur_color="" ;
    String cur_font="" ;
    
    //String str;
    
    for(i = 1; i < r.elements.size(); i++){
	    r.getElement(i);
	    
	    
	    //str = "";
	    if(r.sy != null)
	    {
	        if(opened == false) // on vaja avada tag <font>
	        {
	            write2fileNR("<font color = " +toColor(r.sy.color) + "face = " + toFont(r.sy.font) +">");
	            opened = true;
                out.print(r.sy.c);
                //write2fileNR(String(r.sy.c));  
	            cur_color = toColor(r.sy.color);
	            cur_font = toFont(r.sy.font);
	            continue;
	        }
	        //opened == true
	        if(cur_color.compareTo(toColor(r.sy.color))!=0 || cur_font.compareTo(toFont(r.sy.font))!=0)
	            {
	                write2fileNR("</font>");
	                write2fileNR("<font color = " +toColor(r.sy.color) + "face = " + toFont(r.sy.font) +">");
	                cur_color = toColor(r.sy.color);
	                cur_font = toFont(r.sy.font);
	            }
	         //write2fileNR(String(r.sy.c));
	         out.print(r.sy.c);
            
        }
        
       
  }
   //suletame 
   write2fileNR("</font>");
    
  }
  
  */
  static void writeText(Text t, String st0){
    
    //if(lastNotEmptyText) write2file("<!br><br>");
    // st0 - esimese rea algusse
    //writerow2file(t.row(0));
    //write2file(t.row(0).toString());
    
    write2file("<!5>"+t.row(0).toHTMLString());
    for(int i = 1; i < t.rows.size(); i++)
	//write2file(t.row(i).toString());
	write2file("<!5>"+t.row(i).toHTMLString());
	//writerow2file(t.row(i));
    // kommentaar
    if(t.comment.toString().length()!=0){
        
        printComment(t.comment.toHTMLString());
        
        }
    
        
  }
  static void writeArrowText(Text t){
    // st0 - esimese rea algusse
    // st1 = endlevel+100(3sy) - kommentaari algusse lisaks
    //write2file("<!BEGIN ARROW TEXT>");
    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
    write2file("<!5>"+t.row(0).toHTMLString());
    for(int i = 1; i < t.rows.size(); i++)
	write2file("<!5>"+t.row(i).toHTMLString());
    // kommentaar
    if(t.comment.toString().length()!=0)
        printComment(t.comment.toHTMLString());
        
    write2file("</tr>");
    closed = true;
    //write2file("<!END ARROW TEXT>");
  }

  // Kirjutame Arrow-tyypi objekti faili
  static void writeArrow(Arrow a, int startLevel) {
    // noole algus
    int level = a.level; // otsatase
    String tmp = new String();
    if(a.type==Arrow.STRONG)
        tmp = "-";
        else
        tmp = "~";
    // redutseerida pseudo
    write2file("<!2"+str(a.type)+str(level)+">");
    if(level<=levelOfBlock){//arrow points outside of subscheme
        level = -2;
    }else
        level = level - levelOfBlock;
    initPrint(level/2+1);
    write2file("<td><center><font color = \"red\"><"+tmp+"</font></center></td>");
    for(int i=level/2+1;i<offset;i++)
    {
        write2file("<td><center><font color = \"red\">"+tmp+"</font></center></td>");
    }
    writeArrowText(a.text);	
	
    // noole lo~pp
     //for(i = 0; i <= len/2; i++)
	//write2file("<ul>");
	
    write2file("<!9>"); 	
  }


  // Kirjutame pauml;ise faili
  static void writeHead(Scheme s) {
    String c ;
    int n = s.head.size();
    if(n==0) return;
    if(closed == false) closeRow();
	
	if(s instanceof Sketch)
	    c= new String("blue");
	    else
	    c= new String("purple");
	
    for(int i = 0; i < n; i++){
	initPrint();
	PrimitiveHead he = s.primitiveHead(i);
	// lihtpa"ise algus
    //    String st = str((int)(he.type));
	//write2file(st);
	 
	// lihtpa"ise tekst
    
	switch (he.type){
	case PrimitiveHead.SIMPLE:
	    write2file("<!30>");
	    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
	    //write2file("<font color = " +c + ">");
	    writeText(he.text, "");
	    //write2file("</font>");
	    write2file("</td></tr>");
	    closed = true;
	    break;
	case PrimitiveHead.LOOP:
	    
	    write2file("<!31>");
	    write2file("<td><font color = \"blue\">*</font></td>");
	    offset2++;
	    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
	    //write2file("<font color = " +c + ">");
	    writeText(he.text, "");
	    //write2file("</font>");
	    write2file("</td></tr>");
	    closed = true;
	    offset2 = 0;
	    break;
	case PrimitiveHead.SWITCH:
	    write2file("<!32>");
	    write2file("<td><font color = \"blue\">??</font></td>");
	    offset2++;
	    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
	    //write2file("<font color = " +c + ">");
	    writeText(he.text, "");
	    //write2file("</font>");
	    write2file("</td></tr>");
	    offset2 = 0;
	    closed = true;
	    break;
	case PrimitiveHead.TRY:
	    write2file("<!35>");
	    write2file("<td><font color = \"blue\">!!</font></td>");
	    offset2++;
	    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
	    //write2file("<font color = " +c + ">");
	    writeText(he.text, "");
	    //write2file("</font>");
	    write2file("</td></tr>");
	    offset2 = 0;
	    closed = true;
	    break;
	case PrimitiveHead.CASE:
	    write2file("<!33>");
	    write2file("<td><font color = \"blue\">?</font></td>");
	    offset2++;
	    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
	    //write2file("<font color = " +c + ">");
	    writeText(he.text, "");
	    //write2file("</font>");
	    write2file("</td></tr>");
	    offset2 = 0;
	    closed = true;
	    break;
	case PrimitiveHead.DEFAULT:
	    write2file("<!34>");
	    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
	    //write2file("<font color = " +c + ">");
	    writeText(he.text, "");
	    //write2file("</font>");
	    write2file("</td></tr>");
	    closed = true;
	    break;
	case PrimitiveHead.CATCH:
	    write2file("<!36>");
	    write2file("<td><font color = \"blue\">!</font></td>");
	    offset2++;
	    write2file("<td colspan = \""+str(table_size-offset-offset2)+"\">");
	    //write2file("<font color = " +c + ">");
	    writeText(he.text, "");
	    //write2file("</font>");
	    write2file("</td></tr>");
	    closed = true;
	    break;
	}//switch
	write2file("<!9>");
    }//for
    
  }


  // See meetod tegeleb skeemi labivaatamise ja faili
  // kirjutamisega
  static void writeScheme(Scheme s) {
    Object o;
    // skeemi algust tauml;histab  <! tyyp bl view icon>
    String type = str((int)(s.type));
    String bl = str((int)(s.baseLanguage.type));
    String view = str((int)(s.view.type));
    String icon;
    String tmp="||";
    String tmp1 = "-";
    if(s.icon){
        s.icon = false;
        SchemeStack.push(s);
        
        String t = new String (generateId());
        IdStack.push(t);
        initPrint();
        if(s instanceof Branch)
        {
            write2file("<td colspan = \"" + str(table_size -offset - offset2) + "\"><A HREF = \"#" + t +"\">Branch " + t + "</A>");
            String comm = s.comment.toHTMLString();
            if(comm.length()!=0)
                //printComment(comm);
                write2file(comm);
            write2file("</td>");
        }   
           else
           {
            write2file("<td colspan = \"" + str(table_size -offset - offset2) + "\"><A HREF = \"#" + t +"\">Sketch " + t+"</A>");   
            String comm = s.comment.toHTMLString();
            if(comm.length()!=0)
                //write2file("<font color = \"green\">"+comm +"</font>");
                write2file(comm);
                
            write2file("</td>");
           }
        
            
        write2file("<!6"+t+">");
        
        return;
    }
    else icon = "0";
    
    
    
    
    
    
    if(s instanceof Branch) {
        write2file("<!1"+ type+icon + bl+view+">"); 
        //Roman Ustich 
        if (closed == false) closeRow();
        initPrint();
        closed = false;
        //Roman Ustich
        
        
        
    }
        else{
            switch (s.type){
                case Scheme.SIMPLE :
                tmp="|";
                tmp1="-";
                break;
                case Scheme.LOOP :
                tmp = "||";
                tmp1 = "=";
                break;
                case Scheme.MODULE :
                tmp = "#";
                tmp1 = "#";
                break;
            }
                write2file("<!0"+type+icon+bl+view+">");
                if(closed == false)
                closeRow();
                initPrint();
        
                write2file("<td><center><font color = \"blue\">"+tmp+"</color></center></td><td><font color = \"blue\">"+tmp1+"</font></td>");
                offset2 = 1;
                closed = false;
                m[offset]=tmp;
                offset++;
        }
    String comm = s.comment.toHTMLString();
    if(comm.length()!=0)
    {
        write2file("<td colspan = \"" + str(table_size -offset - offset2) + "\">");   
        printComment(comm );
        write2file("</td></tr>");
        offset2 = 0;
        closed = true;
    }
    writeHead(s);
    // skeemi keha algus
      
    for (Enumeration e = s.body.elements(); e.hasMoreElements(); ){
	o = e.nextElement();

	if (o instanceof Scheme) // tegemist skeemiga
	    writeScheme((Scheme)o);
	else if(o instanceof Arrow)
	    writeArrow((Arrow)o, s.level());
	else
	    writePrimitiveMember((PrimitiveMember)o);
	    
    }
    // skeemi lo~pp
    if(s instanceof Branch) 
	write2file("<!9>");  // haru keha l6putunnus
    else {
        
	//write2file(line); // skeemi lo~pujoon <HR ..
        initPrint();
        write2file("<td><font color = \"blue\">"+tmp1+".</font></td>");
        offset2=1;
        closeRow();
        offset--;
        write2file("<!9>");
    }
    lastNotEmptyText = false;

  }
  
  // abiks
  static private String str(int n){
    return (new Integer(n)).toString(); 
  }
  
  // Votilde;tame vastu 2 parameetrit: Sketchi ja faili nime
  // parameetriteks olgu sketch ja failinimi kuhu ta HTML-iseerida.
  
  static void writeSketchId(String str){
    write2file("<tr><td colspan = \"40\"><A NAME = \""+str +"\">Sketch " +str +"</A></td></tr>");
    write2file("<!7"+str +">");
  }
  static void writeBranchId(String str){
    write2file("<tr><td colspan = \"40\"><A NAME = \""+str +"\">Branch " +str +"</A></td></tr>");
    write2file("<!7"+str +">");
  }  
  
  
  static public void s2h (Scheme s, String fname) {

    // Avame etteantud nimelise faili
    try {
      out = new PrintWriter(new FileWriter(fname));
    }
    // pyyame exceptioni kui ei 6nnestunud faili luua
    catch (IOException e) {
      System.err.println("Caught IOException: " + e.getMessage());
    }
    
    countS = 0;
    levelOfBlock = 0;
    writeHeader(TITLE);
    //kirjutame tabeli pais
    write2file("<table BORDER=\"0\" cellpadding = \"0\" cellspacing =\"0\" COLS=40 WIDTH=\"100%\">");
    write2file("<tr>");
    for(int i=0;i<table_size;i++)
        write2fileNR("<td></td>");
    write2file("</tr>");
    //Pais tehtud
    offset = 0;
    offset2 = 0;
    
    writeScheme(s);
    
    while(!SchemeStack.empty()){
        
        offset = 0;
        offset2 = 0;
        Scheme sh = (Scheme)SchemeStack.pop();
        if (sh instanceof Branch)
                writeBranchId((String)IdStack.pop());
            else
                writeSketchId((String)IdStack.pop());
        levelOfBlock = sh.level();
        writeScheme(sh);
        sh.icon=true;
    }
    
    //sulgeme tabel
    write2file("</table>");
    writeFooter();

    // fail kinni
    out.close();
  }
} // Sketch2HTML
