 import java.util.*;
  class UndoCutHeads extends Undo
   {
   Scheme s;
   Caret caretkeep;
   Vector members;
   int i;
   int j;
    UndoCutHeads(Scheme ss, int ii, int jj, Caret car)
     {
     s = ss;
     i = ii;
     j = jj;
     members = new Vector();
      for(
      int k = i; k <= jj; k++
      )
       {
       members.addElement(s.primitiveHead(k));
       }
     caretkeep = car.make_Copy();
     }
    public  void undo(Editor ed)
     {
      L0:
       {
         {
         if(
         ed.isRedoing
         ){
         ed.stack.push(new UndoInsertHeads(s,i,j-i+1,caretkeep));
         break L0;
         }
         }
       ed.redoStack.push(new UndoInsertHeads(s,i,j-i+1,caretkeep));
       }
      for(
      int m = 0, k = i; k <= j; k++, m++
      )
       {
       Object o = members.elementAt(m);
       PrimitiveHead h = (PrimitiveHead)o;
       s.insert(h, k);
       h.text.invalidate();
       }
     ed.caret = caretkeep.make_Copy();
     AmCanvas c = ed.sketchyText.frame.viewArea;
     ed.sketchyText.main.view.plan(c.hd, c.vd);
     c.caretToScreen();
     }
   }
