 import java.awt.*;
 import java.util.*;
  abstract class View extends Rectangle
   {
   static final byte SKETCHY = 0;
   static final byte BOX = 1;
   static final byte SKETCHY_PLUS = 2;
   static final byte LATEX = 3;
   static final byte STREE = 4;
   static final byte MTREE = 5;
   static final byte DTREE = 6;
   static final byte XML = 7;
   static final byte TABLE = 8;
   byte type;
   Scheme sk;
    View(Scheme s)
     {
     sk = s;
     }
   abstract Rectangle getLineArea(Scheme s);
   abstract void plan(int x, int y);
   abstract void draw(Graphics g);
    public void translate(Primitive p, int xt, int yt)
     {
     p.text.translate(xt, yt);
     p.text.comment.translate(xt, yt);
      for(
      int i = 0; i < p.text.rows.size(); i++
      )
       {
       p.text.row(i).translate(xt, yt);
       }
     }
    public void translate(Scheme s, int xt, int yt)
     {
      L0:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
          o instanceof Scheme
         ){
         translate((Scheme)o, xt, yt);
         continue L0;
         }
         }
       translate((Primitive)o, xt, yt);
       }
     s.comment.translate(xt, yt);
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead h = (PrimitiveHead)(e.nextElement());
       translate(h, xt, yt);
       }
     s.view.translate(xt, yt);
     }
   //abstract void pointLocation(Point p, Scheme s);
    public void pointLocation(Point p, Scheme s)
     {
       {
       if(
       result != null
       ){
       return;
       }
       }
       {
       if(
       !s.view.contains(p)
       ){
       return;
       }
       }
       {
       if(
       s.icon
       ){
       result = new Cursor(s);
       return;
       }
       }
      L1:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
          o instanceof Scheme
         ){
         pointLocation(p, (Scheme)o);
           {
           if(
           result != null
           ){
           return;
           }
           }
         continue L1;
         }
         }
       result = new Cursor(s);
         {
         if(
         pointLocation(p, ((PrimitiveMember)o).text)
         ){
         result.primitive = (PrimitiveMember)o;
         moveCursorToPointInRow(result, p);
         return;
         }
         }
       result = null;
       }
       {
       if(
       getLineArea(s).contains(p)
       ){
       result = new Cursor(s);
       return;
       }
       }
     result = new Cursor(s);
       {
       if(
       pointLocation(p, s.comment)
       ){
       result.primitive = null;
       moveCursorToPointInRow(result, p);
       return;
       }
       }
     result = null;
     result = new Cursor(s);
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead h = (PrimitiveHead)(e.nextElement());
       if(
       pointLocation(p, h.text)
       ){
       result.primitive = h;
       moveCursorToPointInRow(result, p);
       return;
       }
       }
     result = null;
     }
    private static void 
    moveCursorToPointInRow(Cursor result, Point p)
     {
     result.noInRow = 1;
     Row r = result.row;
     int shift = (((Symbol)r.elements.elementAt(0))).width();
      L2:
      for(
      int i = 1; i < r.elements.size(); i++
      )
       {
         {
         if(
         (r.x + shift) > p.x
         ){
         break L2;
         }
         }
       result.noInRow++;
       r.getElement(i);
         {
         if(
         r.sy != null
         ){
         shift += r.sy.width();
         continue L2;
         }
         }
       ;
       }
     }
   static Cursor result;
    boolean pointLocation(Point p, Row r)
     {
       {
       if(
       (r.contains(p))
       ){
       View.result.row = r;
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    boolean pointLocation(Point p, Text t)
     {
      for(
      Enumeration e = t.rows.elements(); e.hasMoreElements();
      )
       {
       Row r = ((Row)(e.nextElement()));
       if(
       (pointLocation(p, r))
       ){
       result.text = t;
       return(
       true
       );
       }
       }
       {
       if(
       (pointLocation(p, t.comment))
       ){
       View.result.text = null;
       View.result.row = t.comment;
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    boolean pointLocation(Point p, Primitive pr)
     {
       {
       if(
       (pointLocation(p, pr.text))
       ){
       View.result.primitive = pr;
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
   static String[] items =
     {
     AmLocale.Sketches(), AmLocale.Boxes(),
     AmLocale.SketchesPlus(), "LaTeX", AmLocale.STree(),
     AmLocale.MTree(), AmLocale.DTree(), "XML", 
     AmLocale.Table()
     }
   ;
   static AmList list;
    static boolean userSetAll(Scheme s, AmFrame frame)
     {
     list = new AmList(items);
     AmDialog d = new AmDialog
     (frame, AmLocale.View(),AmDialog.B_SELECT_CANCEL,
     AmLocale.Select_view()+".",
     (AmList)list);
     int bli = -999;
      switch(
      d.getTulemus()
      )
      {
       case
        AmDialog.CANCEL:
       return(
       false
       );
       case
        AmDialog.SELECT:
       bli = list.getSelectedIndex();
       break;
      }
      switch(
      bli
      )
      {
       case
        BOX:
       setAll(s, BOX);
       break;
       case
        SKETCHY:
       setAll(s, SKETCHY);
       break;
       case
        SKETCHY_PLUS:
       setAll(s, SKETCHY_PLUS);
       break;
       case
        LATEX:
       setAll(s, LATEX);
       break;
       case
       STREE:
        L3:
         {
           {
           if(
           ((Sketch)s).isAllMono()
           ){
           setAll(s, STREE);
           break L3;
           }
           }
         return(
         false
         );
         }
       case
       MTREE:
       setAll(s, MTREE);
       break;
       case
       DTREE:
       setAll(s, DTREE);
       break;
       case
       XML:
       setAll(s, XML);
       break;
       case
       TABLE:
       setAll(s, TABLE);
      }
     return(
     true
     );
     }
    static void setAll(Scheme s, int type)
     {
     set(s, type);
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
       if(
       o instanceof Scheme
       ){
       setAll((Scheme)o, type);
       }
       }
     }
    static void set(Scheme s, int type)
     {
      switch(
      type
      )
      {
       case
        BOX:
       s.view = new ViewBox(s);
       break;
       case
        SKETCHY:
       s.view  = new ViewSketchy(s);
       break;
       case
        SKETCHY_PLUS:
       s.view  = new ViewSketchyPlus(s);
       break;
       case
        LATEX:
       s.view  = new ViewLatex(s);
       break;
       case
       STREE:
         {
         if(
         (s instanceof Branch) || ((Sketch)s).isAllMono()
         ){
         s.view  = new ViewSTree(s);
         }
         }
       case
       MTREE:
       s.view  = new ViewMTree(s);
       break;
       case
       DTREE:
       s.view  = new ViewDTree(s);
       break;
       case
       XML:
       s.view  = new ViewXml(s);
       break;
       case
       TABLE:
       s.view  = new ViewTable(s);
      }
     }
    static View newView(int type, Scheme s)
     {
      switch(
      type
      )
      {
       case
        SKETCHY:
       return(
       new ViewSketchy(s)
       );
       case
        BOX:
       return(
       new ViewBox(s)
       );
       case
        SKETCHY_PLUS:
       return(
       new ViewSketchyPlus(s)
       );
       case
        LATEX:
       return(
       new ViewLatex(s)
       );
       case
       STREE:
       return(
       new ViewSTree(s)
       );
       case
       MTREE:
       return(
       new ViewMTree(s)
       );
       case
       DTREE:
       return(
       new ViewDTree(s)
       );
       case
       XML:
       return(
       new ViewXml(s)
       );
       case
       TABLE:
       return(
       new ViewTable(s)
       );
      }
     return(
     null
     );
     }
   }
