 import java.util.*;
 import java.awt.*;
  class ViewSTree extends View
   {
   static final int hd = 15;
   static final int vd = 5;
   static final int vstep = 4*vd;
   static Color color = Default.sketchLineColor;
   static Color colorBr = Default.branchHeadColor;
   static int iconw;
   static int iconh;
   static int laius;
    ViewSTree(Scheme s)
     {
     super(s);
     type = View.STREE;
     }
    public Rectangle getLineArea(Scheme s)
     {
     return(
     new Rectangle(s.view.x, s.view.y, hd, s.view.height)
     );
     }
    private Rectangle getNodeArea(Scheme s)
     {
     int hhe = vd;
     int ww = hd;
     int x = s.view.x;
     int y = s.view.y;
      for(
      int i = 0; i < s.head.size(); i++
      )
       {
       PrimitiveHead he = s.primitiveHead(i);
         {
         if(
         i == 0
         ){
         x = he.text.x;
         y = he.text.y;
         }
         }
       hhe += he.text.height + vd;
         {
         if(
         he.text.width > ww
         ){
         ww = he.text.width;
         }
         }
       }
     return(
     new Rectangle(x, y, ww, hhe-vd)
     );
     }
    private Rectangle getTextArea(Text t)
     {
     int iLast = t.rows.size()-1;
     Row last = t.row(iLast);
     int wLast = last.width + t.comment.width; 
     return(
     new Rectangle(t.x, t.y, Math.max(wLast, t.width), t.height)
     );
     }
    private void drawSkLine(Graphics g, Scheme s)
     {
     Rectangle rk = getLineArea(s);
     int xx= rk.x, yy=rk.y,  korgus=rk.height;
     laius=rk.width;
     int xja = xx + 1;
     int xjl = xja;
     int dd = (s.comment.width == 0)? 0 :  vd;
     int yja = yy + (s.comment.height - dd) / 2;
     int yjl = yy + korgus - 3;
       {
       }
     g.setColor(color);
      L0:
       {
         {
         if(
         (s instanceof Branch)
         ){
         int vahe1 = laius/4;
           {
           if(
           (vahe1 < 1)
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           (s.parent.type == Scheme.MODULE)
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           (s.parent.type == Scheme.SIMPLE)
           ){
           vahe1 = 0;
           }
           }
         int xsa = xja + vahe1;
           {
           if(
           ((!(((Sketch)(s.parent)).isMono())) ||
           (((Sketch)(s.parent)).head.size() > 0) ||
           (s.type != Scheme.SIMPLE))
           ){
            switch(
            s.type
            )
            {
             case
              Scheme.LOOP:
             case
              Scheme.MODULE:
             int vahe = laius/4;
               {
               if(
               (vahe < 1)
               ){
               vahe = 1;
               }
               }
               {
               if(
               (s.type == Scheme.MODULE)
               ){
               vahe = 1;
               }
               }
             int xva, yva;
             int ysa;
             xva = xja; yva = yja-vahe;
             ysa = yva + vahe;
             g.drawLine(xsa, yva, xva + laius - 2, yva);
             g.drawLine(xsa, ysa, xva + laius - 2, ysa);
             break;
             default
             :
             {
             g.drawLine(xsa, yja, xja + laius - 2 - 1, yja);
             break;
             }
            }
           }
           }
         break L0;
         }
         }
        switch(
        s.type
        )
        {
         case
          Scheme.LOOP:
         case
          Scheme.MODULE:
         int vahe = laius/4;
           {
           if(
           (vahe < 1)
           ){
           vahe = 1;
           }
           }
           {
           if(
           (s.type == Scheme.MODULE)
           ){
           vahe = 1;
           }
           }
         int xva, yva, xvl, yvl;
         int xsa, ysa, xsl, ysl;
         xva = xja; yva = yja-vahe; xvl = xjl; yvl =yjl+vahe;
         xsa = xva + vahe; ysa = yva + vahe; xsl = xsa; ysl = yvl - vahe;
         g.drawLine(xva, yva, xvl, yvl);
         g.drawLine(xva+1, yva, xva + laius - 2, yva);
         g.drawLine(xvl+1, yvl, xvl + laius - 2, yvl);
         g.drawLine(xsa, ysa, xsl, ysl);
         g.drawLine(xsa+1, ysa, xva + laius - 2, ysa);
         g.drawLine(xsl+1, ysl, xvl + laius - 2, ysl);
         break;
         default
         :
         {
         g.drawLine(xja, yja, xjl, yjl);
         g.drawLine(xja+1, yja, xja + laius - 2, yja);
         g.drawLine(xjl+1, yjl, xjl + laius - 2, yjl);
         break;
         }
        }
       }
     }
    public void plan(int x0, int y0)
     {
     PrimitiveHead h;
     PrimitiveMember nsk;
     Arrow ar;
       {
       if(
        (sk.icon)
       ){
       x = x0; y = y0;
       iconw = sk.comment.height;
       iconh = iconw;
       width = iconw + 8;
       height = iconh + 4;
       return;
       }
       }
     Rectangle rc = getNodeArea(sk);
     int hhe = rc.height;
     int ww = rc.width;
     hhe += sk.comment.height;
       {
       if(
       sk.comment.width > ww
       ){
       ww = sk.comment.width;
       }
       }
     int xCurr = x0;
     int yy= y0+hhe+vstep;
     int hh = 0;
      L2:
      for(
      int i = 0; i < sk.body.size(); i++
      )
       {
       Object o = sk.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme ss = (Scheme)o;
          L1:
           {
             {
             if(
             (ss instanceof Sketch)
             ){
             ss.view.plan(xCurr+hd, yy);
             xCurr += ss.view.width + hd;
               {
               if(
               (ss.view.height > hh)
               ){
               hh = ss.view.height;
               }
               }
             break L1;
             }
             }
           ss.view.plan(xCurr+1, yy - vstep);
          xCurr += ss.view.width+hd;
             {
             if(
             (ss.view.height > hh)
             ){
             hh = ss.view.height;
             }
             }
           }
         continue L2;
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
       ns.text.plan(xCurr+hd, yy);
       xCurr += ns.text.width + hd;
         {
         if(
         (ns.text.height > hh)
         ){
         hh = ns.text.height;
         }
         }
       }
     sk.comment.plan(sk.comment.x, sk.comment.y);
     int xNode = (x0 + xCurr)/2 - ww/2 +hd;
     xNode = Math.max(xNode, x0);
     sk.comment.x = xNode;
     sk.comment.y = y0;// - sk.comment.height/2;
     yy = sk.comment.y + sk.comment.height +vd;
       {
       if(
       (sk.head.size() != 0)
       ){
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
         he.text.plan(xNode, yy);
         yy += he.text.height + vd;
         }
       }
       }
     x = x0;
     y = y0;
     height = hh + hhe + vstep;
     width = xCurr - x0 + hd;
     width = Math.max(Math.max(sk.comment.width, rc.width), width);
     //add(getNodeArea(sk));
     }
    public void  draw(Graphics g)
     {
     Scheme s = super.sk;
     Scheme parent = s.parent;
       {
       if(
       (s.icon)
       ){
        L3:
         {
           {
           if(
           (s instanceof Sketch)
           ){
           g.setColor(color);
           break L3;
           }
           }
         g.setColor(colorBr);
         }
       int luX = x + 6;
       int luY = y + 2;
       g.drawRect(luX, luY, iconw, iconh);
       g.drawLine(luX, luY, luX + iconw - 1, luY + iconh - 1);
        L4:
         {
           {
           if(
           (!s.comment.isTrivial())
           ){
           g.setColor(Default.commentColor);
           g.drawString(s.comment.toString(),
           x + width + 2, y + iconh);
           break L4;
           }
           }
         if(
         (s.head.size() != 0)
         ){
          L5:
           {
             {
             if(
             (s instanceof Sketch)
             ){
             g.setColor(color);
             break L5;
             }
             }
           g.setColor(colorBr);
           }
         g.drawString(s.primitiveHead(0).text.row(0).toString(),
         x + width + 2, y + iconh);
         }
         }
       return;
       }
       }
       {
       drawSkLine(g,s);
       s.comment.draw(g);
       }
     int yy = s.comment.height + vd;
     int x1 = x + hd/2;
     Rectangle rk = getNodeArea(sk);
     g.drawOval(rk.x, rk.y, rk.width, rk.height);
       {
       if(
       s instanceof Sketch
       ){
       if(
       parent != null
       ){
       parent = parent.parent;
       Rectangle r = getNodeArea(parent);
       int xParent = r.x + r.width/2;
       int yParent = r.y + r.height;
       g.drawLine(rk.x +rk.width/2, rk.y, xParent, yParent);
       }
       }
       }
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead he = (PrimitiveHead)(e.nextElement());
       he.text.draw(g);
       g.setColor(color);
        switch(
         he.type
        )
        {
         case
          PrimitiveHead.LOOP:
         g.setFont(Default.font);
         g.drawString("*", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.SWITCH:
         g.setFont(Default.font);
         g.drawString("??", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CASE:
         case
          PrimitiveHead.DEFAULT:
         g.setFont(Default.font);
         g.drawString("?", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.TRY:
         g.setFont(Default.font);
         g.drawString("!!", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CATCH:
         case
          PrimitiveHead.FINALLY:
         g.setFont(Default.font);
         g.drawString("!", x1, y+yy + he.text.height*3/4);
         break;
        }
       yy += he.text.height;
       }
      L6:
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Object o = e.nextElement();
         {
         if(
         (o instanceof Scheme)
         ){
         ((Scheme)o).view.draw(g);
         continue L6;
         }
         }
         {
         if(
          (o instanceof Arrow)
         ){
         Arrow ar = (Arrow)o;
         ar.text.draw(g);
         g.setColor(Default.arrowColor);
         int length = s.level() - ar.level + 1;
           {
           if(
           (ar.type == Arrow.WEAK)
           ){
           length += 1;
           }
           }
         int endx = ar.text.x - length*laius/2;
         int yy0 = ar.text.y + ((Row)(ar.text.rows.elementAt(0))).height/2;
          L7:
           {
             {
             if(
             (ar.type == Arrow.WEAK)
             ){
             endx += laius/2;
              for(
              int i = endx; i < ar.text.x; i += laius*2/3
              )
               {
               g.drawLine(i, yy0, i + laius/3, yy0);
               }
             break L7;
             }
             }
           g.drawLine(ar.text.x, yy0,
           endx, yy0);
           }
         g.drawLine(endx, yy0, endx + 4, yy0 - 2);
         g.drawLine(endx, yy0, endx + 4, yy0 + 2);
         continue L6;
         }
         }
       if(
       (o instanceof PrimitiveMember)
       ){
       PrimitiveMember ns = (PrimitiveMember)o;
        switch(
         ns.type
        )
        {
         case
          Primitive.CONDITION:
         g.setFont(Default.font);
         g.setColor(Default.conditionColor);
         g.drawString("?", x1, ns.text.y + ns.text.height*3/4);
         break;
        }
       ns.text.draw(g);
       rk = getTextArea(ns.text);
       g.drawOval(rk.x, rk.y, rk.width, rk.height);
         {
         Rectangle r = getNodeArea(s.parent);
         int xParent = r.x + r.width/2;
         int yParent = r.y + r.height;
         g.drawLine(rk.x +rk.width/2, rk.y, xParent, yParent);
         }
       }
       }
     }
    public void pointLocation(Point p, Scheme s)
     {
       {
       if(
       (result != null)
       ){
       return;
       }
       }
       {
       if(
       (!s.view.contains(p))
       ){
       return;
       }
       }
       {
       if(
       (s.icon)
       ){
       result = new Cursor(s);
       return;
       }
       }
      L8:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme sk = (Scheme)o;
         pointLocation(p, sk);
           {
           if(
           (result != null)
           ){
           return;
           }
           }
         continue L8;
         }
         }
       result = new Cursor(s);
       System.out.println("ViewSketchy: on mitteskeem");
         {
         if(
         (pointLocation(p, ((PrimitiveMember)o).text))
         ){
         System.out.println("ViewSketchy: punkt on mitteskeemis");
         result.primitive = (PrimitiveMember)o;
         result.noInRow = 1;
         Row r = result.row;
         int shift = (((Symbol)r.elements.elementAt(0))).width();
          L9:
          for(
          i = 1; i < r.elements.size(); i++
          )
           {
             {
             if(
             ((r.x + shift) > p.x)
             ){
             break L9;
             }
             }
           result.noInRow++;
           r.getElement(i);
             {
             if(
             (r.sy != null)
             ){
             shift += r.sy.width();
             continue L9;
             }
             }
           ;
           }
         return;
         }
         }
       System.out.println("ViewSketchy: punkt pole mitteskeemis");
       result = null;
       }
       {
       if(
       (getLineArea(s).contains(p))
       ){
       result = new Cursor(s);
       return;
       }
       }
     result = new Cursor(s);
       {
       if(
       (pointLocation(p, s.comment))
       ){
       result.primitive = null;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0))).width();
        L10:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L10;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L10;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     result = new Cursor(s);
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead h = (PrimitiveHead)(e.nextElement());
       if(
       (pointLocation(p, h.text))
       ){
       result.primitive = h;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0))).width();
        L11:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L11;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L11;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     }
    void adjustComment(AmCanvas c,int oldW, int oldH, int caretShift)
     {
     c.frame.contents.affected = sk;
      L12:
       {
         {
         if(
         (sk instanceof Sketch)
         ){
         sk.invalidate(x + oldW);
         c.X = sk.comment.x + c.start.x;
         c.Y = y - sk.comment.height/2 + c.start.y;
         c.W = oldW  + 2;
         c.H = height + sk.comment.height;
         break L12;
         }
         }
       c.X = sk.comment.x + caretShift;
       c.W = oldW - caretShift + 2;
         {
         if(
         (sk.comment.elements.size() == 1)
         ){
         c.X = sk.comment.x;
         c.W = oldW + 2;
         }
         }
       c.X = c.X + c.start.x;
       c.Y = sk.comment.y + c.start.y;
       c.H = oldH;
       }
     }
    void adjustTextComment(AmCanvas c, Row comm, int oldW, int oldH, int caretShift)
     {
     c.frame.contents.affected = sk;
     c.X = comm.x + caretShift;
     c.W = oldW - caretShift + 2;
       {
       if(
       (comm.elements.size() == 1)
       ){
       c.X = comm.x;
       c.W = oldW + 2;
       }
       }
     c.X = c.X + c.start.x;
     c.Y = comm.y + c.start.y - 2;
     c.H = oldH + 4;
     }
    void adjustText(AmCanvas c, Text t, Row r, int oldW, int oldH, int caretShift)
     {
     c.frame.contents.affected = sk;
     int wadd = 0;
       {
       if(
       (t.rows.indexOf(r) == t.rows.size()-1)
       ){
       wadd = t.comment.width;
       }
       }
     c.X = r.x + caretShift;
     c.W = oldW - caretShift + wadd + 2;
       {
       if(
       (r.elements.size() == 1)
       ){
       c.X = r.x;
       c.W = oldW + wadd + 2;
       }
       }
     c.X += c.start.x;
     c.Y = r.y + c.start.y;
     c.H = oldH;
     }
    void adjustText(AmCanvas c, Text t, Row r)
     {
     r.invalidate();
     c.prepare(r.y);
     }
    void adjustText(AmCanvas c, Text t, Row r1, Row r2, int oldW, int oldH)
     {
     c.X = r1.x + c.start.x;
     c.Y = r1.y + c.start.y - 2;
     int i = t.rows.indexOf(r1);
     int j = t.rows.indexOf(r2);
     c.W = t.width(i,j);
     int cw = t.comment.width;
       {
       if(
       ((j == t.rows.size()-1)
       && ((r2.width + cw) > c.W))
       ){
       c.W = r2.width + cw;
       }
       }
     c.W = Math.max(c.W, oldW);
     c.H = r2.y - r1.y + 1 + r2.height;
     c.H = Math.max(c.H, oldH);
      for(
      int k = i; k < j; k++
      )
       {
       (t.row(k)).invalidate();
       }
     }
    void adjustIcon(AmCanvas c)
     {
      switch(
      c.selection.kind()
      )
      {
       case
        Selection.PRIMITIVE2PRIMITIVE:
       c.prepare(c.selection.start.primitive.text.y - 4);
       break;
       case
        Selection.SCHEME2PRIMITIVE:
       c.prepare(c.selection.start.scheme.view.y - 4);
       break;
       case
        Selection.PRIMITIVE2SCHEME:
       c.prepare(c.selection.start.primitive.text.y - 4);
       break;
       case
        Selection.SCHEME2SCHEME:
       c.prepare(c.selection.start.scheme.view.y - 4);
       break;
       default
       :
       {
       return;
       }
      }
     }
    void adjust(AmCanvas c, Primitive p, boolean cut)
     {
     c.prepare(p.text.y - 2);
     }
    void adjust(AmCanvas c, Scheme s, boolean cut)
     {
     c.prepare(s.view.y - 2);
     }
    void adjust(AmCanvas c, Primitive p, Scheme affected)
     {
     Rectangle rec = affected.view.getLineArea(affected);
     c.X = rec.x;
     c.Y = p.text.y;
     c.W = p.text.x + p.text.width - rec.x;
     c.H = p.text.height;
     p.text.invalidate();
     c.frame.contents.affected = affected;
     c.X += c.start.x; c.Y += c.start.y;
     }
    void adjustArrowMap(AmCanvas c, Arrow ar, boolean prolonged)
     {
      L13:
       {
         {
         if(
         (prolonged)
         ){
         int len = sk.level() - ar.level;
         Scheme x = sk;
          for(
          int i = 0; i < len; i++
          )
           {
           x = x.parent;
           }
           {
           if(
           (x instanceof Branch)
           ){
           x = x.parent;
           }
           }
         c.frame.contents.affected = x;
         c.X = x.view.x + c.start.x;
         c.Y = ar.text.y + c.start.y;
         c.W = ar.text.x - x.view.x;
         c.H = ar.text.height + 2;
         break L13;
         }
         }
       int len = sk.level() - ar.level + 1;
       Scheme x = sk;
        for(
        int i = 0; i < len; i++
        )
         {
         x = x.parent;
         }
         {
         if(
         (x instanceof Branch)
         ){
         x = x.parent;
         }
         }
       c.frame.contents.affected = x;
       c.X = x.view.x + c.start.x;
       c.Y = ar.text.y + c.start.y;
       c.W = ar.text.x - x.view.x;
       c.H = ar.text.height + 2;
       }
     }
    public void adjustSchemeMap(AmCanvas c, Scheme s)
     {
       {
       if(
       (s instanceof Branch)
       ){
       s = s.parent;
       }
       }
     Rectangle rec = getLineArea(s);
     c.X = rec.x + c.start.x;
     c.Y = rec.y + c.start.y;
     c.W = rec.width;
     c.H = rec.height+2;
     c.frame.contents.affected = s;
     }
    void adjustSelection(AmCanvas c, Selection sel)
     {
     c.frame.contents.affected = sel.start.scheme;
      switch(
      sel.kind()
      )
      {
       case
        Selection.PRIMITIVETEXT:
       sel.start.primitive.text.invalidate();
       break;
       case
        Selection.PRIMITIVECOMMENT:
       sel.start.primitive.text.comment.invalidate();
       break;
       case
        Selection.SCHEMECOMMENT2SCHEMECOMMENT:
       Scheme s = sel.start.scheme;
       s.invalidateRest(s.view.y - 4);
       Rectangle rec = sel.area();
       c.X = rec.x + c.start.x;
       c.W = rec.width;
       Selection sx = new Selection(
       new Cursor(s), new Cursor(s));
       rec = sx.area();
       c.Y = rec.y + c.start.y;
       c.H = rec.height;
       return;
       case
        Selection.PRIMITIVE2PRIMITIVE:
       break;
       case
        Selection.SCHEME2PRIMITIVE:
       break;
       case
        Selection.PRIMITIVE2SCHEME:
       break;
       case
        Selection.SCHEME2SCHEME:
       break;
      }
     Rectangle rec = sel.area();
     c.X = rec.x + c.start.x;
     c.Y = rec.y + c.start.y;
     c.W = rec.width;
     c.H = rec.height;
     }
   }
