 import java.util.*;
 import java.awt.*;
  class ViewSketchyPlus extends View
   {
   boolean isOneline;
   boolean wasOneline;
   static final int hd = 15;
   static final int vd = 5;
   static final int MAX_ONELINE = 60;
   static Color color = Default.sketchLineColor;
   static Color colorBr = Default.branchHeadColor;
   static int iconw;
   static int iconh;
   static int laius;
    ViewSketchyPlus(Scheme s)
     {
     super(s);
     type = View.SKETCHY_PLUS;
     isOneline = oneline_able(s);
     }
    public Rectangle getLineArea(Scheme s)
     {
     return(
     new Rectangle(s.view.x, s.view.y, hd, s.view.height)
     );
     }
    private void drawSkLine(Graphics g, Scheme s)
     {
     Rectangle rk = getLineArea(s);
     int xx= rk.x, yy=rk.y,  korgus=rk.height;
     laius=rk.width;
     int xja = xx + 1;
     int xjl = xja;
     int dd = (s.comment.width == 0)? 0 : vd;
     int yja = yy + (s.comment.height - dd) / 2;
     int yjl = yy + korgus - 3;
     g.setColor(color);
      L0:
       {
         {
         if(
         (s instanceof Branch)
         ){
         int vahe1 = laius/4;
           {
           if(
           (vahe1 < 1)
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           (s.parent.type == Scheme.MODULE)
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           (s.parent.type == Scheme.SIMPLE)
           ){
           vahe1 = 0;
           }
           }
         int xsa = xja + vahe1;
           {
           if(
           ((!(((Sketch)(s.parent)).isMono())) ||
           (((Sketch)(s.parent)).head.size() > 0) ||
           (s.type != Scheme.SIMPLE))
           ){
            switch(
            s.type
            )
            {
             case
              Scheme.LOOP:
             case
              Scheme.MODULE:
             int vahe = laius/4;
               {
               if(
               (vahe < 1)
               ){
               vahe = 1;
               }
               }
               {
               if(
               (s.type == Scheme.MODULE)
               ){
               vahe = 1;
               }
               }
             int xva, yva;
             int ysa;
             xva = xja; yva = yja-vahe;
             ysa = yva + vahe;
             g.drawLine(xsa, yva, xva + laius - 2, yva);
             g.drawLine(xsa, ysa, xva + laius - 2, ysa);
             break;
             default
             :
             {
             g.drawLine(xsa, yja, xja + laius - 2 - 1, yja);
             break;
             }
            }
           }
           }
         break L0;
         }
         }
        switch(
        s.type
        )
        {
         case
          Scheme.LOOP:
         case
          Scheme.MODULE:
         int vahe = laius/4;
           {
           if(
           (vahe < 1)
           ){
           vahe = 1;
           }
           }
           {
           if(
           (s.type == Scheme.MODULE)
           ){
           vahe = 1;
           }
           }
         int xva, yva, xvl, yvl;
         int xsa, ysa, xsl, ysl;
         xva = xja; yva = yja-vahe; xvl = xjl; yvl =yjl+vahe;
         xsa = xva + vahe; ysa = yva + vahe; xsl = xsa; ysl = yvl - vahe;
         g.drawLine(xva, yva, xvl, yvl);
         g.drawLine(xva+1, yva, xva + laius - 2, yva);
         g.drawLine(xvl+1, yvl, xvl + laius - 2, yvl);
         g.drawLine(xsa, ysa, xsl, ysl);
         g.drawLine(xsa+1, ysa, xva + laius - 2, ysa);
         g.drawLine(xsl+1, ysl, xvl + laius - 2, ysl);
         break;
         default
         :
         {
         g.drawLine(xja, yja, xjl, yjl);
         g.drawLine(xja+1, yja, xja + laius - 2, yja);
         g.drawLine(xjl+1, yjl, xjl + laius - 2, yjl);
         break;
         }
        }
       }
     }
    public void  plan(int x0, int y0)
     {
     PrimitiveHead h;
     PrimitiveMember nsk;
     Arrow ar;
       {
       if(
        (sk.icon)
       ){
       x = x0; y = y0;
       iconw = sk.comment.height;
       iconh = iconw;
       width = iconw + 8;
       height = iconh + 4;
       return;
       }
       }
       {
       if(
       (oneline(sk, x0, y0))
       ){
       return;
       }
       }
     int yy= y0+vd;
     int ww = 0;
     sk.comment.plan(sk.comment.x, sk.comment.y);
     sk.comment.y = yy - sk.comment.height/2;
     yy += sk.comment.height/2 + vd;
       {
       if(
       (sk.comment.width > ww)
       ){
       ww = sk.comment.width;
       }
       }
       {
       if(
       (sk.head.size() != 0)
       ){
       yy += vd;
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
         he.text.plan(x0+hd, yy-vd);
         yy += he.text.height + vd;
         if(
         (he.text.width > ww)
         ){
         ww = he.text.width;
         }
         }
       yy -= vd;
       }
       }
      L2:
      for(
      int i = 0; i < sk.body.size(); i++
      )
       {
       Object o = sk.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme ss = (Scheme)o;
          L1:
           {
             {
             if(
             (ss instanceof Sketch)
             ){
             ss.view.plan(x0+hd, yy);
               {
               if(
               (ss.view.width > ww)
               ){
               ww = ss.view.width;
               }
               }
             break L1;
             }
             }
           ss.view.plan(x0+1, yy);
           if(
           (ss.view.width-hd > ww)
           ){
           ww = ss.view.width-hd;
           }
           }
         yy += ss.view.height + vd;
           {
           if(
           (ss.type != Scheme.SIMPLE)
           ){
           yy += vd;
           }
           }
         continue L2;
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
       ns.text.plan(x0+hd, yy);
       yy += ns.text.height + vd;
       if(
       (ns.text.width > ww)
       ){
       ww = ns.text.width;
       }
       }
     x = x0; y = y0;
     width = ww+hd+1;
     height = yy-y0+vd+1;
      L3:
       {
         {
         if(
         (sk instanceof Branch)
         ){
         height -= 2*vd;
         break L3;
         }
         }
       }
     sk.comment.x = sk.view.x + hd;
     }
    private boolean oneline_able(Scheme sk)
     {
       {
       if(
       (sk instanceof Sketch)
       ){
         {
         if(
         (sk.parent == null)
         ){
         return(
         false
         );
         }
         }
         {
         if(
         (sk.body.size() > 1)
         ){
         return(
         false
         );
         }
         }
       Branch br = ((Sketch)sk).branch(0);
         {
         if(
         (br.head.size() > 0)
         ){
         return(
         false
         );
         }
         }
       int len = sk.comment.elements.size() + br.comment.elements.size();
         {
         if(
         (len > MAX_ONELINE)
         ){
         return(
         false
         );
         }
         }
        for(
        int i = 0; i < sk.head.size(); i++
        )
         {
         PrimitiveHead p = sk.primitiveHead(i);
           {
           if(
           (p.text.rows.size() > 1)
           ){
           return(
           false
           );
           }
           }
         len += (p.text.toString().length()) +
         (p.text.comment.toString().length()) + 2;
         if(
         (len > MAX_ONELINE)
         ){
         return(
         false
         );
         }
         }
       int n = br.body.size();
        for(
        int i=0; i < n; i++
        )
         {
         Object o = br.member(i);
           {
           if(
           (o instanceof Scheme)
           ){
           return(
           false
           );
           }
           }
         Primitive p = (Primitive)o;
           {
           if(
           (p.text.rows.size() > 1)
           ){
           return(
           false
           );
           }
           }
         len += (p.text.toString().length()) +
         (p.text.comment.toString().length()) + 2;
         if(
         (len > MAX_ONELINE)
         ){
         return(
         false
         );
         }
         }
       return(
       true
       );
       }
       }
     int n = sk.body.size();
     int len = sk.comment.elements.size();
      for(
      int i = 0; i < sk.head.size(); i++
      )
       {
       PrimitiveHead p = sk.primitiveHead(i);
         {
         if(
         (p.text.rows.size() > 1)
         ){
         return(
         false
         );
         }
         }
       len += (p.text.toString().length()) +
       (p.text.comment.toString().length()) + 2;
       if(
       (len > MAX_ONELINE)
       ){
       return(
       false
       );
       }
       }
      for(
      int i=0; i < n; i++
      )
       {
       Object o = sk.member(i);
         {
         if(
         (o instanceof Scheme)
         ){
         return(
         false
         );
         }
         }
       Primitive p = (Primitive)o;
         {
         if(
         (p.text.rows.size() > 1)
         ){
         return(
         false
         );
         }
         }
       len += (p.text.toString().length()) +
       (p.text.comment.toString().length()) + 2;
       if(
       (len > MAX_ONELINE)
       ){
       return(
       false
       );
       }
       }
     return(
     true
     );
     }
    private boolean oneline(Scheme sk, int x0, int y0)
     {
     wasOneline = isOneline;
     isOneline = oneline_able(sk);
       {
       if(
       (!isOneline)
       ){
       return(
       false
       );
       }
       }
     int yy= y0;
     int xx = x0+hd;
     int hh = 0;
     sk.comment.plan(sk.comment.x, sk.comment.y);
     sk.comment.y = yy;
     sk.comment.y -= vd/2;
     yy += vd;
     xx += sk.comment.width;
     hh = sk.comment.height
     + sk.comment.height/2;
       {
       if(
       (sk.head.size() != 0)
       ){
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
          L4:
           {
             {
             if(
             (he.type != PrimitiveHead.SIMPLE)
             ){
             he.text.plan(xx+hd, yy);
             xx += he.text.width + hd;
             break L4;
             }
             }
           he.text.plan(xx, yy);
           xx += he.text.width;
           }
         if(
         (he.text.height > hh)
         ){
         hh = he.text.height;
         }
         }
       }
       }
      L6:
       {
         {
         if(
         (sk instanceof Sketch)
         ){
         Branch br = ((Sketch)sk).branch(0);
         br.comment.plan(xx+hd, yy);
         xx += br.comment.width + hd;
           {
           if(
           (br.comment.height > hh)
           ){
           hh = br.comment.height;
           }
           }
          for(
          int i = 0; i < br.body.size(); i++
          )
           {
           Object o = br.member(i);
           PrimitiveMember ns = (PrimitiveMember)o;
            L5:
             {
               {
               if(
               (ns.type != Primitive.SIMPLE)
               ){
               ns.text.plan(xx+hd, yy);
               xx += ns.text.width + hd;
               break L5;
               }
               }
             ns.text.plan(xx, yy);
             xx += ns.text.width;
             }
           if(
           (ns.text.height > hh)
           ){
           hh = ns.text.height;
           }
           }
         br.view.x = br.comment.x - hd;
         br.view.y = br.comment.y;
         br.view.width = xx - br.comment.x + hd;
         br.view.height = hh - hd/2;
         break L6;
         }
         }
        for(
        int i = 0; i < sk.body.size(); i++
        )
         {
         Object o = sk.member(i);
         PrimitiveMember ns = (PrimitiveMember)o;
          L7:
           {
             {
             if(
             (ns.type != Primitive.SIMPLE)
             ){
             ns.text.plan(xx+hd, yy);
             xx += ns.text.width + hd;
             break L7;
             }
             }
           ns.text.plan(xx, yy);
           xx += ns.text.width;
           }
         if(
         (ns.text.height > hh)
         ){
         hh = ns.text.height;
         }
         }
       }
     x = x0; y = y0;
     height = hh+1;
     width = xx-x0+1;
     sk.comment.x = sk.view.x + hd;
     return(
     true
     );
     }
    public void  draw(Graphics g)
     {
     Scheme s = super.sk;
       {
       if(
       (s.icon)
       ){
        L8:
         {
           {
           if(
           (s instanceof Sketch)
           ){
           g.setColor(color);
           break L8;
           }
           }
         g.setColor(colorBr);
         }
       int luX = x + 6;
       int luY = y + 2;
       g.drawRect(luX, luY, iconw, iconh);
       g.drawLine(luX, luY,
       luX + iconw - 1, luY + iconh - 1);
        L9:
         {
           {
           if(
           (!s.comment.isTrivial())
           ){
           g.setColor(Default.commentColor);
           g.drawString(s.comment.toString(),
           x + width + 2, y + iconh);
           break L9;
           }
           }
         if(
         (s.head.size() != 0)
         ){
          L10:
           {
             {
             if(
             (s instanceof Sketch)
             ){
             g.setColor(color);
             break L10;
             }
             }
           g.setColor(colorBr);
           }
         g.drawString(s.primitiveHead(0).text.row(0).toString(),
         x + width + 2, y + iconh);
         }
         }
       return;
       }
       }
       {
       drawSkLine(g,s);
       s.comment.draw(g);
       if(
       ((s instanceof Sketch)&&
       (s.comment.elements.size()>1)&&
       !isOneline)
       ){
       Row endc = new Row(Default.commentColor);
       endc.elements = s.comment.elements;
       endc.x = s.comment.x;
       endc.y = s.comment.y + s.view.height- s.comment.height/2;
       endc.width = s.comment.width;
       endc.height = s.comment.height;
       endc.draw(g);
       }
       }
     int yy = s.comment.height + vd;
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead he = (PrimitiveHead)(e.nextElement());
       he.text.draw(g);
       int x1 = he.text.x-hd+2;
       int y1 = he.text.y + he.text.height*3/4;
       g.setColor(color);
        switch(
         he.type
        )
        {
         case
          PrimitiveHead.LOOP:
         g.setFont(Default.font);
         g.drawString("*", x1, y1);
         break;
         case
          PrimitiveHead.SWITCH:
         g.setFont(Default.font);
         g.drawString("??", x1, y1);
         break;
         case
          PrimitiveHead.CASE:
         case
          PrimitiveHead.DEFAULT:
         g.setFont(Default.font);
         g.drawString("?", x1, y1);
         break;
         case
          PrimitiveHead.TRY:
         g.setFont(Default.font);
         g.drawString("!!", x1, y1);
         break;
         case
          PrimitiveHead.CATCH:
         case
          PrimitiveHead.FINALLY:
         g.setFont(Default.font);
         g.drawString("!", x1, y1);
         break;
        }
       yy += he.text.height;
       }
      L11:
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Object o = e.nextElement();
         {
         if(
         (o instanceof Scheme)
         ){
         ((Scheme)o).view.draw(g);
         continue L11;
         }
         }
         {
         if(
          (o instanceof Arrow)
         ){
         Arrow ar = (Arrow)o;
         ar.text.draw(g);
         g.setColor(Default.arrowColor);
         int length = s.level() - ar.level + 1;
          L12:
           {
             {
             if(
             (isOneline)
             ){
             int arx = ar.text.x-hd/2-1;
             int ary = ar.text.y + ar.text.height*3/4;
             String arlen = String.valueOf((char)('0' + length - 1));
               {
               if(
               ((length - 1) == 1)
               ){
               arlen = " ";
               }
               }
             g.setFont(Default.font);
             g.drawString("^", arx - hd/2, ary);
             g.drawString(arlen, arx, ary);
             break L12;
             }
             }
             {
             if(
             (ar.type == Arrow.WEAK)
             ){
             length += 1;
             }
             }
           int endx = ar.text.x - length*laius/2;
           int yy0 = ar.text.y +
           ((Row)(ar.text.rows.elementAt(0))).height/2;
            L13:
             {
               {
               if(
               (ar.type == Arrow.WEAK)
               ){
               endx += laius/2;
                for(
                int i = endx; i < ar.text.x; i += laius*2/3
                )
                 {
                 g.drawLine(i, yy0, i + laius/3, yy0);
                 }
               break L13;
               }
               }
             g.drawLine(ar.text.x, yy0,
             endx, yy0);
             }
           g.drawLine(endx, yy0, endx + 4, yy0 - 2);
           g.drawLine(endx, yy0, endx + 4, yy0 + 2);
           }
         continue L11;
         }
         }
       if(
       (o instanceof PrimitiveMember)
       ){
       PrimitiveMember ns = (PrimitiveMember)o;
        switch(
         ns.type
        )
        {
         case
          Primitive.CONDITION:
         g.setFont(Default.font);
         g.setColor(Default.conditionColor);
         g.drawString("?", ns.text.x-hd/2-1, ns.text.y + ns.text.height*3/4);
         break;
        }
       ns.text.draw(g);
       }
       }
     }
    public void pointLocation(Point p, Scheme s)
     {
       {
       if(
       (result != null)
       ){
       return;
       }
       }
       {
       if(
       (!s.view.contains(p))
       ){
       return;
       }
       }
       {
       if(
       (s.icon)
       ){
       result = new Cursor(s);
       return;
       }
       }
      L14:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme sk = (Scheme)o;
         pointLocation(p, sk);
           {
           if(
           (result != null)
           ){
           return;
           }
           }
         continue L14;
         }
         }
       result = new Cursor(s);
       System.out.println("ViewSketchy: on mitteskeem");
         {
         if(
         (pointLocation(p, ((PrimitiveMember)o).text))
         ){
         System.out.println("ViewSketchy: punkt on mitteskeemis");
         result.primitive = (PrimitiveMember)o;
         result.noInRow = 1;
         Row r = result.row;
         int shift = (((Symbol)r.elements.elementAt(0)))
         .width();
          L15:
          for(
          i = 1; i < r.elements.size(); i++
          )
           {
             {
             if(
             ((r.x + shift) > p.x)
             ){
             break L15;
             }
             }
           result.noInRow++;
           r.getElement(i);
             {
             if(
             (r.sy != null)
             ){
             shift += r.sy.width();
             continue L15;
             }
             }
           ;
           }
         return;
         }
         }
       System.out.println("ViewSketchy: punkt pole mitteskeemis");
       result = null;
       }
       {
       if(
       (getLineArea(s).contains(p))
       ){
       result = new Cursor(s);
       return;
       }
       }
     result = new Cursor(s);
       {
       if(
       (pointLocation(p, s.comment))
       ){
       result.primitive = null;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0))).width();
        L16:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L16;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L16;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     result = new Cursor(s);
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead h = (PrimitiveHead)(e.nextElement());
       if(
       (pointLocation(p, h.text))
       ){
       result.primitive = h;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0))).width();
        L17:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L17;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L17;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     }
    void adjustComment(AmCanvas c, int oldW, int oldH, int caretShift)
     {
     ViewSketchyPlus v = (ViewSketchyPlus)(sk.view);
       {
       if(
       (oneliningChanged(c))
       ){
       return;
       }
       }
     c.frame.contents.affected = sk;
       {
       if(
       (v.isOneline)
       ){
       c.X = sk.comment.x + caretShift;
         {
         if(
         (sk.comment.elements.size() == 1)
         ){
         c.X = sk.comment.x;
         }
         }
       c.W = sk.view.width - (c.X - sk.comment.x);
       c.X = c.X + c.start.x;
       c.Y = sk.comment.y + c.start.y;
       c.H =  sk.view.height;
       return;
       }
       }
      L18:
       {
         {
         if(
         (sk instanceof Sketch)
         ){
         sk.invalidate(x + oldW);
         c.X = sk.comment.x + c.start.x;
         c.Y = y - sk.comment.height/2 + c.start.y;
         c.W = oldW  + 2;
         c.H = height + sk.comment.height;
         break L18;
         }
         }
       c.X = sk.comment.x + caretShift;
       c.W = oldW - caretShift + 2;
         {
         if(
         (sk.comment.elements.size() == 1)
         ){
         c.X = sk.comment.x;
         c.W = oldW + 2;
         }
         }
       c.X = c.X + c.start.x;
       c.Y = sk.comment.y + c.start.y;
       c.H = oldH;
       }
     }
    private boolean oneliningChanged(AmCanvas c)
     {
       {
       if(
       (sk instanceof Sketch)
       ){
       ViewSketchyPlus v = (ViewSketchyPlus)(sk.view);
         {
         if(
         (v.isOneline != v.wasOneline)
         ){
         c.frame.contents.affected = c.frame.contents.main;
         c.prepare(v.y - 2);
         return(
         true
         );
         }
         }
       return(
       false
       );
       }
       }
       {
       if(
       (sk.parent.view instanceof ViewSketchyPlus)
       ){
       ViewSketchyPlus vParent =
       (ViewSketchyPlus)(sk.parent.view);
         {
         if(
         (vParent.isOneline != vParent.wasOneline)
         ){
         c.frame.contents.affected = c.frame.contents.main;
         c.prepare(vParent.y - 2);
         return(
         true
         );
         }
         }
       if(
       (vParent.isOneline)
       ){
       return(
       false
       );
       }
       }
       }
     ViewSketchyPlus v =
     (ViewSketchyPlus)(sk.view);
       {
       if(
       (v.isOneline != v.wasOneline)
       ){
       c.frame.contents.affected = c.frame.contents.main;
       c.prepare(sk.view.y - 2);
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
   }
