 import java.util.*;
 import java.awt.*;
  class ViewTable extends View
   {
   static final int hd = 10;
   static final int vd = 10;
   static Color color = Color.blue;
   static Color colorBr = Default.branchHeadColor;
   static final Color selectionColor = Color.gray;
   static  int iconw = hd;
   static  int iconh = vd;
    ViewTable(Scheme s)
     {
     super(s);
     type = View.TABLE;
     }
    public void plan(int x0, int y0)
     {
       {
       if(
       sk instanceof Branch
       ){
       planBranch(x0, y0);
       return;
       }
       }
       {
       if(
        sk.icon
       ){
       x = x0; y = y0;
       iconw = sk.comment.height;
       iconh = iconw;
       width = iconw + 4;
       height = iconh + 4;
       return;
       }
       }
     int yy = y0 + vd;
       {
       if(
       !sk.comment.isTrivial()
       ){
       yy += sk.comment.height;
       }
       }
     int xx = x0;
     int headW = 0;
       {
       if(
       sk.head.size() != 0
       ){
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
         he.text.plan(x0+hd, yy-vd);
         yy += he.text.height;
         if(
         he.text.width > headW
         ){
         headW = he.text.width;
         }
         }
       yy += vd;
       }
       }
     xx += hd;
     int headH = yy -y0;
     int maxBodyH = 0;
      for(
      int i = 0; i < sk.body.size(); i++ 
      )
       {
       Branch br = (Branch)sk.member(i);
       br.view.plan(xx, yy + vd);
       xx += br.view.width+1;
         {
         if(
         br.view.height > maxBodyH
         ){
         maxBodyH = br.view.height;
         }
         }
       }
     x = x0; y = y0;
     width = xx -x0;
     width = Math.max(width, headW);
     width += hd;
     sk.comment.x = sk.view.x + sk.view.width - sk.comment.width - 2;
     sk.comment.y = y0 + vd;
     maxBodyH = alignBranchMembers(maxBodyH);
     height = headH + maxBodyH + 2*vd;
     }
    private int alignBranchMembers(int maxBodyH)
     {
     Vector v = new Vector();
     int i = 0;
      L2:
      for(;;)
       {
       int h = -1;
        L0:
        for(
        int j = 0; j < sk.body.size(); j++ 
        )
         {
         Branch br = (Branch)sk.member(j);
         int hi = -1;
           {
           if(
           i > (br.body.size()-1)
           ){
           continue L0;
           }
           }
           {
           Object o = br.member(i);
            L1:
             {
               {
               if(
               o instanceof Sketch
               ){
               hi = ((Sketch)o).view.height;
               break L1;
               }
               }
             hi = ((PrimitiveMember)o).text.height;
             }
             {
             if(
             hi > h
             ){
             h = hi;
             }
             }
           }
         }
         {
           {
           if(
           h == -1
           ){
           break L2;
           }
           }
         v.addElement(new Integer(h));
         i++;
         }
       }
      for(
      i = 1; i < v.size(); i++
      )
       {
       int x = ((Integer)v.elementAt(i-1)).intValue();
       int y = ((Integer)v.elementAt(i)).intValue();
       v.setElementAt(new Integer(x+y+vd), i);
       }
     int headY = 0;
      for(
      i = 0; i < sk.body.size(); i++ 
      )
       {
       Branch br = (Branch)sk.member(i);
       int yy = 0; 
       Object o = br.member(0);
        L3:
         {
           {
           if(
           o instanceof Sketch
           ){
           yy = ((Sketch)o).view.y;
           break L3;
           }
           }
         yy = ((Primitive)o).text.y;
         }
         {
         if(
         yy > headY
         ){
         headY = yy;
         }
         }
       }
      for(
      i = 0; i < sk.body.size(); i++ 
      )
       {
       Branch br = (Branch)sk.member(i);
       int baasY = headY;
       int brY = -1;
        for(
        int j = 0; j < br.body.size(); j++ 
        )
         {
         Object o = br.member(j);
         int suhtY = -vd; 
           {
           if(
           j != 0
           ){
           suhtY = ((Integer)v.elementAt(j-1)).intValue();
           }
           }
         int vanaAbsY = 0;
          L4:
           {
             {
             if(
             o instanceof Sketch
             ){
             Sketch ss = (Sketch)o;
             vanaAbsY = ss.view.y;
             ss.view.translate(ss, 0, baasY + suhtY -vanaAbsY + vd);
             brY = ss.view.y + ss.view.height;
             break L4;
             }
             }
           Primitive pp = (Primitive)o;
           vanaAbsY =pp.text.y;
           translate(pp, 0, baasY + suhtY -vanaAbsY + vd);
           brY = pp.text.y + pp.text.height;
           }
         }
         {
         if(
         brY != -1
         ){
         br.view.height = brY - br.view.y +vd;
           {
           if(
           br.view.height > maxBodyH
           ){
           maxBodyH = br.view.height;
           }
           }
         }
         }
       }
     return(
     maxBodyH
     );
     }
    private void planBranch(int x0, int y0)
     {
       {
       if(
        sk.icon
       ){
       x = x0; y = y0;
       iconw = sk.comment.height;
       iconh = iconw;
       width = iconw + 8;
       height = iconh + 4;
       return;
       }
       }
     int yy= y0+vd;
     int ww = 0;
     sk.comment.y = yy;
     yy += sk.comment.height+vd;
       {
       if(
       sk.comment.width > ww
       ){
       ww = sk.comment.width;
       }
       }
       {
       if(
       sk.head.size() != 0
       ){
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
         he.text.plan(x0+hd, yy-vd);
         yy += he.text.height;
         if(
         he.text.width > ww
         ){
         ww = he.text.width;
         }
         }
       yy += 2*vd;
       }
       }
      L5:
      for(
      int i = 0; i < sk.body.size(); i++
      )
       {
       Object o = sk.member(i);
         {
         if(
          o instanceof Sketch
         ){
         Scheme ss = (Scheme)o;
         ss.view.plan(x0+hd, yy);
         yy += ss.view.height + vd;
           {
           if(
           ss.type != Scheme.SIMPLE
           ){
           yy += 3;
           }
           }
           {
           if(
           ss.view.width > ww
           ){
           ww = ss.view.width;
           }
           }
         continue L5;
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
       ns.text.plan(x0+hd, yy);
       yy += ns.text.height + vd;
       if(
       ns.text.width > ww
       ){
       ww = ns.text.width;
       }
       }
     x = x0; y = y0;
     width = ww+2*hd;
     height = yy-y0+vd+1;
     sk.comment.x = sk.view.x + sk.view.width - sk.comment.width - 2;
     }
    public void draw(Graphics g)
     {
     Scheme s = super.sk;
       {
       if(
       s.icon
       ){
        L6:
         {
           {
           if(
           s instanceof Sketch
           ){
           g.setColor(color);
           break L6;
           }
           }
         g.setColor(colorBr);
         }
       int luX = x + 6;
       int luY = y + 2;
       g.drawRect(luX, luY, iconw, iconh);
       g.drawLine(luX, luY,
       luX + iconw - 1, luY + iconh - 1);
        L7:
         {
           {
           if(
           !s.comment.isTrivial()
           ){
           g.setColor(Default.commentColor);
           g.drawString(s.comment.toString(),
           x + width + 2, y + iconh);
           break L7;
           }
           }
         if(
         s.head.size() != 0
         ){
          L8:
           {
             {
             if(
             s instanceof Sketch
             ){
             g.setColor(color);
             break L8;
             }
             }
           g.setColor(colorBr);
           }
         g.drawString(s.primitiveHead(0).text.row(0).toString(),
         x + width + 2, y + iconh);
         }
         }
       return;
       }
       }
     int yy = 0;
     sk.comment.draw(g);
     yy += sk.comment.height;
     int w = 0;
      for(
      Enumeration e = sk.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead he = (PrimitiveHead)(e.nextElement());
       g.setColor(color);
       he.text.draw(g);
         {
         if(
         he.text.width > w
         ){
         w = he.text.width;
         }
         }
       g.setColor(color);
        switch(
         he.type
        )
        {
         case
          PrimitiveHead.LOOP:
         g.setFont(Default.font);
         g.drawString("*", x+1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.SWITCH:
         g.setFont(Default.font);
         g.drawString("??", x+1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CASE:
         case
          PrimitiveHead.DEFAULT:
         g.setFont(Default.font);
         g.drawString("?", x+1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.TRY:
         g.setFont(Default.font);
         g.drawString("!!", x+1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CATCH:
         case
          PrimitiveHead.FINALLY:
         g.setFont(Default.font);
         g.drawString("!", x+1, y+yy + he.text.height*3/4);
         break;
        }
       yy += he.text.height;
       }
      L9:
       {
         {
         if(
         sk instanceof Branch
         ){
         g.setColor(Color.magenta);
         break L9;
         }
         }
       g.setColor(color);
       }
     g.drawRect(x, y, width, height);
      switch(
      sk.type
      )
      {
       case
        Scheme.LOOP:
       g.drawRect(x-2, y-2, width+4, height+4);
       break;
       case
        Scheme.MODULE:
       g.drawRect(x-1, y-1, width+2, height+2);
       break;
      }
      L10:
      for(
      Enumeration e = sk.body.elements(); e.hasMoreElements();
      )
       {
       Object o = e.nextElement();
         {
         if(
          o instanceof Scheme
         ){
         Scheme ss = (Scheme)o;
         ss.view.draw(g);
         yy += ss.view.height;
         continue L10;
         }
         }
         {
         if(
         o instanceof Arrow
         ){
         Arrow ns = (Arrow)o;
          switch(
           ns.type
          )
          {
           case
            Arrow.STRONG:
           case
            Arrow.WEAK:
           g.setFont(Default.font);
           g.setColor(Default.conditionColor);
           int leftX;
            L11:
             {
               {
               if(
               ns.level == Integer.MAX_VALUE
               ){
               leftX = x+hd/2;
               break L11;
               }
               }
             leftX = (ns.level - 1)*hd + 10;
             }
           int  leftY = ns.text.y + ns.text.height/2,
           rightX = x+hd,
           rightY = leftY;
           g.drawLine(leftX, leftY, rightX, rightY);
           g.drawLine(leftX, leftY, leftX+3, leftY-3);
           g.drawLine(leftX, leftY, leftX+3, leftY+3);
           break;
          }
         ns.text.draw(g);
         yy += ns.text.height;
         continue L10;
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
        switch(
         ns.type
        )
        {
         case
          Primitive.CONDITION:
         g.setFont(Default.font);
         g.setColor(Default.conditionColor);
         g.drawString("?", x+1, ns.text.y + ns.text.height*3/4);
         break;
        }
       ns.text.draw(g);
       yy += ns.text.height;
       }
     }
    public Rectangle getLineArea(Scheme s)
     {
     return(
     new Rectangle(s.view.x, s.view.y, hd, s.view.height)
     );
     }
   }
