 import java.util.*;
 import java.awt.*;
  class ViewXml extends View
   {
   static final int hd = 
   (AmFont.fm[AmFont.No(Default.font)]).charWidth('X') * 2;
   static final int hdd = 5;
   static final int vd = 5;
   static Color color = Default.sketchLineColor;
   static Color colorBr = Default.branchHeadColor;
   static int iconw;
   static int iconh;
   static int laius;
   static Row rDoctype = new Row("DOCTYPE", Default.sketchHeadColor);;
   static Row rElement = new Row("ELEMENT", Default.sketchHeadColor);;
   static Row rEntity = new Row("ENTITY", Default.sketchHeadColor);;
   static Row rAttlist = new Row("ATTLIST", Default.sketchHeadColor);;
   static Row rNotation = new Row("NOTATION", Default.sketchHeadColor);;
    ViewXml(Scheme s)
     {
     super(s);
     type = View.XML;
     }
    public Rectangle getLineArea(Scheme s)
     {
     return(
     new Rectangle(s.view.x, s.view.y, hd, s.view.height)
     );
     }
    private void drawSkLine(Graphics g, Scheme s)
     {
     Rectangle rk = getLineArea(s);
     int xx = rk.x, yy = rk.y,  korgus = rk.height;
     laius = rk.width;
     int xja = xx + 1;
     int xjl = xja;
     int yja = yy + (s.comment.height) / 2;
     int yjl = yy + korgus - 1 - (s.comment.height) / 2;
     g.setColor(color);
      L0:
       {
         {
         if(
         (s instanceof Branch)
         ){
         int vahe1 = laius/hdd;
           {
           if(
           (vahe1 < 1)
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           (s.parent.type == Scheme.MODULE)
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           (s.parent.type == Scheme.SIMPLE)
           ){
           vahe1 = 0;
           }
           }
         int xsa = xja + vahe1;
           {
           if(
           ((!(((Sketch)(s.parent)).isMono())) ||
           (((Sketch)(s.parent)).head.size() > 0) ||
           (s.type != Scheme.SIMPLE))
           ){
            switch(
            s.type
            )
            {
             case
              Scheme.LOOP:
             case
              Scheme.MODULE:
             int vahe = laius/hdd;
               {
               if(
               (vahe < 1)
               ){
               vahe = 1;
               }
               }
               {
               if(
               (s.type == Scheme.MODULE)
               ){
               vahe = 1;
               }
               }
             int xva, yva;
             int ysa;
             xva = xja; yva = yja-vahe;
             ysa = yva + vahe;
             g.drawLine(xsa, yva, xva + laius - 2, yva);
             g.drawLine(xsa, ysa, xva + laius - 2, ysa);
             break;
             default
             :
             {
             g.drawLine(xsa, yja, xja + laius - 2 - 1, yja);
             break;
             }
            }
           }
           }
         break L0;
         }
         }
        switch(
        s.type
        )
        {
         case
          Scheme.LOOP:
         case
          Scheme.MODULE:
         int vahe = laius/hdd;
           {
           if(
           (vahe < 1)
           ){
           vahe = 1;
           }
           }
           {
           if(
           (s.type == Scheme.MODULE)
           ){
           vahe = 1;
           }
           }
         int xva, yva, xvl, yvl;
         int xsa, ysa, xsl, ysl;
         xva = xja; yva = yja-vahe; xvl = xjl; yvl =yjl+vahe;
         xsa = xva + vahe; ysa = yva + vahe; xsl = xsa; ysl = yvl - vahe;
         g.drawLine(xva, yva, xvl, yvl);
         g.drawLine(xva+1, yva, xva + laius - 2, yva);
         g.drawLine(xvl+1, yvl, xvl + laius - 2, yvl);
         g.drawLine(xsa, ysa, xsl, ysl);
         g.drawLine(xsa+1, ysa, xva + laius - 2, ysa);
         g.drawLine(xsl+1, ysl, xvl + laius - 2, ysl);
         break;
         default
         :
         {
         g.drawLine(xja, yja, xjl, yjl);
         g.drawLine(xja+1, yja, xja + laius - 2, yja);
         g.drawLine(xjl+1, yjl, xjl + laius - 2, yjl);
         break;
         }
        }
       }
     }
    public void  plan(int x0, int y0)
     {
     rDoctype.planSize();
     rElement.planSize();
     rEntity.planSize();
     PrimitiveHead h;
     PrimitiveMember nsk;
     Arrow ar;
       {
       if(
        (sk.icon)
       ){
       x = x0; y = y0;
         {
         if(
         sk instanceof Branch
         ){
         x += 5; y += 5;
         }
         }
       iconw = sk.comment.height;
       iconh = iconw;
       width = iconw + 4;
       height = iconh + 4;
       return;
       }
       }
     int ll = 0; 
       {
       if(
       sk.type == Scheme.MODULE
       ){
        L1:
         {
           {
           if(
           sk instanceof Sketch
           ){
             {
             if(
             sk.head.size() > 0
             ){
             if(
             sk.primitiveHead(0).type == PrimitiveHead.TRY
             ){
             ll = rDoctype.width;
             }
             }
             }
           break L1;
           }
           }
           {
           if(
           sk.head.size() > 0
           ){
           if(
           sk.primitiveHead(0).type == PrimitiveHead.CATCH
           ){
           ll = rElement.width;
           break L1;
           }
           }
           }
           {
           if(
           sk.head.size() > 0
           ){
           if(
           sk.primitiveHead(0).type == PrimitiveHead.CASE
           ){
           ll = rEntity.width;
           break L1;
           }
           }
           }
           {
           if(
           sk.head.size() > 0
           ){
           if(
           sk.primitiveHead(0).type == PrimitiveHead.LOOP
           ){
           ll = rAttlist.width;
           break L1;
           }
           }
           }
         }
       }
       }
     int yy= y0;
     int ww = 0;
     sk.comment.y = yy;
     yy += sk.comment.height + vd;
       {
       if(
       (sk.comment.width + ll) > ww
       ){
       ww = sk.comment.width + ll;
       }
       }
       {
       if(
       (sk.head.size() != 0)
       ){
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
         he.text.plan(x0+hd, yy);
         yy += he.text.height + vd;
         if(
         (he.text.width > ww)
         ){
         ww = he.text.width;
         }
         }
       }
       }
      L3:
      for(
      int i = 0; i < sk.body.size(); i++
      )
       {
       Object o = sk.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme ss = (Scheme)o;
          L2:
           {
             {
             if(
             (ss instanceof Sketch)
             ){
             ss.view.plan(x0+hd, yy);
               {
               if(
               (ss.view.width > ww)
               ){
               ww = ss.view.width;
               }
               }
             break L2;
             }
             }
           ss.view.plan(x0+1, yy);
           if(
           (ss.view.width-hd > ww)
           ){
           ww = ss.view.width-hd;
           }
           }
         yy += ss.view.height + vd;
           {
           if(
           (ss.type != Scheme.SIMPLE)
           ){
           yy += vd;
           }
           }
         continue L3;
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
       ns.text.plan(x0+hd, yy);
       yy += ns.text.height + vd;
       if(
       (ns.text.width > ww)
       ){
       ww = ns.text.width;
       }
       }
     x = x0; y = y0;
     width = ww+hd+1;
      L4:
       {
         {
         if(
         sk instanceof Branch
         ){
         height = yy-y0-vd+1;
         break L4;
         }
         }
       height = yy-y0+vd+1 + sk.comment.height;;
       }
     sk.comment.x = sk.view.x + hd + ll;
     //sk.view.width += ll;
     }
    public void  draw(Graphics g)
     {
     Scheme s = super.sk;
       {
       if(
       (s.icon)
       ){
        L5:
         {
           {
           if(
           (s instanceof Sketch)
           ){
           g.setColor(color);
           break L5;
           }
           }
         g.setColor(colorBr);
         }
       int luX = x + 2;
       int luY = y + 2;
       g.drawRect(luX, luY, iconw, iconh);
       g.drawLine(luX, luY, luX + iconw - 1, luY + iconh - 1);
       g.drawImage(Am.pictureBoard.iconImage, luX, luY, null); 
        L6:
         {
           {
           if(
           (!s.comment.isTrivial())
           ){
           g.setColor(Default.commentColor);
           g.drawString(s.comment.toString(),
           x + width + 2, y + iconh);
           break L6;
           }
           }
         if(
         (s.head.size() != 0)
         ){
          L7:
           {
             {
             if(
             (s instanceof Sketch)
             ){
             g.setColor(color);
             break L7;
             }
             }
           g.setColor(colorBr);
           }
         g.drawString(s.primitiveHead(0).text.row(0).toString(),
         x + width + 2, y + iconh);
         }
         }
        L8:
         {
         int X = x, Y = y + height/2;
           {
           if(
           s instanceof Sketch
           ){
           drawArrowsForIcon(g, (Sketch)s, X, Y, s.level());
           break L8;
           }
           }
         int m = s.body.size();
          L9:
          for(
          int j = 0; j < m; j++
          )
           {
           Object o = ((Branch)s).member(j);
             {
             if(
             o instanceof Sketch
             ){
             drawArrowsForIcon(g, (Sketch)o, X, Y, s.level());
             continue L9;
             }
             }
           if(
           o instanceof Arrow
           ){
           drawIconArrow(g, (Branch)s, (Arrow)o, X, Y, s.level());
           }
           }
         }
       return;
       }
       }
       {
       drawSkLine(g,s);
         {
         if(
         s.type == Scheme.MODULE
         ){
          L10:
           {
             {
             if(
             s instanceof Sketch
             ){
               {
               if(
               s.head.size() > 0
               ){
               if(
               s.primitiveHead(0).type == PrimitiveHead.TRY
               ){
               rDoctype.x = s.view.x +hd;
               rDoctype.y = s.view.y;
               rDoctype.planSize();
               rDoctype.draw(g);
               }
               }
               }
             break L10;
             }
             }
             {
             if(
             s.head.size() > 0
             ){
             if(
             s.primitiveHead(0).type == PrimitiveHead.CATCH
             ){
             rElement.x = s.view.x +hd;
             rElement.y = s.view.y;
             rElement.planSize();
             rElement.draw(g);
             break L10;
             }
             }
             }
             {
             if(
             s.head.size() > 0
             ){
             if(
             s.primitiveHead(0).type == PrimitiveHead.CASE
             ){
             rEntity.x = s.view.x +hd;
             rEntity.y = s.view.y;
             rEntity.planSize();
             rEntity.draw(g);
             break L10;
             }
             }
             }
             {
             if(
             s.head.size() > 0
             ){
             if(
             s.primitiveHead(0).type == PrimitiveHead.LOOP
             ){
             rAttlist.x = s.view.x +hd;
             rAttlist.y = s.view.y;
             rAttlist.planSize();
             rAttlist.draw(g);
             break L10;
             }
             }
             }
           }
         }
         }
       s.comment.draw(g);
       if(
       ((s instanceof Sketch)&&
       (s.comment.elements.size()>1))
       ){
       Row endc = new Row(Default.commentColor);
       endc.elements = s.comment.elements;
       endc.x = s.comment.x;
       endc.y = s.view.y + s.view.height - 1 - s.comment.height;
       endc.width = s.comment.width;
       endc.height = s.comment.height;
       endc.draw(g);
       }
       }
     int yy = s.comment.height + vd;
     int x1 = x + hd/2;
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead he = (PrimitiveHead)(e.nextElement());
       he.text.draw(g);
       g.setColor(color);
        switch(
         he.type
        )
        {
         case
          PrimitiveHead.LOOP:
         g.setFont(Default.font);
         g.drawString("*", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.SWITCH:
         g.setFont(Default.font);
         g.drawString("??", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CASE:
         case
          PrimitiveHead.DEFAULT:
         g.setFont(Default.font);
         g.drawString("?", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.TRY:
         g.setFont(Default.font);
         g.drawString("!!", x1, y+yy + he.text.height*3/4);
         break;
         case
          PrimitiveHead.CATCH:
         case
          PrimitiveHead.FINALLY:
         g.setFont(Default.font);
         g.drawString("!", x1, y+yy + he.text.height*3/4);
         break;
        }
       yy += he.text.height;
       }
      L11:
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Object o = e.nextElement();
         {
         if(
         (o instanceof Scheme)
         ){
         ((Scheme)o).view.draw(g);
         continue L11;
         }
         }
         {
         if(
          (o instanceof Arrow)
         ){
         Arrow ar = (Arrow)o;
         ar.text.draw(g);
         Scheme sc = ar.destination((Branch)s);
         int endx;
         int yy0 = ar.text.y + 
                        ((Row)(ar.text.rows.elementAt(0))).height/2;
          L12:
           {
             {
             if(
             (ar.type == Arrow.WEAK)
             ){
             endx = sc.view.x + hd/2;
             drawWeakArrow(g, ar.text.x, yy0, endx);
             break L12;
             }
             }
           endx = sc.view.x;
           drawStrongArrow(g, ar.text.x, yy0, endx);
           }
         continue L11;
         }
         }
       if(
       (o instanceof PrimitiveMember)
       ){
       PrimitiveMember ns = (PrimitiveMember)o;
        switch(
         ns.type
        )
        {
         case
          Primitive.CONDITION:
         g.setFont(Default.font);
         g.setColor(Default.conditionColor);
         g.drawString("?", x1, ns.text.y + ns.text.height*3/4);
         break;
        }
       ns.text.draw(g);
       }
       }
     }
    private void drawStrongArrow(Graphics g, 
    int startX, int Y, int endX)
     {
     g.setColor(Default.arrowColor);
     g.drawLine(startX, Y, endX, Y);
     g.drawLine(endX, Y, endX + 4, Y - 2);
     g.drawLine(endX, Y, endX + 4, Y + 2);
     }
    private void drawWeakArrow(Graphics g, 
    int startX, int Y, int endX)  
     {
     g.setColor(Default.arrowColor);
      for(
      int i = endX; i < startX; i += laius*2/3
      )
       {
       g.drawLine(i, Y, i + laius/3, Y);
       }
     g.drawLine(endX, Y, endX + 4, Y - 2);
     g.drawLine(endX, Y, endX + 4, Y + 2);
     }
    private void drawArrowsForIcon(Graphics g, Sketch s, 
    int X, int Y, int iconLevel)
     {
     int endX;
     int n = s.body.size();
      for(
      int i = 0; i < n; i++
      )
       {
       Branch br = s.branch(i);
       int m = br.body.size();
        L13:
        for(
        int j = 0; j < m; j++
        )
         {
         Object o = br.member(j);
           {
           if(
           o instanceof Sketch
           ){
           drawArrowsForIcon(g, (Sketch)o, X, Y, iconLevel);
           continue L13;
           }
           }
         if(
         o instanceof Arrow
         ){
         drawIconArrow(g, br, (Arrow)o, X, Y, iconLevel);
         }
         }
       }
     }
    private void drawIconArrow(Graphics g, 
    Branch br, Arrow ar, int X, int Y, int iconLevel)
     {
     int endX;
     Scheme sc = ar.destination(br);
       {
       if(
       sc.level() >= iconLevel
       ){
       return;
       }
       }
      L14:
       {
         {
         if(
         sc instanceof Sketch
         ){
         endX = sc.view.x;
         break L14;
         }
         }
       endX = sc.view.x + hd/2;
       }
      L15:
       {
         {
         if(
         ar.type == Arrow.WEAK
         ){
         drawWeakArrow(g, X, Y, endX);
         break L15;
         }
         }
       drawStrongArrow(g, X, Y, endX);
       }
     }
    public void pointLocation(Point p, Scheme s)
     {
       {
       if(
       (result != null)
       ){
       return;
       }
       }
       {
       if(
       (!s.view.contains(p))
       ){
       return;
       }
       }
       {
       if(
       (s.icon)
       ){
       result = new Cursor(s);
       return;
       }
       }
      L16:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme sk = (Scheme)o;
         pointLocation(p, sk);
           {
           if(
           (result != null)
           ){
           return;
           }
           }
         continue L16;
         }
         }
       result = new Cursor(s);
         {
         if(
         (pointLocation(p, ((PrimitiveMember)o).text))
         ){
         result.primitive = (PrimitiveMember)o;
         result.noInRow = 1;
         Row r = result.row;
         int shift = (((Symbol)r.elements.elementAt(0))).width();
          L17:
          for(
          i = 1; i < r.elements.size(); i++
          )
           {
             {
             if(
             ((r.x + shift) > p.x)
             ){
             break L17;
             }
             }
           result.noInRow++;
           r.getElement(i);
             {
             if(
             (r.sy != null)
             ){
             shift += r.sy.width();
             continue L17;
             }
             }
           ;
           }
         return;
         }
         }
       result = null;
       }
       {
       if(
       (getLineArea(s).contains(p))
       ){
       result = new Cursor(s);
       return;
       }
       }
     result = new Cursor(s);
       {
       if(
       (pointLocation(p, s.comment))
       ){
       result.primitive = null;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0))).width();
        L18:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L18;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L18;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     result = new Cursor(s);
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead h = (PrimitiveHead)(e.nextElement());
       if(
       (pointLocation(p, h.text))
       ){
       result.primitive = h;
       result.noInRow = 1;
       Row r = result.row;
       int shift = (((Symbol)r.elements.elementAt(0))).width();
        L19:
        for(
        int i = 1; i < r.elements.size(); i++
        )
         {
           {
           if(
           ((r.x + shift) > p.x)
           ){
           break L19;
           }
           }
         result.noInRow++;
         r.getElement(i);
           {
           if(
           (r.sy != null)
           ){
           shift += r.sy.width();
           continue L19;
           }
           }
         ;
         }
       return;
       }
       }
     result = null;
     }
   }
