 import java.io.*;
 import org.jdom.*;
 import org.jdom.input.*;
 import org.jdom.output.*;
 import java.util.*;
 import org.xml.sax.*;
 import org.xml.sax.helpers.*;
  class Xml2Sketch
   {
   static final String TITLE = "<HTML><BODY>AMADEUS html plain";
   static final String DTDkohamrk = "thokDTDkoht";
   static PrintWriter outf;
   static String inName = "";
   static String outName = "";
    public static void main(String[] arg)
    throws FileNotFoundException,UnsupportedEncodingException, 
    IOException, JDOMException
     {
       {
       if(
       arg.length != 2
       ){
       System.out.println("PRE-SKETCHIFIER FOR XML.");
       System.out.println("Usage:");
       System.out.println("java XMLSketchifier  file1  file2 ");
       System.out.println("        file1: source xml");
       System.out.println("        file2: result xml; sketchified source, ");
       System.out.println("                                   ready for AMADEUS import");
       return;
       }
       }
     inName  = arg[0];
     outName = arg[1];
       {
       if(
       inName.compareTo(outName) == 0
       ){
       System.out.println("The names for file1 and  fail2 must differ!");
       return;
       }
       }
     xml2sketch();
     }
    public static String xml2sketch()
     {
     String viga = "";
     System.out.println("Xml2Sketch:xmlSketchifier started");
     System.out.println("Xml2Sketch: sketchifying: " + inName + " ==> " + 
     outName);
      L1:
      {try
       {
        {try
         {
         outf = new PrintWriter(new FileWriter(outName));
         }
         catch
         (IOException e)
         {
         return(
         "Caught IOException: " + e.getMessage()
         );
         }
        }
       writeHeader(TITLE);
       vlja(skeemiAlgus("0", "", "0", "0"));
       vlja(skeemiAlgus("0", "", "0", "0"));
       vlja("<UL>");  
       File file = new File(inName);
       SAXBuilder builder = new SAXBuilder();
       Document xmlDoc = builder.build(file);
       List content = xmlDoc.getMixedContent();
       Element root = null; 
        for(
         Iterator i = content.iterator(); i.hasNext(); 
        )
         {
         Object obj = i.next();
          L0:
           {
             {
             if(
              (obj instanceof Element)
             ){
             root = (Element)obj;
             System.out.println("Xml2Sketch:xmlSketchifier root found");
             vlja(primitiiv("0", DTDkohamrk));
             break L0;
             }
             }
             {
             if(
              (obj instanceof Comment)
             ){
             vljaKommentaar((Comment)obj);
             break L0;
             }
             }
             {
             if(
              (obj instanceof ProcessingInstruction)
             ){
             vljaTtlusksk((ProcessingInstruction)obj);
             break L0;
             }
             }
           //throw new IllegalAddException(
           //"A Document may contain only objects of type Element, " +
           //"Comment, and ProcessingInstruction");
           }
         }
         {
         if(
         root == null
         ){
         System.out.println("Xml2Sketch:xmlSketchifier failed");
         viga = "Root element not found";
         break L1;
         }
         }
       tdeldaElement(root);
       vlja(haruJaSkeemiLpp());
       writeFooter();
       outf.flush();
       outf.close();
       }
       catch
       (JDOMException e)
       {
       viga = e.getMessage();
       }
      }
      L3:
       {
         {
         if(
         viga.length() != 0
         ){
         System.out.println("Xml2Sketch:xmlSketchifier failed");
         vlja(primitiiv("0", DTDkohamrk));
         StringTokenizer st = new StringTokenizer(viga, " ", true);
         String osa = "";
          for(
          ; st.hasMoreTokens() ;
          )
           {
           String osake = st.nextToken();
            L2:
             {
               {
               if(
               osake.startsWith("file:")
               ){
               osa = osa + "source file:";
               break L2;
               }
               }
             osa = osa + osake;
             }
             {
             if(
             osa.length() > 30
             ){
             vlja(primitiiv("1", osa));
             osa = "";
             }
             }
           }
           {
           if(
           osa.length() > 0
           ){
           vlja(primitiiv("1", osa));
           }
           }
         break L3;
         }
         }
       System.out.println("Xml2Sketch:xmlSketchifier completed.");
       }
     vlja(haruJaSkeemiLpp());
     writeFooter();
     outf.flush();
     outf.close();
     return(
     viga
     );
     }
    static void tdeldaElement(Element elem)
     {
     vlja(skeemiAlgus("0", elem.getName(), "0", "1"));
     vlja(atribuudid(elem));
     vlja(skeemiAlgus("0", "", "0", "0"));
     vlja("<UL>");  
     List mixedContent = elem.getMixedContent();
     Iterator i = mixedContent.iterator();
     String t;
      L4:
      for(
       ;i.hasNext();
      )
       {
       Object o = i.next();
         {
         if(
         o instanceof Comment
         ){
         vljaKommentaar((Comment)o);
         continue L4;
         }
         }
         {
         if(
          o instanceof String
         ){
         t = trimm((String)o);
         t = ridadeks(t);
         vlja(primitiiv("0", t));
         continue L4;
         }
         }
         {
         if(
          o instanceof Entity
         ){
         t = ((Entity)o).getSerializedForm().trim();
         t = ridadeks(t);
         vlja(primitiiv("0", t));
         continue L4;
         }
         }
         {
         if(
          o instanceof CDATA
         ){
         t = ((CDATA)o).getSerializedForm().trim();
         t = ridadeks(t);
         vlja(primitiiv("0", t));
         continue L4;
         }
         }
         {
         if(
          o instanceof Element
         ){
         tdeldaElement((Element)o);
         continue L4;
         }
         }
       if(
       o instanceof ProcessingInstruction
       ){
       vljaTtlusksk((ProcessingInstruction)o);
       }
       }
     vlja(haruJaSkeemiLpp());
     }
    static void vljaKommentaar(Comment comm)
     {
     vlja(skeemiAlgus("1", "", "2", "1"));
     vlja(skeemiAlgus("0", "", "0", "0"));
     vlja("<UL>");  
     String t = comm.getText().trim();
     t = ridadeks(t);
     vlja(primitiiv("0", t));
     vlja(haruJaSkeemiLpp());
     }
    static void vljaTtlusksk(ProcessingInstruction pi)
     {
     String t = pi.getTarget().trim() + " " + pi.getData().trim();
     t = ridadeks(t);
     vlja(primitiiv("1", t));
     }
    static String atribuudid(Element elem)
     {
     String tulem = "";
     List atrib = elem.getAttributes();
     Iterator i = atrib.iterator();
      L5:
      for(
       ;i.hasNext();
      )
       {
       Object o = i.next();
       String t = ((Attribute)o).getSerializedForm().trim();
       t = ridadeks(t);
         {
         if(
         t.length() == 0
         ){
         continue L5;
         }
         }
       vlja("<!0>");
       vlja("&nbsp;&nbsp;&nbsp;<!X>" + t);
       vlja("<i></i>");
       }
     return(
     tulem
     );
     }
    static void vlja(String s)
     {
     if(
     s.length() > 0
     ){
     outf.println(s);
     }
     }
    static void writeHeader(String title) 
     {
     vlja("<!--- This file is generated by Xml2Sketch. --->");
     vlja(TITLE);
     }
    static void writeFooter() 
     {
     vlja("</BODY>");
     vlja("</HTML>");
     }
    static String ridadeks(String t) 
     {
     String tulem = "";
      for(
      int i = 0; i < t.length(); i++
      )
       {
       String s = "" + t.charAt(i);
         {
         if(
         !s.equals("\t")
         ){
         tulem += s;
         }
         }
         {
         if(
         s.equals("\n")
         ){
         tulem += "<br>";
         }
         }
       }
     return(
     tulem
     );
     }
    public static String skeemiAlgus(String type, String comm, 
                                                     String view, String icon)
     {
     String tulem = "";
         tulem += "<!" + type + "4"+ view + icon + ">\n";
         tulem += "<HR size = "+type+">\n";
         tulem += "<I>" + comm + "</I>";
     return(
     tulem
     );
     }
    public static String haruJaSkeemiLpp()
     {
     String tulem = "";
     tulem += "</UL>\n";
     tulem += ("<!xxxx>\n");
     tulem += ("<HR size = "+"0"+">\n");
     tulem += ("<!xxxx>");
     return(
     tulem
     );
     }
    public static String primitiiv(String type, String t)
     {
     String tulem = "";
      L6:
       {
         {
         if(
         t.trim().length() == 0
         ){
         break L6;
         }
         }
       if(
       t.length() > 0
       ){
       tulem += "<!" + type + ">\n";
       tulem += "<!br><br>\n";
        L7:
         {
           {
           if(
           type.equals("0")
           ){
           tulem += ("&nbsp;&nbsp;&nbsp;<!X>" + t+"\n");
           break L7;
           }
           }
         if(
         type.equals("1")
         ){
         tulem += ("&nbsp;?&nbsp;<!X>" + t+"\n");
         }
         }
       tulem += ("<i></i>");
       }
       }
     return(
     tulem
     );
     }
    private static String trimmX(String s)
     {
     int n = s.length();
       {
       if(
       n == 0
       ){
       return(
       ""
       );
       }
       }
     int i = 0;
     int j = n-1;
     char c;
      L8:
      for(;;)
       {
       c = s.charAt(i);
         {
         if(
         c == ' '
         ){
         break L8;
         }
         }
         {
         if(
         !Character.isWhitespace(c)
         ){
         break L8;
         }
         }
       i++;
       if(
       i == n
       ){
       return(
       ""
       );
       }
       }
      L9:
      for(;;)
       {
       c = s.charAt(j);
         {
         if(
         c == ' '
         ){
         break L9;
         }
         }
         {
         if(
         !Character.isWhitespace(c)
         ){
         break L9;
         }
         }
       j--;
       }
     return(
     s.substring(i, j+1)
     );
     }
    private static String trimm(String s)
     {
     String tulem = "";
     boolean onTaandes = false;
      L10:
      for(
      int i = 0; i < s.length(); i++
      )
       {
       String t = "" + s.charAt(i);
         {
         if(
         t.equals(" ") && onTaandes
         ){
         continue L10;
         }
         }
         {
         if(
         t.equals("\n")
         ){
         onTaandes = true;
         tulem += t;
         continue L10;
         }
         }
       onTaandes = false;
       tulem += t;
       }
     int i = tulem.lastIndexOf("\n");
       {
       if(
       i == tulem.length()-1
       ){
       tulem = tulem.substring(0, i);
       }
       }
     i = tulem.indexOf("\n");
       {
       if(
       i >= 0
       ){
       String p = tulem.substring(0, i).trim();
       if(
       p.length() == 0
       ){
       return(
       tulem.substring(i+1)
       );
       }
       }
       }
     return(
     tulem
     );
     }
   }
